@echo off

setlocal ENABLEDELAYEDEXPANSION
set basedir=%cd%

set user=tipadmin
set passwd=tippass
if not "%1" == "" (
	set user=%1
)
if not "%2" == "" (
	set passwd=%2
)
set base=7.3.0
set fixpack=4

echo Searching for installed components...

pushd "%SI_PATH%\bin" 2>nul
if ERRORLEVEL 1 (
	pushd "%USERPROFILE%\acsi_%USERNAME%" 2>nul
	if ERRORLEVEL 1 (
		pushd "%PROGRAMFILES(x86)%\IBM\Common\acsi\bin" 2>nul
		if ERRORLEVEL 1 (
			pushd "%PROGRAMFILES%\IBM\Common\acsi\bin"
			if ERRORLEVEL 1 (
				echo Unable to find DE
				exit /b 1
			)
		)
	)
)
call ..\setenv.cmd
set patched=0
for /f "delims=, tokens=2,4,5,6" %%i in ('de_lsrootiu.cmd ^| find "IU,TIPCore"') do (
    set tipver=%%j
    if "!ver:~0,5!" == "2.2.0" (
    	if "!ver:~6,2!" lss "5" (
			echo "TUAM is not supported on TIP %tipver% - please apply TIP 2.2 fix pack 5"
			echo "before applying this TUAM fix pack."
			exit /b 1
    	)
    )
    set TIP_HOME=%%k
    !TIP_HOME!\profiles\TIPProfile\bin\serverStatus.bat server1 -username %user% -password %passwd% | find "ADMU0508I" >NUL:
	if not !ERRORLEVEL! == 0 (
		echo Unable to check TIP server status - please ensure server is running
		echo and check %user% password is correct.
		echo
		echo usage: applyFixpack.bat tipadmin password
		exit /b 1
	)
    
)
for /f "delims=, tokens=2,4,5,6" %%i in ('de_lsrootiu.cmd ^| find "IU,TUAM_" ^| sort') do (
    set ver=%%j
	if "!ver:~0,5!" == "%base%" (
	  if "!ver:~6,2!" lss "%fixpack%" (
		if exist "%basedir%\%%i\META-INF\." (
			echo Applying patch for %%i
			pushd "%basedir%\%%i\META-INF"
			if "%%i" == "TUAM_UI" (
				call "%%k\bin\setupEnv"
			    set uid=%%l
				echo Variable#RootIUTypeID[!uid:~0,32!,%base%.%fixpack%]#IAGLOBAL_TIP_HOME=!TIP_HOME:\=\\!> var.properties
				echo Variable#RootIUTypeID[!uid:~0,32!,%base%.%fixpack%]#shExt=bat>> var.properties
				echo Variable#RootIUTypeID[!uid:~0,32!,%base%.%fixpack%]#IAGLOBAL_WASUserID=%user%>> var.properties
				echo Variable#RootIUTypeID[!uid:~0,32!,%base%.%fixpack%]#IALOCAL_WASPassword=%passwd%>> var.properties
				call manageIU.bat -o update -u true  -i var.properties -r "!TUAM_HOME!" -p packagedIU.xml 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				set status=!ERRORLEVEL!
				del /q var.properties
				mkdir "!TUAM_HOME!\_uninst\fixes\fp%fixpack%" 2>nul
				if "%tipver%" == "2.2.0.5" (
					copy "!TIP_HOME!\profiles\TIPProfile\installedApps\TIPCell\isc.ear\isclite.war\secure\isclite\scripts\SMUtils.js" "!TUAM_HOME!\_uninst\fixes\fp%fixpack%"
					copy ..\FILES\SMUtils_2.2.0.5.js "!TIP_HOME!\profiles\TIPProfile\installedApps\TIPCell\isc.ear\isclite.war\secure\isclite\scripts\SMUtils.js" >nul
				)
				if !status! == 0 (
					call "!TIP_HOME!\profiles\TIPProfile\bin\tipRegister" -getVersion 081F67AF608643DE937B00F6A41D9083 > "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\tipregistry.txt"
					if not !ERRORLEVEL! == 0 (
						del /q "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\tipregistry.txt"
					)
					call "!TIP_HOME!\profiles\TIPProfile\bin\tipRegister" 081F67AF608643DE937B00F6A41D9083 TUAM !TUAM_HOME! %base%.%fixpack% product none false 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					set status=!ERRORLEVEL!
				)
			) else (
				set TUAM_HOME=%%k
				call manageIU.bat -o update -r "!TUAM_HOME!" -p packagedIU.xml -u true 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				set status=!ERRORLEVEL!
			)
			if not !status! == 0 (
				echo Patch failed
				exit /b 1
			)
			mkdir "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i" 2>nul
			copy * "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i" >nul
			popd
			set /a patched+=1
		)
	  )
	)
)

popd
if %patched% == 0 (
   set /a fixpack-=1
   echo TUAM Release %base%.0 to %base%.%fixpack% must be installed to install this fix pack.
   echo Please install this version before attempting to install this fix pack.
   echo Fix has not been applied successfully.
   exit /b 1
)

endlocal

