@echo off
rem *************************************************************** {COPYRIGHT-TOP}
rem * Licensed Materials - Property of IBM
rem * Restricted Materials of IBM
rem * IBM Tivoli Usage and Accounting Manager
rem * 5724-O33, 5765-UAV, 5765-UA7, 44E7863
rem * (c) Copyright IBM Corp. 2004, 2007 All Rights Reserved.
rem *
rem * US Government Users Restricted Rights - Use, duplication or
rem * disclosure restricted by GSA ADP Schedule Contract with
rem * IBM Corp.
rem **************************************************************** {COPYRIGHT-END}
rem
rem ***************************************************************************
rem * Batch script to start JobRunner.
rem *
rem ***************************************************************************

setlocal ENABLEDELAYEDEXPANSION

call "%~dp0setupEnv.bat"

set TUAM_INSTALLPATH=%TUAM_HOME%

rem ***** Passed in parameter ******
set JOB_FILE=%1

rem ***** TUAM Libraries **********
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucCommon.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucIntegrator.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucProcessEngine.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucJobFileConversion.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucAspects.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucDataAccess.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucJobRunner.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucVerification.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucRpd.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucItmCollector.jar

rem ***** Collector Libraries ********
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucBCP.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucECP.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucNFC.jar

rem ***** Message packages **********
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_ar.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_de.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_fr.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_it.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_es.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_ja.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_ko.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_pt_BR.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_zh_CN.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aucMessages_zh_TW.jar

rem ***** External Libraries **********
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\auii18n.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\auibase.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\commons-net-1.4.1.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\icl.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\icu4j.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\jlanclient.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\mtftp.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\Notes.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\remoteaccess.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\ssh.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\jlog.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\axis.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\axis-ant.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\vim.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\vim25.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\engine.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\aspectjrt.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\commons-logging-1.0.4.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\commons-discovery-0.2.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\wsdl4j-1.5.1.jar

rem ***** TIP Libraries **********
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\lib\bootstrap.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\lib\j2ee.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\lib\mail-impl.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\plugins\com.ibm.ws.runtime.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\plugins\com.ibm.ws.security.crypto.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\plugins\com.ibm.ws.emf.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\plugins\org.eclipse.emf.common.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\plugins\org.eclipse.emf.ecore.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\universalDriver\lib\db2jcc_license_cu.jar
set JR_CLASSPATH=%JR_CLASSPATH%;%TIP_HOME%\plugins\com.ibm.wsfp.main.jar

for %%A in (dir %TUAM_LIB%\auc*Collector.jar) do set JR_CLASSPATH=!JR_CLASSPATH!;%TUAM_LIB%\%A

rem ***** customer provided jar files *******
rem if unsupported version of db driver is specified on the system classpath
rem then the supported version should be added here e.g.
rem set JR_CLASSPATH=%JR_CLASSPATH%;%TUAM_LIB%\db2jcc.jar
rem Alternatively this line can be removed to ignore the system classpath
set JR_CLASSPATH=%JR_CLASSPATH%;.;%CLASSPATH%

set JAVA_OPTS=-Xms50M -Xmx512M

"%JAVA_HOME%\jre\bin\java" %JAVA_OPTS% -cp "%JR_CLASSPATH%" com.ibm.tivoli.tuam.jobrunner.JobRunner %*


endlocal
