#!/bin/sh
#   *************************************************************** {COPYRIGHT-TOP}
#   * Licensed Materials - Property of IBM
#   * Restricted Materials of IBM
#   * IBM Tivoli Usage and Accounting Manager
#   * 5724-O33, 5765-UAV, 5765-UA7, 44E7863
#   * (c) Copyright IBM Corp. 2004, 2007 All Rights Reserved.
#   *
#   * US Government Users Restricted Rights - Use, duplication or
#   * disclosure restricted by GSA ADP Schedule Contract with
#   * IBM Corp.
#   **************************************************************** {COPYRIGHT-END}
#
#   ***************************************************************************
#   * This is a wrapper script around the eWAS startServer.sh, which ensures
#   * that the eWAS script runs as the user specified during TUAM install.
#   ***************************************************************************

binDir=`dirname $0`
. $binDir/setupEnv.sh

de=""
for dir in $SI_PATH/bin $HOME/.acsi_$USER/bin /usr/ibm/common/acsi/bin
do
	if [ -x $dir/de_lsrootiu.sh ]; then
		de=$dir
		break
	fi
done
if [ ! -z "$de" ]; then
	TCR_HOME=`${de}/de_lsrootiu.sh | grep "IU,TCRCore" | awk -F, '{print $5}'`
fi

if [ -z "${TCR_HOME}" ] || [ ! -x "${TCR_HOME}/bin/startTCRserver.sh" ]; then
	${TIP_HOME}/profiles/TIPProfile/bin/startServer.sh server1 $@
else
	${TCR_HOME}/bin/startTCRserver.sh $@
fi
