@echo off

rem *************************************************************** {COPYRIGHT-TOP}
rem * Licensed Materials - Property of IBM
rem * Restricted Materials of IBM
rem * IBM Tivoli Usage and Accounting Manager
rem * 5724-O33, 5765-UAV, 5765-UA7, 44E7863
rem * (c) Copyright IBM Corp. 2012 All Rights Reserved.
rem *
rem * US Government Users Restricted Rights - Use, duplication or
rem * disclosure restricted by GSA ADP Schedule Contract with
rem * IBM Corp.
rem **************************************************************** {COPYRIGHT-END}
rem 
rem ***************************************************************************
rem * This is a wrapper script around the TIP stopServer.bat, which ensures
rem * that the correct TIP/TCR version is called.
rem ***************************************************************************

call "%~dp0\..\bin\setupEnv"
set status=0
setlocal ENABLEDELAYEDEXPANSION

pushd "%SI_PATH%\bin" 2>nul
if ERRORLEVEL 1 (
	pushd "%USERPROFILE%\acsi_%USERNAME%" 2>nul
	if ERRORLEVEL 1 (
		pushd "%PROGRAMFILES(x86)%\IBM\Common\acsi\bin" 2>nul
		if ERRORLEVEL 1 (
			pushd "%PROGRAMFILES%\IBM\Common\acsi\bin"
			if ERRORLEVEL 1 (
				%TIP_HOME%\profiles\TIPProfile\bin\stopServer server1 %*
				set status=%ERRORLEVEL%
				goto done
			)
		)
	)
)
call ..\setenv.cmd

for /f "delims=, tokens=2,4,5,6" %%i in ('de_lsrootiu.cmd ^| find "IU,TCRCore"') do (
    set TCR_HOME=%%k
	if exist !TCR_HOME!\bin\stopTCRserver.* (
		!TCR_HOME!\bin\stopTCRserver %*
		set status=!ERRORLEVEL!
		goto done
	)
)

%TIP_HOME%\profiles\TIPProfile\bin\stopServer server1 %*

:done
popd
endlocal
exit /b %status%
