#!/bin/sh
#   *************************************************************** {COPYRIGHT-TOP}
#   * Licensed Materials - Property of IBM
#   * Restricted Materials of IBM
#   * IBM Tivoli Usage and Accounting Manager
#   * 5724-O33, 5765-UAV, 5765-UA7, 44E7863
#   * (c) Copyright IBM Corp. 2004, 2007 All Rights Reserved.
#   *
#   * US Government Users Restricted Rights - Use, duplication or
#   * disclosure restricted by GSA ADP Schedule Contract with
#   * IBM Corp.
#   **************************************************************** {COPYRIGHT-END}

binDir=`dirname $0`
. $binDir/setupEnv.sh

TUAM_INSTALLPATH=$TUAM_HOME


# ***** TUAM Libraries **********
JR_CLASSPATH=.:$CLASSPATH
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucCommon.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucIntegrator.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucProcessEngine.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucDataAccess.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucJobRunner.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucVerification.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucRpd.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucExternalBridge.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucProductInfo.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucAspects.jar

# ***** Collector Libraries ********
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucBCP.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucECP.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucNFC.jar

# ***** Messages packages **********
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_ar.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_de.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_fr.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_it.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_es.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_ja.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_ko.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_pt_BR.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_zh_CN.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aucMessages_zh_TW.jar


# ***** External Libraries **********
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/auii18n.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/auibase.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/commons-net-1.4.1.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/icl.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/icu4j.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/jlanclient.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/mtftp.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/Notes.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/remoteaccess.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/ssh.jar
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/aspectjrt.jar

# ***** TIP Libraries **********
JR_CLASSPATH=$JR_CLASSPATH:$TIP_HOME/lib/j2ee.jar
JR_CLASSPATH=$JR_CLASSPATH:$TIP_HOME/lib/mail-impl.jar
JR_CLASSPATH=$JR_CLASSPATH:$TIP_HOME/plugins/com.ibm.ws.runtime.jar
JR_CLASSPATH=$JR_CLASSPATH:$TIP_HOME/universalDriver/lib/db2jcc_license_cu.jar

# ***** Dynamic Collectors ******
for jar in $TUAM_LIB/auc*Collector.jar
do
	JR_CLASSPATH=$JR_CLASSPATH:$jar
done

# ***** customer Libraries **********
JR_CLASSPATH=$JR_CLASSPATH:$TUAM_LIB/db2jcc.jar


exec $JAVA_HOME/jre/bin/java -cp $JR_CLASSPATH com.ibm.tivoli.tuam.productinfo.TUAMProductInfo $*
