/***************************************************************
 * Licensed Materials - Property of IBM
 * IBM Tivoli Usage and Accounting Manager
 * 5724-O33, 5765-UAV, 5765-UA7, 44E7863
 *  Copyright IBM Corp. 2005, 2007
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 ****************************************************************
 */
 
/********************************************************
**   CimsMouseEvent
********************************************************/
function CimsMouseEvent(sType, oEvent)
{
    if (_inPrototype)return;
    CimsEvent.call(this, sType);
    this._event = oEvent;
}
_p = _mExtend(CimsMouseEvent, CimsEvent, "CimsMouseEvent");
_p._bubbles = true;
_p._propagationStopped = false;
if (CimsBrowserCheck.ie)
{
    CimsMouseEvent.LEFT = 1;
    CimsMouseEvent.RIGHT = 2;
    CimsMouseEvent.MIDDLE = 4;
}
else 
{
    CimsMouseEvent.LEFT = 0;
    CimsMouseEvent.MIDDLE = 1;
    CimsMouseEvent.RIGHT = 2;
}
_p.getClientX = function ()
{
    return this._event.clientX;
};

_p.getClientY = function ()
{
    return this._event.clientY;
};

_p.getScreenX = function ()
{
    return this._event.screenX;
};

_p.getScreenY = function ()
{
    return this._event.screenY;
};

_p.getOffsetX = function ()
{
    return this.getScreenX() - this.getTarget()._getScreenClientArea().left;
};

_p.getOffsetY = function ()
{
    return this.getScreenY() - this.getTarget()._getScreenClientArea().top;
};

_p.getCtrlKey = function ()
{
    return this._event.ctrlKey;
};

_p.getShiftKey = function ()
{
    return this._event.shiftKey;
};

_p.getAltKey = function ()
{
    return this._event.altKey;
};

_p.getRelatedTarget = function ()
{
    var relEl;
    if (CimsBrowserCheck.ie)
    {
        if (this._type == "mouseover")relEl = this._event.fromElement;
        else if (this._type == "mouseout")relEl = this._event.toElement;
    }
    else relEl = this._event.relatedTarget;
    try
    {
        while (relEl != null && relEl._biComponent == null)
			relEl = relEl.parentNode;
    }
    catch (ex)
    {
        return null;
    }
    if (relEl == null)return null;
    return relEl._biComponent;
};

_p.getButton = function ()
{
    if (CimsBrowserCheck.ie && this._event.type == "click")return 1;
    else return this._event.button;
};

_p.getWheelDelta = function ()
{
    if (CimsBrowserCheck.ie)
		return this._event.wheelDelta ? this._event.wheelDelta / 40 : 0;
    else 
    {
        var v = this._event.detail || 0;
        if (v > 1000)v = 3;
        else if (v <  - 1000)v =  - 3;
        return - v;
    }
};

_p.getTarget = function ()
{
    var el = this._event.target || this._event.srcElement;
    while (el != null && el._biComponent == null)
		el = el.parentNode;
    return el == null ? this._target : el._biComponent || this._target;
};

_p.preventDefault = function ()
{
    this._defaultPrevented = true;
    if (CimsBrowserCheck.moz)this._event.preventDefault();
    this._event.returnValue = false;
};

_p.dispose = function ()
{
    CimsEvent.prototype.dispose.call(this);
    this._event = null;
};

CimsMouseEvent._storeEventState = function (biEvent)
{
    CimsMouseEvent._screenX = biEvent.getScreenX();
    CimsMouseEvent._screenY = biEvent.getScreenY();
    CimsMouseEvent._clientX = biEvent.getClientX();
    CimsMouseEvent._clientY = biEvent.getClientY();
    CimsMouseEvent._button = biEvent.getButton();
};

CimsMouseEvent.getScreenX = function ()
{
    return CimsMouseEvent._screenX;
};

CimsMouseEvent.getScreenY = function ()
{
    return CimsMouseEvent._screenY;
};

CimsMouseEvent.getClientX = function ()
{
    return CimsMouseEvent._clientX;
};

CimsMouseEvent.getClientY = function ()
{
    return CimsMouseEvent._clientY;
};

CimsMouseEvent.getButton = function ()
{
    return CimsMouseEvent._button;
};

CimsMouseEvent._screenX = CimsMouseEvent._screenY = CimsMouseEvent._clientX = CimsMouseEvent._clientY = CimsMouseEvent._button = 0;
if (CimsBrowserCheck.moz)CimsMouseEvent._button =  - 1;

/********************************************************
**   CimsKeyboardEvent
********************************************************/
function CimsKeyboardEvent(sType, oEvent)
{
    if (_inPrototype)return;
    CimsEvent.call(this, sType);
    this._event = oEvent;
    this._keyCode = oEvent.keyCode || oEvent.charCode;
}
_p = _mExtend(CimsKeyboardEvent, CimsEvent, "CimsKeyboardEvent");
_p._bubbles = true;
_p._propagationStopped = false;
_p.getCtrlKey = function ()
{
    return this._event.ctrlKey;
};

_p.getShiftKey = function ()
{
    return this._event.shiftKey;
};

_p.getAltKey = function ()
{
    return this._event.altKey;
};

_p.getKeyCode = function ()
{
    return this._keyCode;
};

_p.preventDefault = function ()
{
    this._defaultPrevented = true;
    if (CimsBrowserCheck.moz)this._event.preventDefault();
    this._event.returnValue = false;
    if (CimsBrowserCheck.ie)
    {
        try
        {
            this._event.keyCode = 0;
        }
        catch (ex)
        {
        }
    }
};

_p.dispose = function ()
{
    CimsEvent.prototype.dispose.call(this);
    this._event = null;
};

CimsKeyboardEvent.ENTER = 13;
CimsKeyboardEvent.TAB = 9;
CimsKeyboardEvent.UP = 38;
CimsKeyboardEvent.DOWN = 40;
CimsKeyboardEvent.LEFT = 37;
CimsKeyboardEvent.RIGHT = 39;
CimsKeyboardEvent.SPACE = 32;
CimsKeyboardEvent.SHIFT = 16;
CimsKeyboardEvent.CTRL = 17;
CimsKeyboardEvent.CONTROL = 17;
CimsKeyboardEvent.ALT = 18;
CimsKeyboardEvent.ESC = 27;
CimsKeyboardEvent.F1 = 112;
CimsKeyboardEvent.F2 = 113;
CimsKeyboardEvent.F3 = 114;
CimsKeyboardEvent.F4 = 115;
CimsKeyboardEvent.F5 = 116;
CimsKeyboardEvent.F6 = 117;
CimsKeyboardEvent.F7 = 118;
CimsKeyboardEvent.F8 = 119;
CimsKeyboardEvent.F9 = 120;
CimsKeyboardEvent.F10 = 121;
CimsKeyboardEvent.F11 = 122;
CimsKeyboardEvent.F12 = 123;
CimsKeyboardEvent.DEL = 46;
CimsKeyboardEvent.DELETE = 46;
CimsKeyboardEvent.BACKSPACE = 8;
CimsKeyboardEvent.INSERT = 45;
CimsKeyboardEvent.HOME = 36;
CimsKeyboardEvent.END = 35;
CimsKeyboardEvent.PAGE_UP = 33;
CimsKeyboardEvent.PAGE_DOWN = 34;
CimsKeyboardEvent.NUM_LOCK = 144;
CimsKeyboardEvent.NUMPAD0 = 96;
CimsKeyboardEvent.NUMPAD1 = 97;
CimsKeyboardEvent.NUMPAD2 = 98;
CimsKeyboardEvent.NUMPAD3 = 99;
CimsKeyboardEvent.NUMPAD4 = 100;
CimsKeyboardEvent.NUMPAD5 = 101;
CimsKeyboardEvent.NUMPAD6 = 102;
CimsKeyboardEvent.NUMPAD7 = 103;
CimsKeyboardEvent.NUMPAD8 = 104;
CimsKeyboardEvent.NUMPAD9 = 105;
CimsKeyboardEvent.NUMPAD_DIVIDE = 111;
CimsKeyboardEvent.NUMPAD_MULTIPLY = 106;
CimsKeyboardEvent.NUMPAD_MINUS = 109;
CimsKeyboardEvent.NUMPAD_PLUS = 107;

/********************************************************
**   CimsFocusEvent
********************************************************/
function CimsFocusEvent(sType)
{
    if (_inPrototype)return;
    CimsEvent.call(this, sType);
    if (sType == "focusin" || sType == "focusout")
    {
        this._bubbles = true;
        this._propagationStopped = false;
    }
}
_p = _mExtend(CimsFocusEvent, CimsEvent, "CimsFocusEvent");
CimsFocusEvent._lastFocused = null;
CimsFocusEvent.prototype.getRelatedTarget = function ()
{
    return this._relatedTarget;
};


/********************************************************
**   CimsEventManager
********************************************************/
function CimsEventManager()
{
    if (_inPrototype)return;
    CimsObject.call(this);
    var oThis = this;
    this.__onmouseevent = function (e)
    {
        return oThis._onmouseevent(e);
    }
    ;
    this.__onkeyevent = function (e)
    {
        return oThis._onkeyevent(e);
    }
    ;
    this.__onselectevent = function (e)
    {
        return oThis._onselectevent(e);
    }
    ;
    this.__onwindowblur = function (e)
    {
        return oThis._onwindowblur(e);
    }
    ;
    this.__ondragevent = function (e)
    {
        return oThis._ondragevent(e);
    }
    ;
    if (CimsBrowserCheck.ie)
    {
        this.__onactivateevent = function (e)
        {
            return oThis._onactivateevent(e);
        }
        ;
        this.__onbeforeactivateevent = function (e)
        {
            return oThis._onbeforeactivateevent(e);
        }
        ;
    }
    this.__onresizeevent = function (e)
    {
        return oThis._onresizeevent(e);
    }
    ;
    this._mozActiveElement = null;
}
_p = _mExtend(CimsEventManager, CimsObject, "CimsEventManager");
_p._lastFocused = null;
_p._lastMouseEventType = null;
_p._lastMouseDown = false;
_p._lastMouseEventDate = 0;
_p._allowBrowserContextMenu = false;
CimsEventManager.prototype.getAllowBrowserContextMenu = function ()
{
    return this._allowBrowserContextMenu;
};

CimsEventManager.prototype.setAllowBrowserContextMenu = function (v)
{
    this._allowBrowserContextMenu = v;
};

_p.attachToWindow = function (oWindow)
{
    this._window = oWindow;
    this.attachMouseEvents();
    this.attachKeyboardEvents();
    var doc = oWindow.document;
    doc.body.onselect = doc.onselectstart = doc.onselectionchange = this.__onselectevent;
    doc.ondragstart = this.__ondragevent;
    oWindow.onblur = this.__onwindowblur;
    if (CimsBrowserCheck.moz)
    {
        oWindow.addEventListener("resize", this.__onresizeevent, false);
    }
    else 
    {
        doc.body.onactivate = this.__onactivateevent;
        doc.body.onbeforeactivate = this.__onbeforeactivateevent;
        oWindow.attachEvent("onresize", this.__onresizeevent);
    }
};

CimsEventManager._mouseEventTypes = ["mouseover", "mousemove", "mouseout", "mousedown", "mouseup", "click", "dblclick", "contextmenu", (CimsBrowserCheck.ie ? "mousewheel" : "DOMMouseScroll")];
_p.attachMouseEvents = function ()
{
    var doc = this._window.document;
    var types = CimsEventManager._mouseEventTypes;
    if (CimsBrowserCheck.ie)
    {
        for (var i = 0; i < types.length; i++)
			doc.attachEvent("on" + types[i], this.__onmouseevent); 
	}
    else 
    {
        for (i = 0; i < types.length; i++)
			doc.addEventListener(types[i], this.__onmouseevent, false); 
	}
};


_p.detachMouseEvents=function()
{
	var doc=this._window.document;
	var types=CimsEventManager._mouseEventTypes;
	if(CimsBrowserCheck.ie)
	{
		for(var i=0;i<types.length;i++)
			doc.detachEvent("on"+types[i],this.__onmouseevent);
	}
	else 
	{
		if(doc)
		{
			for(var i=0;i<types.length;i++)
				doc.removeEventListener(types[i],this.__onmouseevent,false);
		}
	}
};

CimsEventManager._keyboardEventTypes=["keydown","keypress","keyup"];

_p.attachKeyboardEvents = function ()
{
    var doc = this._window.document;
    var types = CimsEventManager._keyboardEventTypes;
    if (CimsBrowserCheck.ie)
    {
        for (var i = 0; i < types.length; i++)doc.body.attachEvent("on" + types[i], this.__onkeyevent); }
    else 
    {
        for (i = 0; i < types.length; i++)doc.addEventListener(types[i], this.__onkeyevent, false); }
};

_p.detachKeyboardEvents = function ()
{
    var doc = this._window.document;
    var types = CimsEventManager._keyboardEventTypes;
    if (CimsBrowserCheck.ie)
    {
        for (var i = 0; i < types.length; i++)doc.body.detachEvent("on" + types[i], this.__onkeyevent); }
    else 
    {
        if (doc)
        {
            for (i = 0; i < types.length; i++)doc.removeEventListener(types[i], this.__onkeyevent, false); }
    }
};

_p._onmouseevent = function (e)
{
    if (!e)e = this._window.event;
    var type = e.type;
    if (CimsBrowserCheck.ie)
    {
        if (type == "mousedown")this._mouseIsDown = true;
        else if (type == "mouseup")this._mouseIsDown = false;
        else if (type == "mousemove" && this._mouseIsDown && e.button == 0)
        {
            this._onmouseevent2(e, "mouseup");
            this._mouseIsDown = false;
        }
        if (type == "mouseup" &&!this._lastMouseDown && new Date - this._lastMouseEventDate < 250)
        {
            this._onmouseevent2(e, "mousedown");
        }
        else if (type == "dblclick" && this._lastMouseEventType == "mouseup" && new Date - this._lastMouseEventDate < 250)
        {
            this._onmouseevent2(e, "click");
        }
        switch (type)
            {
            case "mousedown":
            case "mouseup":
            case "click":
            case "dblclick":
            case "contextmenu":
                this._lastMouseEventType = type;
                this._lastMouseEventDate = (new Date).valueOf();
                this._lastMouseDown = type == "mousedown";
        }
    }
    else 
    {
        switch (type)
            {
            case "DOMMouseScroll":
                type = "mousewheel";
                break;
            case "click":
            case "dblclick":
                if (e.button != CimsMouseEvent.LEFT)return;
            case "mousedown":
                if (e.target && e.target.localName == "IMG")e.preventDefault();
                break;
        }
    }
    this._onmouseevent2(e, type);
};

_p._onmouseevent2 = function (e, type)
{
    if (type == "contextmenu" &&!this._allowBrowserContextMenu)
    {
        if (CimsBrowserCheck.moz)e.preventDefault();
        e.returnValue = false;
    }
    else if (type == "mousedown" && CimsBrowserCheck.moz)this._onactivateevent(e);
    var target;
    if (this._captureComponent)
    {
        target = this._captureComponent;
    }
    else
    {
        var el = e.target || e.srcElement;
        while (el != null && el._biComponent == null)el = el.parentNode;
        if (el == null)return;
        target = el._biComponent;
    }
    if (target == null)return;
    var enabledAncestor = null;
    var c = target;
    while (c)
    {
        if (!c.getEnabled())enabledAncestor = null;
        else if (enabledAncestor == null)enabledAncestor = c;
        c = c._parent;
    }
    target = enabledAncestor;
    if (target == null)return;
    var biEvent = new CimsMouseEvent(type, e);
    CimsMouseEvent._storeEventState(biEvent);
    switch (type)
        {
        case "mousedown":
            (new CimsPopupManager).hideAutoHiding(target);
            var tmp = target;
            while (tmp != null &&!tmp.getCanFocus())tmp = tmp._parent;
            if (tmp != null && tmp.getCanFocus())
            {
                if (CimsBrowserCheck.ie)
                {
                    if (tmp._element.tagName != "IFRAME")tmp._element.setActive();
                }
                else 
                {
                }
            }
            break;
        case "mouseover":
            try
            {
                tmp = e.relatedTarget || e.fromElement;
                while (tmp != null && tmp._biComponent == null)tmp = tmp.parentNode;
                if (tmp && tmp._biComponent == target)
                {
                    biEvent.dispose();
                    return;
                }
            }
            catch (ex)
            {
                biEvent.dispose();
                return;
            }
            break;
        case "mouseout":
            try
            {
                tmp = e.relatedTarget || e.toElement;
                while (tmp != null && tmp._biComponent == null)tmp = tmp.parentNode;
                if (tmp && tmp._biComponent == target)
                {
                    biEvent.dispose();
                    return;
                }
            }
            catch (ex)
            {
                biEvent.dispose();
                return;
            }
            break;
    }
    var rv = target.dispatchEvent(biEvent);
    if (type == "mouseup")
    {
        application.getThemeManager()._handleMouseUp(biEvent);
    }
    switch (type)
        {
        case "mouseover":
            (new CimsToolTipManager).handleMouseOver(biEvent);
            break;
        case "mouseout":
            (new CimsToolTipManager).handleMouseOut(biEvent);
            break;
        case "contextmenu":
            if (!rv)break;
            var cm;
            while (target &&!(cm = target.getContextMenu()))target = target._parent;
            if (cm)
            {
                if (CimsBrowserCheck.moz)e.preventDefault();
                e.returnValue = false;
                cm._component = target;
                cm.setLocation(biEvent.getScreenX(), biEvent.getScreenY());
                cm._component = target;
                cm.setVisible(true);
            }
            break;
        case "mousewheel":
            if (!rv)
            {
                e.returnValue = false;
                if (CimsBrowserCheck.moz)e.preventDefault();
            }
            else 
            {
                if (CimsBrowserCheck.moz && target instanceof CimsComponent)
                {
                    this._onMozMouseWheel(target, biEvent);
                }
            }
            break;
    }
    (new CimsDragAndDropManager).handleMouseEvent(biEvent);
    biEvent.dispose();
    if (CimsBrowserCheck.moz && target &&!target.getCanSelect() &&!target.getCanFocus())e.preventDefault();
    application.flushLayoutQueue();
};


_p._onMozMouseWheel = function (c, e)
{
    if (c == null)return;
    if (c.getOverflowY() == "hidden")
    {
        this._onMozMouseWheel(c._parent, e);
        return;
    }
    var st = c.getScrollTop();
    var delta = 20 * e.getWheelDelta();
    if (st == 0 && delta > 0)
    {
        this._onMozMouseWheel(c._parent, e);
        return;
    }
    var sh = c.getScrollHeight();
    var ch = c.getClientHeight();
    if (st + ch >= sh && delta < 0)
    {
        this._onMozMouseWheel(c._parent, e);
        return;
    }
    c.setScrollTop(st - delta);
    e._event.preventDefault();
};


_p._onkeyevent = function (e)
{
    if (!e)e = this._window.event;
    var el = this._mozActiveElement || e.target || e.srcElement;
    while (el != null && el._biComponent == null)el = el.parentNode;
    if (el == null)return;
    var target = el._biComponent;
    while (target &&!target.getEnabled())target = target._parent;
    if (target == null)return;
    var biEvent = new CimsKeyboardEvent(e.type, e);
    target.dispatchEvent(biEvent);
    (new CimsDragAndDropManager).handleKeyboardEvent(biEvent);
    application.flushLayoutQueue();
};


_p._onactivateevent = function (e)
{
    if (!e)e = this._window.event;
    var el = e.target || e.srcElement;
    if (CimsBrowserCheck.moz)this._mozActiveElement = el;
    while (el != null && el._biComponent == null)el = el.parentNode;
    if (el == null)return;
    var target = el._biComponent;
    while (target != null &&!target.getCanFocus())target = target._parent;
    if (target == null)return;
    this._setFocusedComponent(target);
};


_p._onbeforeactivateevent=function()
{
	var e=this._window.event;
	var c,el,d,w,em;
	d=this._window.document;
	if(e.srcElement==d.body)
	{
		el=d.activeElement;
		do
		{
			if(el)
			{
				c=el._biComponent;
				el=el.parentNode;
			}
		}
		while(el&&!c);
		if (!c) return;
		if(c.getFocused())
		{
			e.returnValue=false;
		}
		else if( (em=(w=d.body._biComponent)._eventManager)._lastFocused && !d.body.contains(em._lastFocused._element) && c.getCanFocus() )
		{
			c.setFocused(true);
			w._activeComponent=c;
			e.returnValue=false;
		}
	}
};

_p._setFocusedComponent = function (oComponent)
{
    if (this._lastFocused == oComponent)return;
    var blurComp = this._lastFocused;
    var focusComp = oComponent;
    while (blurComp && blurComp._anonymous)blurComp = blurComp.getParent();
    while (focusComp && focusComp._anonymous)focusComp = focusComp.getParent();
    if (blurComp == focusComp)return;
    var fr;
    if (oComponent)
    {
        fr = oComponent.getFocusRoot();
        fr._activeComponent = oComponent;
    }
    else if (this._lastFocused)
    {
        fr = this._lastFocused.getFocusRoot();
        fr._activeComponent = null;
    }
    this._lastFocused = oComponent;
    (new CimsPopupManager).hideAutoHiding(focusComp);
    var e;
    if (blurComp)
    {
        blurComp._focused = false;
        e = new CimsFocusEvent("focusout");
        e._relatedTarget = focusComp;
        blurComp.dispatchEvent(e);
    }
    if (focusComp)
    {
        focusComp._focused = true;
        e = new CimsFocusEvent("focusin");
        e._relatedTarget = blurComp;
        focusComp.dispatchEvent(e);
    }
    if (blurComp)
    {
        e = new CimsFocusEvent("blur");
        e._relatedTarget = focusComp;
        blurComp.dispatchEvent(e);
        (new CimsToolTipManager).handleBlur(e);
    }
    if (focusComp)
    {
        e = new CimsFocusEvent("focus");
        e._relatedTarget = blurComp;
        focusComp.dispatchEvent(e);
        (new CimsToolTipManager).handleFocus(e);
    }
    if (CimsBrowserCheck.moz && blurComp)blurComp._blurComponent();
    application.flushLayoutQueue();
};

_p._onwindowblur = function (e)
{
    if (!CimsBrowserCheck.moz)(new CimsPopupManager).hideAutoHiding();
};

_p._onresizeevent = function (e)
{
    var c = this._window.document.body._biComponent;
    if (c && typeof c._onresize == "function")c._onresize();
    application.flushLayoutQueue();
};

_p._onselectevent = function (e)
{
    if (!e)e = this._window.event;
    var el = e.target || e.srcElement;
    while (el != null && el._biComponent == null)el = el.parentNode;
    if (el == null)return;
    var target = el._biComponent;
    if (!target.getCanSelect())
    {
        if (CimsBrowserCheck.moz)e.preventDefault();
        e.returnValue = false;
    }
};

_p._ondragevent = function (e)
{
    if (!e)e = this._window.event;
    if ((e.target || e.srcElement).tagName == "IMG")this._onselectevent();
};

CimsEventManager.prototype.getCaptureComponent = function ()
{
    return this._captureComponent;
};

CimsEventManager.prototype.setCaptureComponent = function (v)
{
    this._captureComponent = v;
};

_p.dispose = function ()
{
    if (this._disposed)return;
    CimsObject.prototype.dispose.call(this);
    if (this._window)
    {
        this.detachMouseEvents();
        this.detachKeyboardEvents();
        var doc = this._window.document;
        if (doc)
        {
            if (doc.body)
            {
                doc.body.onselect = doc.body.onactivate = null;
            }
            doc.onselectstart = doc.onselectionchange = doc.ondragstart = null;
        }
        this._window.onblur = null;
        if (CimsBrowserCheck.moz)
        {
            window.removeEventListener("resize", this.__onresizeevent, false);
        }
    }
    this.__onmouseevent = this.__onkeyevent = this.__onselectevent = this.__onwindowblur = this.__ondragevent = this.__onactivateevent = this.__onbeforeactivateevent = this.__onresizeevent = null;
    this._mozActiveElement = null;
};

_p._mozOnFocus = function (e, c, el)
{
    var old = this._mozActiveElement;
    this._mozActiveElement = el;
    this._mozUpdateFocusVisuals(el);
    if (old && old != el)this._mozUpdateFocusVisuals(old);
    this._setFocusedComponent(c);
    if (e)e.stopPropagation();
};

_p._mozOnBlur = function (e, c, el)
{
    if (this._mozActiveElement == el)this._mozActiveElement = null;
    this._mozUpdateFocusVisuals(el);
};

_p._mozUpdateFocusVisuals = function (el)
{
    if (el == this._mozActiveElement)el.setAttribute("bi-moz-focused", "true");
    else el.removeAttribute("bi-moz-focused");
};


/********************************************************
**   CimsBorder
********************************************************/
function CimsBorder(nWidth, sStyle, sColor)
{
    if (_inPrototype)return;
    CimsObject.call(this);
    this._props = 
    {
    }
    ;
    this._set("border", (nWidth != null ? nWidth + "px " : "") + (sStyle ? sStyle + " " : "") + (sColor ? sColor : ""));
    this._leftWidth = this._rightWidth = this._topWidth = this._bottomWidth = nWidth;
    this._leftStyle = this._rightStyle = this._topStyle = this._bottomStyle = sStyle;
    this._leftColor = this._rightColor = this._topColor = this._bottomColor = sColor;
    if (CimsBrowserCheck.moz)
    {
        this._mozSyncLeftColors();
        this._mozSyncRightColors();
        this._mozSyncTopColors();
        this._mozSyncBottomColors();
    }
}
_p = _mExtend(CimsBorder, CimsObject, "CimsBorder");
CimsBorder.prototype.getLeftWidth = function ()
{
    return this._leftWidth;
};

CimsBorder.prototype.getLeftStyle = function ()
{
    return this._leftStyle;
};

CimsBorder.prototype.getLeftColor = function ()
{
    return this._leftColor;
};

CimsBorder.prototype.getRightWidth = function ()
{
    return this._rightWidth;
};

CimsBorder.prototype.getRightStyle = function ()
{
    return this._rightStyle;
};

CimsBorder.prototype.getRightColor = function ()
{
    return this._rightColor;
};

CimsBorder.prototype.getTopWidth = function ()
{
    return this._topWidth;
};

CimsBorder.prototype.getTopStyle = function ()
{
    return this._topStyle;
};

CimsBorder.prototype.getTopColor = function ()
{
    return this._topColor;
};

CimsBorder.prototype.getBottomWidth = function ()
{
    return this._bottomWidth;
};

CimsBorder.prototype.setBottomWidth = function (v)
{
    this._bottomWidth = v;
};

CimsBorder.prototype.getBottomStyle = function ()
{
    return this._bottomStyle;
};

CimsBorder.prototype.setBottomStyle = function (v)
{
    this._bottomStyle = v;
};

CimsBorder.prototype.getBottomColor = function ()
{
    return this._bottomColor;
};

CimsBorder.prototype.setBottomColor = function (v)
{
    this._bottomColor = v;
};

_p.setLeft = function (nWidth, sStyle, sColor)
{
    this._set("borderLeft", (nWidth != null ? nWidth + "px " : "") + (sStyle ? sStyle + " " : "") + (sColor ? sColor : ""));
    this._leftWidth = nWidth;
    this._leftStyle = sStyle;
    this._leftColor = sColor;
    if (CimsBrowserCheck.moz)this._mozSyncLeftColors();
};

_p.setRight = function (nWidth, sStyle, sColor)
{
    this._set("borderRight", (nWidth != null ? nWidth + "px " : "") + (sStyle ? sStyle + " " : "") + (sColor ? sColor : ""));
    this._rightWidth = nWidth;
    this._rightStyle = sStyle;
    this._rightColor = sColor;
    if (CimsBrowserCheck.moz)this._mozSyncRightColors();
};

_p.setTop = function (nWidth, sStyle, sColor)
{
    this._set("borderTop", (nWidth != null ? nWidth + "px " : "") + (sStyle ? sStyle + " " : "") + (sColor ? sColor : ""));
    this._topWidth = nWidth;
    this._topStyle = sStyle;
    this._topColor = sColor;
    if (CimsBrowserCheck.moz)this._mozSyncTopColors();
};

_p.setBottom = function (nWidth, sStyle, sColor)
{
    this._set("borderBottom", (nWidth != null ? nWidth + "px " : "") + (sStyle ? sStyle + " " : "") + (sColor ? sColor : ""));
    this._bottomWidth = nWidth;
    this._bottomStyle = sStyle;
    this._bottomColor = sColor;
    if (CimsBrowserCheck.moz)this._mozSyncBottomColors();
};

_p.setWidth = function (nWidth)
{
    this._set("borderWidth", nWidth + "px");
    this._leftWidth = this._rightWidth = this._topWidth = this._bottomWidth = nWidth;
};

_p.setStyle = function (sStyle)
{
    this._set("borderStyle", sStyle);
    this._leftStyle = this._rightStyle = this._topStyle = this._bottomStyle = sStyle;
    if (CimsBrowserCheck.moz)
    {
        this._mozSyncLeftColors();
        this._mozSyncRightColors();
        this._mozSyncTopColors();
        this._mozSyncBottomColors();
    }
};

_p.setColor = function (sColor)
{
    this._set("borderColor", sColor);
    this._leftColor = this._rightColor = this._topColor = this._bottomColor = sColor;
    if (CimsBrowserCheck.moz)
    {
        this._mozSyncLeftColors();
        this._mozSyncRightColors();
        this._mozSyncTopColors();
        this._mozSyncBottomColors();
    }
};

_p.setLeftWidth = function (nWidth)
{
    this.setLeft(nWidth, this._leftStyle, this._leftColor);
};

_p.setRightWidth = function (nWidth)
{
    this.setRight(nWidth, this._rightStyle, this._rightColor);
};

_p.setTopWidth = function (nWidth)
{
    this.setTop(nWidth, this._topStyle, this._topColor);
};

_p.setBottomWidth = function (nWidth)
{
    this.setBottom(nWidth, this._bottomStyle, this._bottomColor);
};

_p.setLeftStyle = function (sStyle)
{
    this.setLeft(this._leftWidth, sStyle, this._leftColor);
    if (CimsBrowserCheck.moz)this._mozSyncLeftColors();
};

_p.setRightStyle = function (sStyle)
{
    this.setRight(this._rightWidth, sStyle, this._rightColor);
    if (CimsBrowserCheck.moz)this._mozSyncRightColors();
};

_p.setTopStyle = function (sStyle)
{
    this.setTop(this._topWidth, sStyle, this._topColor);
    if (CimsBrowserCheck.moz)this._mozSyncTopColors();
};

_p.setBottomStyle = function (sStyle)
{
    this.setBottom(this._bottomWidth, sStyle, this._bottomColor);
    if (CimsBrowserCheck.moz)this._mozSyncBottomColors();
};

_p.setLeftColor = function (sColor)
{
    this.setLeft(this._leftWidth, this._leftStyle, sColor);
    if (CimsBrowserCheck.moz)this._mozSyncLeftColors();
};

_p.setRightColor = function (sColor)
{
    this.setRight(this._rightWidth, this._rightStyle, sColor);
    if (CimsBrowserCheck.moz)this._mozSyncRightColors();
};

_p.setTopColor = function (sColor)
{
    this.setTop(this._topWidth, this._topStyle, sColor);
    if (CimsBrowserCheck.moz)this._mozSyncTopColors();
};

_p.setBottomColor = function (sColor)
{
    this.setBottom(this._bottomWidth, this._bottomStyle, sColor);
    if (CimsBrowserCheck.moz)this._mozSyncBottomColors();
};

_p._setLeftColors = function (sColors)
{
    this._set("MozBorderLeftColors", sColors);
};

_p._setRightColors = function (sColors)
{
    this._set("MozBorderRightColors", sColors);
};

_p._setTopColors = function (sColors)
{
    this._set("MozBorderTopColors", sColors);
};

_p._setBottomColors = function (sColors)
{
    this._set("MozBorderBottomColors", sColors);
};

_p.paintBorder = function (oComponent)
{
    for (var p in this._props)
    {
        oComponent.setStyleProperty(p, this._props[p]);
    }
};

_p.removeBorder = function (oComponent)
{
    for (var p in this._props)
    {
        oComponent.removeStyleProperty(p);
    }
};

_p._set = function (sName, sValue)
{
    if (sValue == "" || sValue == null)delete this._props[sName];
    else this._props[sName] = sValue;
};

_p._mozSyncLeftColors = function ()
{
    if (this._leftColor)this._setLeftColors("");
    else 
    {
        switch (this._leftStyle)
            {
            case "groove":
                this._setLeftColors("ThreeDShadow ThreeDHighlight");
                break;
            case "ridge":
                this._setLeftColors("ThreeDHighlight ThreeDShadow");
                break;
            case "inset":
                this._setLeftColors("ThreeDShadow ThreeDDarkShadow");
                break;
            case "outset":
                this._setLeftColors("ThreeDLightShadow ThreeDHighlight");
                break;
                default : this._setLeftColors("");
        }
    }
};

_p._mozSyncRightColors = function ()
{
    if (this._rightColor)this._setRightColors("");
    else 
    {
        switch (this._rightStyle)
            {
            case "groove":
                this._setRightColors("ThreeDHighlight ThreeDShadow");
                break;
            case "ridge":
                this._setRightColors("ThreeDShadow ThreeDHighlight");
                break;
            case "inset":
                this._setRightColors("ThreeDHighlight ThreeDLightShadow");
                break;
            case "outset":
                this._setRightColors("ThreeDDarkShadow ThreeDShadow");
                break;
                default : this._setRightColors("");
        }
    }
};

_p._mozSyncTopColors = function ()
{
    if (this._topColor)this._setTopColors("");
    else 
    {
        switch (this._topStyle)
            {
            case "groove":
                this._setTopColors("ThreeDShadow ThreeDHighlight");
                break;
            case "ridge":
                this._setTopColors("ThreeDHighlight ThreeDShadow");
                break;
            case "inset":
                this._setTopColors("ThreeDShadow ThreeDDarkShadow");
                break;
            case "outset":
                this._setTopColors("ThreeDLightShadow ThreeDHighlight");
                break;
                default : this._setTopColors("");
        }
    }
};

_p._mozSyncBottomColors = function ()
{
    if (this._bottomColor)this._setBottomColors("");
    else 
    {
        switch (this._bottomStyle)
            {
            case "groove":
                this._setBottomColors("ThreeDHighlight ThreeDShadow");
                break;
            case "ridge":
                this._setBottomColors("ThreeDShadow ThreeDHighlight");
                break;
            case "inset":
                this._setBottomColors("ThreeDHighlight ThreeDLightShadow");
                break;
            case "outset":
                this._setBottomColors("ThreeDDarkShadow ThreeDShadow");
                break;
                default : this._setBottomColors("");
        }
    }
};

CimsBorder.THIN_INSET_BORDER = new CimsBorder(1, "solid", "ThreeDShadow");
CimsBorder.THIN_INSET_BORDER.setRightColor("ThreeDHighlight");
CimsBorder.THIN_INSET_BORDER.setBottomColor("ThreeDHighlight");
CimsBorder.THIN_OUTSET_BORDER = new CimsBorder(1, "solid", "ThreeDShadow");
CimsBorder.THIN_OUTSET_BORDER.setLeftColor("ThreeDHighlight");
CimsBorder.THIN_OUTSET_BORDER.setTopColor("ThreeDHighlight");
CimsBorder.INSET_BORDER = new CimsBorder(2, "inset");
CimsBorder.OUTSET_BORDER = new CimsBorder(2, "outset");
CimsBorder.GROOVE_BORDER = new CimsBorder(2, "groove");
CimsBorder.RIDGE_BORDER = new CimsBorder(2, "ridge");
CimsBorder.fromString = function (s)
{
    var b = new CimsBorder;
    var part;
    var parts = s.split(/\s+/);
    for (var i = 0; i < parts.length; i++)
    {
        part = parts[i];
        switch (part)
            {
            case "groove":
            case "ridge":
            case "inset":
            case "outset":
            case "solid":
            case "dotted":
            case "dashed":
            case "double":
            case "none":
                b.setStyle(part);
                break;
                default : var n = parseFloat(part);
                if (n == part || part.indexOf("px") !=  - 1)b.setWidth(n);
                else b.setColor(part);
                break;
        }
    }
    return b;
};




/********************************************************
**   CimsComponent
********************************************************/
function CimsComponent(sName)
{
    if (_inPrototype)return;
    CimsEventTarget.call(this);
    if (sName)this._name = sName;
    this._children = [];
    this._style = {};
    this._htmlProperties = {
        id : "bi-component-" + ++CimsComponent._componentCount, 
        className : this._cssClassName, 
        unselectable : "on"
     };
    this._htmlAttributes = {};
}
_p = _mExtend(CimsComponent, CimsEventTarget, "CimsComponent");
CimsComponent._componentCount = 0;
CimsComponent.__oninlineevent = function (e)
{
    return this._biComponent._oninlineevent(e);
};

_p._parent = null;
_p._name = "";
_p._enabled = true;
_p._capture = false;
_p._canSelect = false;
_p._focused = false;
_p._created = false;
_p._tabIndex =  - 1;
_p._hideFocus = false;
_p._tagName = "DIV";
_p._cssClassName = "bi-component";
_p._toolTip = null;
_p._toolTipText = null;
_p._opacity = 1;
_p._visible = true;
_p._left = _p._right = _p._top = _p._bottom = _p._width = _p._height = null;
_p._measuredWidth = null;
_p._measuredHeight = null;
_p._minimumWidth = _p._maximumWidth = _p._minimumHeight = _p._maximumHeight = null;
_p._acceptsEnter = false;
_p._acceptsEsc = false;
_p._focusManager = null;
_p._lazyCreate = false;
_p.add = function (oChild, oBefore, bAnonymous)
{
    var p = oChild._parent;
    if (oBefore == null)
    {
        if (p != null)p.remove(oChild);
        this._children.push(oChild);
    }
    else
    {
        if (oBefore._parent != this)throw new Error("Can only add components before siblings");
        if (p != null)p.remove(oChild);
        this._children.insertBefore(oChild, oBefore);
    }
    oChild._anonymous = Boolean(bAnonymous);
    oChild._parent = this;
    if (this._created)oChild._addHtmlElementToParent(this, oBefore);
};

_p.remove = function (oChild)
{
    if (oChild._parent != this)throw new Error("Can only remove children");
    this._children.remove(oChild);
    oChild._parent = null;
    oChild._anonymous = false;
    if (this._created)this._removeHtmlElement(oChild);
    return oChild;
};

_p.removeAll = function ()
{
    var cs = this.getChildren();
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        this.remove(cs[i]);
        cs[i].dispose();
    }
};

_p.getParent = function ()
{
    if (this._parent == null ||!this._parent._anonymous)return this._parent;
    return this._parent.getParent();
};

_p.setParent = function (p)
{
    if (p != null && p != this._parent)
    {
        p.add(this);
    }
    else if (this._parent != null)
    {
        this._parent.remove(this);
    }
};

_p.getChildren = function ()
{
    var res = [];
    var cs = this._children;
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        if (!cs[i]._anonymous)res.push(cs[i]);
    }
    return res;
};

_p.setChildren = function (cs)
{
    this.removeAll();
    if (cs != null)
    {
        for (var i = 0; i < cs.length; i++)
        {
            this.add(cs[i]);
        }
    }
};

_p.hasChildren = function ()
{
    var cs = this._children;
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        if (!cs[i]._anonymous)return true;
    }
    return false;
};

_p.getTopLevelComponent = function ()
{
    if (this._parent == null)return null;
    return this._parent.getTopLevelComponent();
};

_p.contains = function (oDescendant)
{
    if (oDescendant == null)return false;
    if (oDescendant == this)return true;
    var p = oDescendant._parent;
    return this.contains(p);
};

_p.getFirstChild = function ()
{
    var cs = this._children;
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        if (!cs[i]._anonymous)return cs[i];
    }
    return null;
};

_p.getLastChild = function ()
{
    var cs = this._children;
    var l = cs.length;
    for (var i = l - 1; i >= 0; i--)
    {
        if (!cs[i]._anonymous)return cs[i];
    }
    return null;
};

_p.getPreviousSibling = function ()
{
    var p = this._parent;
    if (p == null)return null;
    var cs = p._children;
    for (var i = cs.indexOf(this) - 1; i >= 0; i--)
    {
        if (!cs[i]._anonymous)return cs[i];
    }
    return null;
};

_p.getNextSibling = function ()
{
    var p = this._parent;
    if (p == null)return null;
    var cs = p._children;
    var l = cs.length;
    for (var i = cs.indexOf(this) + 1; i < l; i++)
    {
        if (!cs[i]._anonymous)return cs[i];
    }
    return null;
};

CimsComponent.prototype.getAnonymous = function ()
{
    return this._anonymous;
};

_p.setStyleProperty = function (sProp, sValue)
{
    this._style[sProp] = sValue;
    if (this._created)this._element.style[sProp] = sValue;
};

_p.getStyleProperty = function (sProp)
{
    if (this._created)
    {
        if (CimsBrowserCheck.ie)return this._element.currentStyle[sProp];
        else return this._document.defaultView.getComputedStyle(this._element, "")[sProp];
    }
    else return this._style[sProp];
};

_p.removeStyleProperty = function (sProp)
{
    delete this._style[sProp];
    if (this._created)this._element.style[sProp] = "";
};

_p.getHtmlProperty = function (sProp)
{
    if (this._created)return this._element[sProp];
    return this._htmlProperties[sProp];
};


_p.setHtmlProperty = function (sProp, oValue)
{
    this._htmlProperties[sProp] = oValue;
    if (this._created)this._element[sProp] = oValue;
};

_p.removeHtmlProperty = function (sProp)
{
    delete this._htmlProperties[sProp];
    if (this._created)
    {
        if (CimsBrowserCheck.ie)this._element.removeAttribute(sProp);
        else delete this._element[sProp];
    }
};

_p._getHtmlAttribute = function (sName)
{
    if (this._created)return this._element.getAttribute(sName);
    else return this._htmlAttributes[sName];
};

_p._setHtmlAttribute = function (sName, sValue)
{
    this._htmlAttributes[sName] = sValue;
    if (this._created)this._element.setAttribute(sName, sValue);
};

_p._removeHtmlAttribute = function (sName)
{
    delete this._htmlAttributes[sName];
    if (this._created)this._element.removeAttribute(sName);
};

_p.setForeColor = function (sForeColor)
{
    this.setStyleProperty("color", sForeColor);
};

_p.getForeColor = function ()
{
    return this.getStyleProperty("color");
};

_p.setBackColor = function (sBackColor)
{
    this.setStyleProperty("backgroundColor", sBackColor);
};

_p.getBackColor = function ()
{
    return this.getStyleProperty("backgroundColor");
};

_p.setZIndex = function (nZIndex)
{
	if (nZIndex == null) // Fix for IE8
		nZIndex = "auto";
    this.setStyleProperty("zIndex", nZIndex);
};

_p.getZIndex = function ()
{
    if (CimsBrowserCheck.moz && this._created)return Number(this._element.style.zIndex);
    else return Number(this.getStyleProperty("zIndex"));
};

_p.setVisible = function (bVisible)
{
    if (!bVisible && this.getContainsFocus())this.setFocused(false);
    this._visible = bVisible;
    this.setStyleProperty("visibility", bVisible ? "inherit" : "hidden");
    if (this._lazyCreate &&!this._created && bVisible)
    {
        var p = this.getParent();
        if (p && p._created)this._addHtmlElementToParent(p, this.getNextSibling(), true);
    }
};

_p.getVisible = function ()
{
    return this.getStyleProperty("visibility") != "hidden";
};

_p.getIsVisible = function ()
{
    if (!this.getVisible())return false;
    var p = this._parent;
    return p != null && p.getIsVisible();
};

_p.setCursor = function (sCursor)
{
    if (!sCursor)
    {
        this.removeStyleProperty("cursor");
    }
    else
    {
        this.setStyleProperty("cursor", CimsBrowserCheck.ie55 && sCursor == "pointer" ? "hand" : sCursor);
    }
};

_p.getCursor = function ()
{
    var c = this.getStyleProperty("cursor");
    return c == "hand" ? "pointer" : (c || "");
};

_p.setBackgroundImage = function (oUri)
{
    if (oUri == null || oUri == "")
    {
        this.removeStyleProperty("backgroundImage");
    }
    else 
    {
        var uri;
        if (oUri instanceof CimsUri)uri = oUri;
        else uri = new CimsUri(application.getAdfPath(), oUri);
        this.setStyleProperty("backgroundImage", "url(" + uri + ")");
    }
};

_p.getBackgroundImage = function ()
{
    var s = this.getStyleProperty("backgroundImage");
    if (s == null || s == "" || s == "none")return null;
    return new CimsUri(s.match(/^url\((.+)\)$/i)[1]);
};

_p.setOpacity = function (n)
{
    if (this._opacity != n)
    {
        n = Math.max(0, Math.min(1, n));
        this._opacity = n;
        if (CimsBrowserCheck.ie)
        {
            n = Math.round(n * 100);
            if (n == 100)this.removeStyleProperty("filter");
            else this.setStyleProperty("filter", "Alpha(Opacity=" + n + ")");
        }
        else 
        {
            if (n == 1)this.removeStyleProperty("MozOpacity");
            else this.setStyleProperty("MozOpacity", n);
        }
    }
};

CimsComponent.prototype.getOpacity = function ()
{
    return this._opacity;
};

_p.setLeft = function (nLeft)
{
    if (this._left != nLeft)
    {
        this._left = nLeft;
        this.invalidateParentLayout("size");
    }
};

_p.setRight = function (nRight)
{
    if (this._right != nRight)
    {
        this._right = nRight;
        this.invalidateParentLayout("size");
    }
};

_p.setTop = function (nTop)
{
    if (this._top != nTop)
    {
        this._top = nTop;
        this.invalidateParentLayout("size");
    }
};

_p.setBottom = function (nBottom)
{
    if (this._bottom != nBottom)
    {
        this._bottom = nBottom;
        this.invalidateParentLayout("size");
    }
};

_p.setWidth = function (nWidth)
{
    if (this._width != nWidth)
    {
        this._width = nWidth;
        this.invalidateParentLayout("size");
    }
};

_p.setHeight = function (nHeight)
{
    if (this._height != nHeight)
    {
        this._height = nHeight;
        this.invalidateParentLayout("size");
    }
};

_p.setSize = function (nWidth, nHeight)
{
    if (this._width != nWidth || this._height != nHeight)
    {
        this._width = nWidth;
        this._height = nHeight;
        this.invalidateParentLayout("size");
    }
};

_p.setLocation = function (nLeft, nTop)
{
    if (this._left != nLeft || this._top != nTop)
    {
        this._left = nLeft;
        this._top = nTop;
        this.invalidateParentLayout("size");
    }
};

_p.setBounds = function (nLeft, nTop, nWidth, nHeight)
{
    if (this._left != nLeft || this._top != nTop || this._width != nWidth || this._height != nHeight)
    {
        this._left = nLeft;
        this._top = nTop;
        this._width = nWidth;
        this._height = nHeight;
        this.invalidateParentLayout("size");
    }
};

_p.invalidateParentLayout = function (sHint)
{
    this._invalidBoundaries = true;
    var p = this._parent;
    if (p)p.invalidateChild(this, sHint);
};

_p.invalidateLayout = function ()
{
    this._invalidLayout = true;
    if (this._created)CimsComponent.enqueueLayout(this);
};

_p.invalidateChild = function (oChild, sHint)
{
    if (sHint == null || sHint == "size")this._invalidateChild(oChild, sHint);
};


_p._invalidateChild = function (oChild, sHint)
{
    if (!oChild._invalidBoundaries)
    {
        oChild._invalidBoundaries = true;
        oChild.invalidateParentLayout(sHint);
    }
    oChild._invalidBoundaries = true;
    if (oChild._created)CimsComponent.enqueueLayout(oChild);
};

_p._invalidBoundaries = true;
_p._invalidLayout = false;
CimsComponent._layoutQueue = 
{
};

CimsComponent._inFlushLayoutQueue = false;
CimsComponent._inFlushLayoutComponent = false;
CimsComponent.enqueueLayout = function (c)
{
    var hc = c.toHashCode();
    if (hc in this._layoutQueue)return;
    this._layoutQueue[hc] = c;
};

CimsComponent.flushLayoutQueue = function ()
{
    if (this._inFlushLayoutQueue || this._inFlushLayoutComponent)return;
    this._inFlushLayoutQueue = true;
    var c, ks, vs;
    while (!Object.isEmpty(this._layoutQueue))
    {
        ks = Object.getKeys(this._layoutQueue);
        vs = Object.getValues(this._layoutQueue);
        for (var i = 0; i < ks.length; i++)
        {
            this.flushLayoutComponent(vs[i]);
            delete this._layoutQueue[ks[i]];
        }
    }
    this._inFlushLayoutQueue = false;
};

CimsComponent.flushLayoutComponent = function (c)
{
    if (this._inFlushLayoutComponent)return;
    this._inFlushLayoutComponent = true;
    var hc;
    var cs = [];
    while (c)
    {
        hc = c.toHashCode();
        if (hc in this._layoutQueue)cs.push(c);
        c = c._parent;
    }
    for (var i = cs.length - 1; i >= 0; i--)
    {
        c = cs[i];
        hc = c.toHashCode();
        delete this._layoutQueue[hc];
        if (c.getDisposed())continue;
        if (c._invalidBoundaries)c.layoutComponent();
        if (c._invalidLayout)c.layoutAllChildren();
    }
    this._inFlushLayoutComponent = false;
};

_p.layoutComponent = function ()
{
    var p;
    if (this._created && (p = this._parent))
    {
        p.layoutChild(this);
    }
};

_p.layoutChild = function (oChild)
{
    var sizeChanged = this._layoutChild(oChild);
    if (sizeChanged)oChild.invalidateLayout();
};

_p.layoutChildX = function (oChild)
{
};

_p.layoutChildY = function (oChild)
{
};

_p.layoutAllChildren = function ()
{
    var cs = this._children;
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        cs[i].layoutComponent();
    }
    this._invalidLayout = false;
};

_p.layoutAllChildrenX = function ()
{
};

_p.layoutAllChildrenY = function ()
{
};


_p._layoutChild = function (oChild)
{
    var x, y, w, h;
    var cw, ch;
    if (oChild._left != null)
    {
        x = oChild._left;
        if (oChild._right != null)
        {
            cw = this.getClientWidth();
            w = cw - oChild._left - oChild._right;
        }
        else if (oChild._width != null)
        {
            w = oChild._width;
        }
    }
    else if (oChild._right != null)
    {
        if (oChild._width != null)w = oChild._width;
        else 
        {
            oChild.removeStyleProperty("width");
            if (CimsBrowserCheck.ie && oChild._measuredHeight == 0)
            {
                oChild._element.runtimeStyle.display = "";
            }
            w = oChild.getWidth();
        }
        cw = this.getClientWidth();
        x = cw - w - oChild._right;
    }
    else if (oChild._width != null)
    {
        w = oChild._width;
    }
    if (oChild._top != null)
    {
        y = oChild._top;
        if (oChild._bottom != null)
        {
            ch = this.getClientHeight();
            h = ch - oChild._top - oChild._bottom;
        }
        else if (oChild._height != null)
        {
            h = oChild._height;
        }
    }
    else if (oChild._bottom != null)
    {
        h;
        if (oChild._height != null)h = oChild._height;
        else 
        {
            oChild.removeStyleProperty("height");
            if (CimsBrowserCheck.ie && oChild._measuredHeight == 0)
            {
                oChild._element.runtimeStyle.display = "";
            }
            h = oChild.getHeight();
        }
        ch = this.getClientHeight();
        y = ch - h - oChild._bottom;
    }
    else if (oChild._height != null)
    {
        h = oChild._height;
    }
    return this._layoutChild2(oChild, x, y, w, h);
};

if (CimsBrowserCheck.ie)
{
    _p._layoutChild2 = function (c, x, y, w, h, bInvalidate)
    {
        if (x != null)c.setStyleProperty("pixelLeft", x);
        if (y != null)c.setStyleProperty("pixelTop", y);
        if (w != null)c.setStyleProperty("pixelWidth", w);
        if (h != null)c.setStyleProperty("pixelHeight", h);
        var wChanged = false;
        var hChanged = false;
        if (w != null)
        {
            wChanged = w != c._measuredWidth;
            c._measuredWidth = w;
        }
        if (h != null)
        {
            hChanged = h != c._measuredHeight;
            if (hChanged)c._element.runtimeStyle.display = h == 0 ? "none" : "";
            c._measuredHeight = h;
        }
        c._invalidBoundaries = false;
        if (wChanged || hChanged)
        {
            c.dispatchEvent(new CimsEvent("resize"));
            if (bInvalidate)
            {
                c.invalidateLayout();
            }
            return true;
        }
        return false;
    }
    ;
}
else 
{
    _p._layoutChild2 = function (c, x, y, w, h, bInvalidate)
    {
        if (x != null)c.setStyleProperty("left", x + "px");
        if (y != null)c.setStyleProperty("top", y + "px");
        if (w != null)c.setStyleProperty("width", w + "px");
        if (h != null)c.setStyleProperty("height", h + "px");
        var wChanged = false;
        var hChanged = false;
        if (w != null)
        {
            wChanged = w != c._measuredWidth;
            c._measuredWidth = w;
        }
        if (h != null)
        {
            hChanged = h != c._measuredHeight;
            c._measuredHeight = h;
        }
        c._invalidBoundaries = false;
        if (wChanged || hChanged)
        {
            c.dispatchEvent(new CimsEvent("resize"));
            if (bInvalidate)
            {
                c.invalidateLayout();
            }
            return true;
        }
        return false;
    }
    ;
}
_p.getLeft = function ()
{
    if (this._created)
    {
        CimsComponent.flushLayoutComponent(this);
        return this._element.offsetLeft;
    }
    return this._left;
};


_p.getRight = function ()
{
    if (this._created && this._parent)
    {
        CimsComponent.flushLayoutComponent(this);
        return this._parent.getClientWidth() - this.getLeft() - this.getWidth();
    }
    return this._right;
};

_p.getTop = function ()
{
    if (this._created)
    {
        CimsComponent.flushLayoutComponent(this);
        return this._element.offsetTop;
    }
    return this._top;
};

_p.getBottom = function ()
{
    if (this._created && this._parent)
    {
        CimsComponent.flushLayoutComponent(this);
        return this._parent.getClientHeight() - this.getTop() - this.getHeight();
    }
    return this._bottom;
};

_p.getWidth = function ()
{
    if (this._created)
    {
        CimsComponent.flushLayoutComponent(this);
        return this._element.offsetWidth;
    }
    return this._width;
};

_p.getHeight = function ()
{
    if (this._created)
    {
        CimsComponent.flushLayoutComponent(this);
        return this._element.offsetHeight;
    }
    return this._height;
};

if (CimsBrowserCheck.moz)
{
    _p.getWidth = function ()
    {
        if (this._created)
        {
            CimsComponent.flushLayoutComponent(this);
            if (this._element.style.width == "")
            {
                var ps = this._element.parentNode.style;
                var w = ps.width;
                var h = ps.height;
                ps.width = ps.height = "9999999px";
                var res = this._element.offsetWidth;
                ps.width = w;
                ps.height = h;
                return res;
            }
            return this._element.offsetWidth;
        }
        return this._width;
    }
    ;
    _p.getHeight = function ()
    {
        if (this._created)
        {
            CimsComponent.flushLayoutComponent(this);
            if (this._element.style.height == "")
            {
                var ps = this._element.parentNode.style;
                var w = ps.width;
                var h = ps.height;
                ps.width = ps.height = "9999999px";
                var res = this._element.offsetHeight;
                ps.width = w;
                ps.height = h;
                return res;
            }
            return this._element.offsetHeight;
        }
        return this._height;
    }
    ;
}
_p.getHasFixedWidth = function ()
{
    return this._width != null || this._left != null && this._right != null;
};

_p.getHasFixedHeight = function ()
{
    return this._height != null || this._top != null && this._bottom != null;
};

_p.getClientWidth = function ()
{
    if (this._created)
    {
        CimsComponent.flushLayoutComponent(this);
        return this._element.clientWidth;
    }
    throw new Error("Visual property on non created component");
};

_p.getClientHeight = function ()
{
    if (this._created)
    {
        CimsComponent.flushLayoutComponent(this);
        return this._element.clientHeight;
    }
    throw new Error("Visual property on non created component");
};


_p.getInsetLeft = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    if (CimsBrowserCheck.ie)return this._element.clientLeft;
    else 
    {
        var rtl = this.getRightToLeft();
        var el = this._element;
        var cs = this._document.defaultView.getComputedStyle(el, "");
        if (!rtl)return parseInt(cs.borderLeftWidth);
        return el.offsetWidth - el.clientWidth - parseInt(cs.borderRightWidth);
    }
};

_p.getInsetRight = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    var el = this._element;
    if (CimsBrowserCheck.ie)
    {
        if (this.getStyleProperty("overflowY") == "hidden" || el.clientWidth == 0)
        {
            if (el.currentStyle.borderRightStyle == "none")return 0;
            var brw = el.currentStyle.borderRightWidth;
            if (brw.indexOf("px") !=  - 1)return parseInt(brw);
        }
        return Math.max(0, this._element.offsetWidth - this._element.clientLeft - this._element.clientWidth);
    }
    else 
    {
        var rtl = this.getRightToLeft();
        var cs = this._document.defaultView.getComputedStyle(el, "");
        if (rtl)return parseInt(cs.borderRightWidth);
        return Math.max(0, el.offsetWidth - el.clientWidth - parseInt(cs.borderLeftWidth));
    }
};

_p.getInsetTop = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    if (CimsBrowserCheck.ie)return this._element.clientTop;
    else 
    {
        return parseInt(window.getComputedStyle(this._element, "").borderTopWidth);
    }
};

_p.getInsetBottom = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    var el = this._element;
    if (CimsBrowserCheck.ie)
    {
        if (this.getStyleProperty("overflowX") == "hidden" || el.clientHeight == 0)
        {
            if (el.currentStyle.borderBottomStyle == "none")return 0;
            var bbw = el.currentStyle.borderBottomWidth;
            if (bbw.indexOf("px") !=  - 1)return parseInt(bbw);
        }
        return Math.max(0, this._element.offsetHeight - this._element.clientTop - this._element.clientHeight);
    }
    else 
    {
        var cs = this._document.defaultView.getComputedStyle(el, "");
        return Math.max(0, el.offsetHeight - el.clientHeight - parseInt(cs.borderTopWidth));
    }
};

_p.getClientLeft = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    if (CimsBrowserCheck.ie)return this._element.getBoundingClientRect().left;
    else 
    {
        var el = this._element;
        var doc = this._document;
        var win = doc.defaultView;
        var bo = doc.getBoxObjectFor(el);
        var bl = parseInt(win.getComputedStyle(el, "").borderLeftWidth);
        var sum = 0;
        var p = this._element.parentNode;
        while (p.nodeType == 1)
        {
            sum += p.scrollLeft;
            p = p.parentNode;
        }
        return bo.x - bl - sum;
    }
};

_p.getClientTop = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    if (CimsBrowserCheck.ie)return this._element.getBoundingClientRect().top;
    else 
    {
        var el = this._element;
        var doc = this._document;
        var win = doc.defaultView;
        var bo = doc.getBoxObjectFor(el);
        var bt = parseInt(win.getComputedStyle(el, "").borderTopWidth);
        var sum = 0;
        var p = this._element.parentNode;
        while (p.nodeType == 1)
        {
            sum += p.scrollTop;
            p = p.parentNode;
        }
        return bo.y - bt - sum;
    }
};


_p.getScreenLeft = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    if (CimsBrowserCheck.ie)return this.getClientLeft() + this._document.parentWindow.screenLeft;
    else 
    {
        var sum = 0;
        var p = this._element.parentNode;
        while (p.nodeType == 1)
        {
            sum += p.scrollLeft;
            p = p.parentNode;
        }
        return this._document.getBoxObjectFor(this._element).screenX - sum;
    }
};

_p.getScreenTop = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    if (CimsBrowserCheck.ie)return this.getClientTop() + this._document.parentWindow.screenTop;
    else 
    {
        var sum = 0;
        var p = this._element.parentNode;
        while (p.nodeType == 1)
        {
            sum += p.scrollTop;
            p = p.parentNode;
        }
        return this._document.getBoxObjectFor(this._element).screenY - sum;
    }
};

_p._getScreenClientArea = function ()
{
    return {
        left : this.getScreenLeft() + this.getInsetLeft(), 
        top : this.getScreenTop() + this.getInsetTop(), 
        width : this.getClientWidth(), 
        height : this.getClientHeight()
    };
};

_p.getPreferredWidth = function ()
{
    if (this._preferredWidth != null)return this._preferredWidth;
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutQueue();
    var el = this._element;
    var w = el.style.width;
    var h = el.style.height;
    el.style.width = "auto";
    el.style.height = "auto";
    var sw = el.scrollWidth;
    var sh = el.scrollHeight;
    el.style.width = w;
    el.style.height = h;
    return this.getInsetLeft() + sw + this.getInsetRight();
};

_p.getPreferredHeight = function ()
{
    if (this._preferredHeight != null)return this._preferredHeight;
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutQueue();
    var el = this._element;
    var w = el.style.width;
    var h = el.style.height;
    el.style.width = "auto";
    el.style.height = "auto";
    var sw = el.scrollWidth;
    var sh = el.scrollHeight;
    el.style.width = w;
    el.style.height = h;
    return this.getInsetTop() + sh + this.getInsetBottom();
};

_p.setPreferredWidth = function (n)
{
    if (this._preferredWidth != n)
    {
        this._preferredWidth = n;
        this.invalidateParentLayout("preferred");
    }
};

_p.setPreferredHeight = function (n)
{
    if (this._preferredHeight != n)
    {
        this._preferredHeight = n;
        this.invalidateParentLayout("preferred");
    }
};

_p.setPreferredSize = function (nWidth, nHeight)
{
    this.setPreferredWidth(nWidth);
    this.setPreferredHeight(nHeight);
};

_p.pack = function ()
{
    this.setSize(this.getPreferredWidth(), this.getPreferredHeight());
};

_p.getMinimumWidth = function ()
{
    if (this._minimumWidth != null)
		return this._minimumWidth;
    return 0;
};

_p.setMinimumWidth = function (n)
{
    if (this._minimumWidth != n)
    {
        this._minimumWidth = n;
        this.invalidateParentLayout("minimum");
    }
};

_p.getMaximumWidth = function ()
{
    if (this._maximumWidth != null)
		return this._maximumWidth;
    return Infinity;
};

_p.setMaximumWidth = function (n)
{
    if (this._maximumWidth != n)
    {
        this._maximumWidth = n;
        this.invalidateParentLayout("maximum");
    }
};

_p.getMinimumHeight = function ()
{
    if (this._minimumHeight != null)
		return this._minimumHeight;
    return 0;
};

_p.setMinimumHeight = function (n)
{
    if (this._minimumHeight != n)
    {
        this._minimumHeight = n;
        this.invalidateParentLayout("minimum");
    }
};

_p.getMaximumHeight = function ()
{
    if (this._maximumHeight != null)
		return this._maximumHeight;
    return Infinity;
};

_p.setMaximumHeight = function (n)
{
    if (this._maximumHeight != n)
    {
        this._maximumHeight = n;
        this.invalidateParentLayout("maximum");
    }
};


_p.setBorder = function (oBorder)
{
    if (this._border)this._border.removeBorder(this);
    this._border = oBorder;
    if (oBorder)this._border.paintBorder(this);
    if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
    this.invalidateLayout();
};

_p.getBorder = function ()
{
    return this._border ? this._border : new CimsBorder;
};

_p._marginLeft = 0;
_p._marginRight = 0;
_p._marginTop = 0;
_p._marginBottom = 0;
CimsComponent.prototype.getMarginLeft = function ()
{
    return this._marginLeft;
};

_p.setMarginLeft = function (n)
{
    if (this._marginLeft != n)
    {
        this._marginLeft = Number(n);
        this.invalidateParentLayout("margin");
    }
};

CimsComponent.prototype.getMarginRight = function ()
{
    return this._marginRight;
};

_p.setMarginRight = function (n)
{
    if (this._marginRight != n)
    {
        this._marginRight = Number(n);
        this.invalidateParentLayout("margin");
    }
};

CimsComponent.prototype.getMarginTop = function ()
{
    return this._marginTop;
};

_p.setMarginTop = function (n)
{
    if (this._marginTop != n)
    {
        this._marginTop = Number(n);
        this.invalidateParentLayout("margin");
    }
};

CimsComponent.prototype.getMarginBottom = function ()
{
    return this._marginBottom;
};

_p.setMarginBottom = function (n)
{
    if (this._marginBottom != n)
    {
        this._marginBottom = Number(n);
        this.invalidateParentLayout("margin");
    }
};


_p.setMargin = function (nLeft, nRight, nTop, nBottom)
{
    if (arguments.length == 1)
    {
        nBottom = nTop = nRight = nLeft;
    }
    else if (arguments.length == 2)
    {
        nTop = nBottom = nRight;
        nRight = nLeft;
    }
    this._marginLeft = Number(nLeft);
    this._marginRight = Number(nRight);
    this._marginTop = Number(nTop);
    this._marginBottom = Number(nBottom);
    this.invalidateParentLayout("maximum");
};


_p._clipLeft=null;
_p._clipRight=null;
_p._clipTop=null;
_p._clipBottom=null;

_p.setClip = function (nLeft, nTop, nWidth, nHeight)
{
    if (nLeft == "auto")nLeft = null;
    if (nTop == "auto")nTop = null;
    if (nWidth == "auto")nWidth = null;
    if (nHeight == "auto")nHeight = null;
    if (nLeft != this._clipLeft || nTop != this._clipTop || nWidth != this._clipWidth || nHeight != this._clipHeight)
    {
        this._clipLeft = nLeft;
        this._clipTop = nTop;
        this._clipWidth = nWidth;
        this._clipHeight = nHeight;
        this._setClipValue();
    }
};

CimsComponent.prototype.getClipLeft = function ()
{
    return this._clipLeft;
};

_p.setClipLeft = function (nLeft)
{
    if (nLeft == "auto")nLeft = null;
    if (this._clipLeft != nLeft)
    {
        this._clipLeft = nLeft;
        this._setClipValue();
    }
};

CimsComponent.prototype.getClipTop = function ()
{
    return this._clipTop;
};

_p.setClipTop = function (nTop)
{
    if (nTop == "auto")nTop = null;
    if (this._clipTop != nTop)
    {
        this._clipTop = nTop;
        this._setClipValue();
    }
};

CimsComponent.prototype.getClipWidth = function ()
{
    return this._clipWidth;
};

_p.setClipWidth = function (nWidth)
{
    if (nWidth == "auto")nWidth = null;
    if (this._clipWidth != nWidth)
    {
        this._clipWidth = nWidth;
        this._setClipValue();
    }
};

CimsComponent.prototype.getClipHeight = function ()
{
    return this._clipHeight;
};

_p.setClipHeight = function (nHeight)
{
    if (nHeight == "auto")nHeight = null;
    if (this._clipHeight != nHeight)
    {
        this._clipHeight = nHeight;
        this._setClipValue();
    }
};


_p._setClipValue = function ()
{
    var left = this._clipLeft;
    var top = this._clipTop;
    var width = this._clipWidth;
    var height = this._clipHeight;
    var right, bottom;
    if (left == null)
    {
        if (width == null)right = "auto";
        else right = width + "px";
        left = "auto"}
    else 
    {
        if (width == null)right = "auto";
        else right = left + width + "px";
        left = left + "px";
    }
    if (top == null)
    {
        if (height == null)bottom = "auto";
        else bottom = height + "px";
        top = "auto"}
    else 
    {
        if (height == null)bottom = "auto";
        else bottom = top + height + "px";
        top = top + "px";
    }
    this.setStyleProperty("clip", "rect(" + top + "," + right + "," + bottom + "," + left + ")");
};

_p.setOverflow = function (sOverflow)
{
    if (CimsBrowserCheck.ie)
    {
        this.setOverflowX(sOverflow);
        this.setOverflowY(sOverflow);
    }
    else 
    {
        this._overflow = sOverflow;
        this._overflowX = sOverflow;
        this._overflowY = sOverflow;
        if (sOverflow == "hidden")sOverflow = "-moz-scrollbars-none";
        this.setStyleProperty("overflow", sOverflow);
        if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
        this.invalidateLayout();
    }
};

_p.getOverflow = function ()
{
    if (CimsBrowserCheck.ie)
    {
        var x = this.getOverflowX();
        var y = this.getOverflowY();
        return x == y ? x : null;
    }
    else 
    {
        var s = this.getStyleProperty("overflow");
        if (s == "-moz-scrollbars-horizontal" || s == "-moz-scrollbars-vertical")return null;
        else if (s == "-moz-scrollbars-none")return "hidden";
        else return s;
    }
};

_p.setOverflowX = function (sOverflowX)
{
    if (this._overflowX != sOverflowX)
    {
        if (CimsBrowserCheck.ie)
        {
            this.setStyleProperty("overflowX", sOverflowX);
        }
        else 
        {
            var s;
            this._overflowX = sOverflowX;
            if (this._overflowX == "hidden" && this._overflowY == "hidden")s = "-moz-scrollbars-none";
            else if (this._overflowX == this._overflowY)s = sOverflowX;
            else if (this._overflowX == "hidden" && this._overflowY == "scroll")s = "-moz-scrollbars-vertical";
            else if (this._overflowX == "scroll" || this._overflowY == "scroll")s = "scroll";
            else if (this._overflowX == "auto" || this._overflowY == "auto")s = "auto";
            else s = "-moz-scrollbars-horizontal";
            this.setStyleProperty("overflow", s);
        }
        if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
        this.invalidateLayout();
    }
};

_p.setOverflowY = function (sOverflowY)
{
    if (this._overflowY != sOverflowY)
    {
        if (CimsBrowserCheck.ie)
        {
            this.setStyleProperty("overflowY", sOverflowY);
        }
        else 
        {
            var s;
            this._overflowY = sOverflowY;
            if (this._overflowX == "hidden" && this._overflowY == "hidden")s = "-moz-scrollbars-none";
            else if (this._overflowX == this._overflowY)s = sOverflowY;
            else if (this._overflowX == "hidden" && this._overflowY == "scroll")s = "-moz-scrollbars-vertical";
            else if (this._overflowX == "scroll" || this._overflowY == "scroll")s = "scroll";
            else if (this._overflowX == "auto" || this._overflowY == "auto")s = "auto";
            else s = "-moz-scrollbars-horizontal";
            this.setStyleProperty("overflow", s);
        }
        if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
        this.invalidateLayout();
    }
};


_p.getOverflowX = function ()
{
    if (CimsBrowserCheck.ie)return this.getStyleProperty("overflowX");
    else 
    {
        var s = this.getStyleProperty("overflow");
        if (s == "-moz-scrollbars-horizontal")return "scroll";
        else if (s == "-moz-scrollbars-vertical" || s == "-moz-scrollbars-none")return "hidden";
        else return s;
    }
};

_p.getOverflowY = function ()
{
    if (CimsBrowserCheck.ie)return this.getStyleProperty("overflowY");
    else 
    {
        var s = this.getStyleProperty("overflow");
        if (s == "-moz-scrollbars-vertical")return "scroll";
        else if (s == "-moz-scrollbars-horizontal" || s == "-moz-scrollbars-none")return "hidden";
        else return s;
    }
};

_p.setScrollLeft = function (nScrollLeft)
{
    if (!this._created)throw new Error("Visual property on non created component");
    this._element.scrollLeft = nScrollLeft;
};

_p.setScrollTop = function (nScrollTop)
{
    if (!this._created)throw new Error("Visual property on non created component");
    this._element.scrollTop = nScrollTop;
};

_p.getScrollLeft = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    this._element.offsetWidth;
    return this._element.scrollLeft;
};

_p.getScrollTop = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    this._element.offsetHeight;
    return this._element.scrollTop;
};

_p.getScrollWidth = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    this._element.offsetWidth;
    if ((new CimsBrowserCheck).getIe55())
    {
        var max = this._element.scrollWidth;
        var cs = this._children;
        var l = cs.length;
        for (var i = 0; i < l; i++)max = Math.max(max, cs[i].getLeft() + cs[i].getWidth()); return max; }
    else return this._element.scrollWidth;
};

_p.getScrollHeight = function ()
{
    if (!this._created)throw new Error("Visual property on non created component");
    CimsComponent.flushLayoutComponent(this);
    this._element.offsetHeight;
    if ((new CimsBrowserCheck).getIe55())
    {
        var max = this._element.scrollHeight;
        var cs = this._children;
        var l = cs.length;
        for (var i = 0; i < l; i++)max = Math.max(max, cs[i].getTop() + cs[i].getHeight()); return max; }
    else return this._element.scrollHeight;
};

_p.scrollIntoView = function (bTopLeft)
{
    this.scrollIntoViewX(bTopLeft);
    this.scrollIntoViewY(bTopLeft);
};

_p.scrollIntoViewX = function (bLeft)
{
    if (!this._created)
    {
        return;
    }
    var p = this._parent;
    if (!p)return;
    var l = this.getLeft();
    var w = this.getWidth();
    var sl = p.getScrollLeft();
    var cw = p.getClientWidth();
    if (bLeft)p.setScrollLeft(l);
    else if (bLeft == false)p.setScrollLeft(l + w - cw);
    else if (w > cw || l < sl)p.setScrollLeft(l);
    else if (l + w > sl + cw)p.setScrollLeft(l + w - cw);
};

_p.scrollIntoViewY = function (bTop)
{
    if (!this._created)
    {
        return;
    }
    var p = this._parent;
    if (!p)return;
    var t = this.getTop();
    var h = this.getHeight();
    var st = p.getScrollTop();
    var ch = p.getClientHeight();
    if (bTop)p.setScrollTop(t);
    else if (bTop == false)p.setScrollTop(t + h - ch);
    else if (h > ch || t < st)p.setScrollTop(t);
    else if (t + h > st + ch)p.setScrollTop(t + h - ch);
};

CimsComponent.prototype.getTabIndex = function ()
{
    return this._tabIndex;
};

_p.setTabIndex = function (nTabIndex)
{
    this._tabIndex = nTabIndex;
    if (CimsBrowserCheck.ie)
    {
        this.setHtmlProperty("unselectable", nTabIndex < 0 ||!this._enabled);
        this.setHtmlProperty("tabIndex", nTabIndex < 0 ?- 1 : 1);
    }
    else 
    {
        this.setStyleProperty("MozUserFocus", nTabIndex < 0 ? "ignore" : "normal");
    }
};

CimsComponent.prototype.getHideFocus = function ()
{
    return this._hideFocus;
};

_p.setHideFocus = function (bHideFocus)
{
    this._hideFocus = bHideFocus;
    if (CimsBrowserCheck.ie)this.setHtmlProperty("hideFocus", bHideFocus);
    else 
    {
        if (bHideFocus)this.setStyleProperty("MozOutline", "none");
        else this.removeStyleProperty("MozOutline");
    }
};

_p._focusComponent = function ()
{
    if (CimsBrowserCheck.ie)
    {
        try
        {
            this._element.focus();
        }
        catch (ex)
        {
        }
    }
    else 
    {
        if (this._element.focus)
        {
            try
            {
                this._element.focus();
            }
            catch (ex)
            {
            }
        }
        else 
        {
            var tlc = this.getTopLevelComponent();
            if (tlc)
            {
                tlc._eventManager._mozOnFocus(null, this, this._element);
            }
        }
    }
};


_p._blurComponent = function ()
{
    if (this.getDisposed())return;
    if (CimsBrowserCheck.ie)
    {
        this._element.blur();
    }
    else 
    {
        if (this._element.blur)
        {
            try
            {
                this._element.blur();
            }
            catch (ex)
            {
            }
        }
        else 
        {
            var tlc = this.getTopLevelComponent();
            if (tlc)
            {
                tlc._eventManager._mozOnBlur(null, this, this._element);
            }
        }
    }
};

CimsComponent.prototype.getFocused = function ()
{
    return this._focused;
};

_p.setFocused = function (bFocused)
{
    if (bFocused &&!this.getCanFocus())throw new Error("Cannot set focus to component");
    if (this._focused != bFocused)
    {
        if (bFocused)this._focusComponent();
        else
        {
            this.getTopLevelComponent()._eventManager._setFocusedComponent(null);
            this._blurComponent();
        }
    }
};

_p.getContainsFocus = function ()
{
    var fr = this.getFocusRoot();
    if (fr)return this.contains(fr.getActiveComponent());
    return false;
};

_p.getCanFocus = function ()
{
    return this._created && this.getTabIndex() >= 0 && this.getIsEnabled() && this.getIsVisible();
};

_p.getFocusRoot = function ()
{
    if (this._parent)return this._parent.getFocusRoot();
    return null;
};

_p.getActiveComponent = function ()
{
    var fr = this.getFocusRoot();
    if (fr)return fr.getActiveComponent();
    return null;
};

_p.isFocusRoot = function ()
{
    return false;
};

CimsComponent.prototype.getFocusManager = function ()
{
    return this._focusManager;
};

CimsComponent.prototype.setFocusManager = function (v)
{
    this._focusManager = v;
};

_p.getTabChildren = function ()
{
    return this.getChildren();
};

CimsComponent.prototype.getCanSelect = function ()
{
    return this._canSelect;
};

_p.setCanSelect = function (bCanSelect)
{
    this._canSelect = bCanSelect;
    if (CimsBrowserCheck.ie)
    {
        if (bCanSelect)this.removeHtmlProperty("unselectable");
        else this.setHtmlProperty("unselectable", "on");
    }
    else 
    {
        if (bCanSelect)this.removeStyleProperty("MozUserSelect");
        else this.setStyleProperty("MozUserSelect", "none");
    }
};

CimsComponent.prototype.getEnabled = function ()
{
    return this._enabled;
};

_p.setEnabled = function (bEnabled)
{
    if (this._enabled != bEnabled)
    {
        if (this.getTabIndex() >= 0)
        {
            if (CimsBrowserCheck.ie)
            {
                if (!bEnabled ||!this._canSelect)this.setHtmlProperty("unselectable", "on");
                else this.removeHtmlProperty("unselectable");
            }
            if (!bEnabled && this.getFocused())
            {
                this.setFocused(false);
            }
        }
        this._enabled = bEnabled;
        this.setHtmlProperty("disabled", !bEnabled);
        if (CimsBrowserCheck.moz)
        {
            if (bEnabled)this._removeHtmlAttribute("disabled");
            else this._setHtmlAttribute("disabled", "true");
        }
        this.dispatchEvent(new CimsEvent("enabledchanged"));
        if (this._command)this._command.setEnabled(bEnabled);
        var tlc;
        if (bEnabled && this.getCanFocus() && (tlc = this.getTopLevelComponent()) && tlc.getActiveComponent() == this)
        {
            this.setFocused(true);
        }
    }
};

_p.getIsEnabled = function ()
{
    if (!this.getEnabled())return false;
    var p = this.getParent();
    if (p)return p.getIsEnabled();
    return true;
};

CimsComponent.prototype.getCapture = function ()
{
    return this._capture;
};

_p.setCapture = function (bCapture)
{
    if (this._created)
    {
        this._element.onlosecapture = CimsComponent.__oninlineevent;
        this._capture = bCapture;
        if (bCapture)
        {
            if (CimsBrowserCheck.ie)this._element.setCapture();
            this.getTopLevelComponent()._eventManager.setCaptureComponent(this);
        }
        else
        {
            if (CimsBrowserCheck.ie)this._element.releaseCapture();
            else this.getTopLevelComponent()._eventManager.setCaptureComponent(null);
        }
    }
};

_p.setAccessKey = function (sAccessKey)
{
    this.setHtmlProperty("accessKey", sAccessKey);
};

_p.getAccessKey = function ()
{
    return this.getHtmlProperty("accessKey");
};

CimsComponent.prototype.getContextMenu = function ()
{
    return this._contextMenu;
};

CimsComponent.prototype.setContextMenu = function (v)
{
    this._contextMenu = v;
};

CimsComponent.prototype.getName = function ()
{
    return this._name;
};

CimsComponent.prototype.setName = function (v)
{
    this._name = v;
};

CimsComponent.prototype.setToolTip = function (v)
{
    this._toolTip = v;
};

CimsComponent.prototype.getToolTipText = function ()
{
    return this._toolTipText;
};

CimsComponent.prototype.setToolTipText = function (v)
{
    this._toolTipText = v;
};

_p.getToolTip = function ()
{
    if (this._toolTip != null)return this._toolTip;
    if (this._toolTipText != null)return CimsToolTip.getTextToolTip(this._toolTipText);
    return null;
};


_p.setRightToLeft = function (b)
{
    if (b == true)this.setStyleProperty("direction", "rtl");
    else if (b == false)this.setStyleProperty("direction", "ltr");
    else this.removeStyleProperty("direction");
};

_p.getRightToLeft = function ()
{
    var v = this.getStyleProperty("direction");
    if (v == null && this._parent)return this._parent.getRightToLeft();
    return v == "rtl";
};

CimsComponent.prototype.getCreated = function ()
{
    return this._created;
};

CimsComponent._createEvent = new CimsEvent("create");
_p._create = function (oDocument)
{
    this._document = oDocument || document;
    var el = this._element = this._document.createElement(this._tagName);
    el._biComponent = this;
    this._setHtmlProperties();
    this._setCssProperties();
    if (CimsBrowserCheck.ie)
    {
        el.onscroll = CimsComponent.__oninlineevent;
    }
    else 
    {
        this._setHtmlAttributes();
        el.onscroll = el.onfocus = CimsComponent.__oninlineevent;
    }
};

_p._createChildren = function (oDocument)
{
    var cs = this._children;
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        cs[i]._addHtmlElementToParent(this, null);
    }
};

_p._setCssProperties = function ()
{
    var es = this._element.style;
    var sp = this._style;
    for (var p in sp)
    {
        es[p] = sp[p];
    }
};

_p._setHtmlProperties = function ()
{
    var el = this._element;
    var hp = this._htmlProperties;
    for (var p in hp)
    {
        el[p] = hp[p];
    }
};

_p._setHtmlAttributes = function ()
{
    var el = this._element;
    var ha = this._htmlAttributes;
    for (var n in ha)el.setAttribute(n, ha[n]); };

_p._addHtmlElementToParent = function (oParent, oBefore)
{
    if (this._lazyCreate &&!this.getVisible())return;
    if (!this._created)this._create(oParent._document);
    if (oBefore && oBefore._element)oParent._element.insertBefore(this._element, oBefore._element);
    else oParent._element.appendChild(this._element);
    this._created = true;
    this._createChildren(oParent._document, false);
    this.invalidateParentLayout();
    this.dispatchEvent(CimsComponent._createEvent);
};

_p._removeHtmlElement = function (oChild)
{
    oChild._removeHtmlElementFromParent(this);
};

_p._removeHtmlElementFromParent = function (oParent)
{
    if (this._created &&!(application && application._disposed))oParent._element.removeChild(this._element);
};

_p._oninlineevent = function (e)
{
    if (this._disposed)return;
    if (!e)e = this._document.parentWindow.event;
    switch (e.type)
        {
        case "losecapture":
            this._capture = false;
            this.getTopLevelComponent()._eventManager.setCaptureComponent(null);
            break;
        case "focus":
            if (this.getCanFocus())this.getTopLevelComponent()._eventManager._mozOnFocus(e, this, this._element);
            return;
        case "propertychange":
            if (e.propertyName == "onpropertychange")return;
            break;
    }
    this.dispatchEvent(new CimsEvent(e.type));
    application.flushLayoutQueue();
};

_p.dispose = function ()
{
    if (this._disposed)return;
    CimsEventTarget.prototype.dispose.call(this);
    this.setCommand(null);
    var cs = this._children;
    for (var i = cs.length - 1; i >= 0; i--)cs[i].dispose(); if (this._border != CimsComponent.prototype._border)this._border.dispose(); this._border = null; var el = this._element; if (el)
    {
        el._biComponent = null;
        el.onscroll = el.onfocus = el.onlosecapture = null;
    }
    this.__oninlineevent = null;
    this._document = null;
    this._style = null;
    this._htmlProperties = null;
    this._children = null;
    this._parent = null;
    this._element = null;
    this._created = false;
};

_p.addXmlNode = function (oNode, oParser)
{
    if (oNode.nodeType == 1)
    {
        var c = oParser.fromNode(oNode);
        if (c instanceof CimsComponent)this.add(c);
    }
};

_p.setAttribute = function (sName, sValue, oParser)
{
    switch (sName)
        {
        case "border":
            if (sValue.charAt(0) == "#")
            {
                sValue = sValue.substr(1);
                var b = oParser.getComponentById(sValue);
                this.setBorder(b);
            }
            else this.setBorder(CimsBorder.fromString(sValue));
            break;
        case "contextMenu":
        case "toolTip":
        case "command":
            if (sValue.charAt(0) == "#")sValue = sValue.substr(1);
            var ref = oParser.getComponentById(sValue);
            this.setProperty(sName, ref);
            break;
        case "margin":
            var parts = sValue.split(/\s+/).map(parseFloat);
            this.setMargin.apply(this, parts);
            break;
            default : CimsEventTarget.prototype.setAttribute.apply(this, arguments);
    }
};

_p._command = null;
CimsComponent.prototype.getCommand = function ()
{
    return this._command;
};

_p.setCommand = function (oCommand)
{
    if (this._command != oCommand)
    {
        if (this._command)
        {
            this._command.removeEventListener("enabledchanged", this._syncWithCommmand, this);
            this._command.removeEventListener("checkedchanged", this._syncWithCommmand, this);
            this._command.removeEventListener("uservaluechanged", this._syncWithCommmand, this);
            this._command.removeEventListener("shortcutchanged", this._syncWithCommmand, this);
        }
        this._command = oCommand;
        if (this._command)
        {
            this._syncWithCommmand();
            this._command.addEventListener("enabledchanged", this._syncWithCommmand, this);
            this._command.addEventListener("checkedchanged", this._syncWithCommmand, this);
            this._command.addEventListener("uservaluechanged", this._syncWithCommmand, this);
            this._command.addEventListener("shortcutchanged", this._syncWithCommmand, this);
        }
    }
};

_p._syncWithCommmand = function ()
{
    if (this._command)
    {
        this.setEnabled(this._command.getEnabled());
    }
};

_p.setDropDataTypes = function (aDataTypes)
{
    this._dropDataTypes = aDataTypes;
};

_p.getDropDataTypes = function ()
{
    return this._dropDataTypes || [];
};

_p.setCssClassName = function (s)
{
    this._cssClassName = s;
    this.setHtmlProperty("className", s + application.getThemeManager().getAppearanceTag(this));
};

_p.getCssClassName = function ()
{
    return this._cssClassName;
};

_p.setAppearance = function (sName)
{
    this._appearance = sName;
    var tm = application.getThemeManager();
    tm.setAppearance(this, sName);
    tm.addAppearance(this);
};

_p.getAppearance = function ()
{
    return this._appearance;
};

CimsComponent.invalidateAll = function ()
{
    var allElements;
    if (CimsBrowserCheck.ie)allElements = document.all;
    else allElements = document.getElementsByTagName("*");
    var l = allElements.length;
    var allComponents = [];
    var i;
    for (i = 0; i < l; i++)
    {
        if (allElements[i]._biComponent && allElements[i]._biComponent instanceof CimsComponent &&!allElements[i]._biComponent.getDisposed())
        {
            allComponents.push(allElements[i]._biComponent);
        }
    }
    l = allComponents.length;
    for (i = 0; i < l; i++)
    {
        allComponents[i]._invalidLayout = true;
        allComponents[i]._invalidBoundaries = true;
        CimsComponent.enqueueLayout(allComponents[i]);
    }
};



//////////////////
// CimsInlineComponent
//////////////////
function CimsInlineComponent(sId)
{
    if (_inPrototype)return;
    CimsComponent.call(this);
    this._inlineId = sId;
    this.setCssClassName("bi-inline-component");
}
_p = _mExtend(CimsInlineComponent, CimsComponent, "CimsInlineComponent");
_p._create = function (oDocument)
{
    this._document = oDocument || document;
    var el = this._element = this._document.getElementById(this._inlineId);
    if (!el)throw new Error("CimsInlineComponent, could not find element in page");
    el._biComponent = this;
    this._setHtmlProperties();
    this._setCssProperties();
    if (CimsBrowserCheck.ie)el.onscroll = el.onresize = CimsComponent.__oninlineevent;
    else 
    {
        this._setHtmlAttributes();
        el.onscroll = el.onfocus = CimsComponent.__oninlineevent;
    }
};

_p._addHtmlElementToParent = function (oParent, oBefore, bLayout)
{
    if (bLayout == null)bLayout = true;
    if (!this._created)this._create(oParent._document);
    this._created = true;
    this._createChildren(oParent._document, false);
    this.invalidateParentLayout();
    this.dispatchEvent(CimsComponent._createEvent);
};

_p._removeHtmlElementFromParent = function (oParent)
{
};

CimsInlineComponent.prototype.getInlineId = function ()
{
    return this._inlineId;
};

CimsInlineComponent.prototype.setInlineId = function (v)
{
    this._inlineId = v;
};

_p.layoutComponent = function ()
{
    CimsComponent.prototype.layoutComponent.call(this);
    this.layoutAllChildren();
};




//////////////////
// CimsApplicationWindow
//////////////////
function CimsApplicationWindow()
{
    if (_inPrototype)return;
    CimsComponent.call(this);
    this.removeHtmlProperty("className");
    this.removeHtmlProperty("id");
    this.setRightToLeft(false);
    this._shownDialogs = [];
    this._commands = 
    {
    }
    ;
    this._eventManager = new CimsEventManager;
    this._focusManager = new CimsFocusManager;
    this._glassPane = new CimsComponent;
    this._glassPane.setCssClassName("bi-glass-pane");
    this._glassPane.setLocation(0, 0);
    this._glassPane.setRight(0);
    this._glassPane.setBottom(0);
    this.addEventListener("keydown", this._ondefaultbuttonkeydown);
    this.addEventListener("keydown", this._onkeyevent);
    this.addEventListener("keypress", this._onkeyevent);
};

_p = _mExtend(CimsApplicationWindow, CimsComponent, "CimsApplicationWindow");
_p._diff = null;
_p._insets = null;
_p._insetLeft = 4;
_p._insetRight = 4;
_p._insetTop = 30;
_p._insetBottom = 4;
_p._lastActive = null;
_p._activeComponent = null;
_p._globalCursor = null;
_p.setLeft = function (nLeft)
{
    this._window.moveTo(nLeft, this.getTop());
};

_p.setRight = function (nRight)
{
    this.setLeft(this._window.screen.width - this.getWidth() - nRight);
};

_p.getScreenLeft = _p.getLeft = function ()
{
    if (CimsBrowserCheck.ie)return this._window.screenLeft - this._getInsets().left;
    else return this._window.screenX;
};

_p.getRight = function ()
{
    return this._window.screen.width - this.getLeft() - this.getWidth();
};

_p.setTop = function (nTop)
{
    this._window.moveTo(this.getLeft(), nTop);
};

_p.setBottom = function (nBottom)
{
    this.setTop(this._window.screen.height - this.getHeight() - nBottom);
};

_p.setLocation = function (nLeft, nTop)
{
    this._window.moveTo(nLeft, nTop);
};

_p.getScreenTop = _p.getTop = function ()
{
    if (CimsBrowserCheck.ie)return this._window.screenTop - this._getInsets().top;
    else return this._window.screenY;
};

_p.getBottom = function ()
{
    return this._window.screen.height - this.getTop() - this.getHeight();
};

_p.setWidth = function (nWidth)
{
    if (CimsBrowserCheck.ie)this._window.resizeTo(nWidth, this.getHeight());
    else this._window.outerWidth = nWidth;
};

_p.getWidth = function ()
{
    if (CimsBrowserCheck.ie)return this._getSize().width;
    else return this._window.outerWidth;
};

_p.setHeight = function (nHeight)
{
    if (CimsBrowserCheck.ie)this._window.resizeTo(this.getWidth(), nHeight);
    else this._window.outerHeight = nHeight;
};

_p.setSize = function (nWidth, nHeight)
{
    this._window.resizeTo(nWidth, nHeight);
};

_p.getHeight = function ()
{
    if (CimsBrowserCheck.ie)return this._getSize().height;
    else return this._window.outerHeight;
};

_p.getInsetLeft = function ()
{
    return this._getInsets().left + CimsComponent.prototype.getInsetLeft.call(this);
};

_p.getInsetRight = function ()
{
    return this.getWidth() - this.getInsetLeft() - this.getClientWidth();
};

_p.getInsetTop = function ()
{
    return this._getInsets().top + CimsComponent.prototype.getInsetTop.call(this);
};

_p.getInsetBottom = function ()
{
    return this.getHeight() - this.getInsetTop() - this.getClientHeight();
};

_p.getClientLeft = function ()
{
    return -this.getInsetLeft();
};

_p.getClientTop = function ()
{
    return - this.getInsetTop();
};

_p._getScreenClientArea = function ()
{
    if (CimsBrowserCheck.ie)
		return {left : this._window.screenLeft, top : this._window.screenTop, width : this._element.clientWidth, height : this._element.clientHeight};
    else 
    {
        var bo = this._document.getBoxObjectFor(this._document.documentElement);
        return {left : bo.screenX, top : bo.screenY, width : this._element.clientWidth, height : this._element.clientHeight};
    }
};

_p.setZIndex = _p.getZIndex = _p.setVisible = _p.getVisible = function ()
{
    throw new Error("Not supported");
};

_p.getTopLevelComponent = function ()
{
    return this;
};

_p.getIsVisible = function ()
{
    return true;
};

_p.getCaption = function ()
{
    return this._window.document.title;
};

_p.setCaption = function (sTitle)
{
    this._window.document.title = sTitle;
};

_p.getFullScreen = function ()
{
    throw new Error("Not yet implemented");
};

_p.getResizable = function ()
{
    throw new Error("Not yet implemented");
};

_p.close = function ()
{
    this._window.close();
};

_p.print = function ()
{
    this._window.print();
};

_p.isFocusRoot = function ()
{
    return true;
};

_p.getFocusRoot = function ()
{
    return this;
};

_p.getActiveComponent = function ()
{
    if (this._activeComponent && this._activeComponent.getDisposed())this._activeComponent = null;
    return this._activeComponent;
};

CimsApplicationWindow.prototype.getAcceptButton = function ()
{
    return this._acceptButton;
};

CimsApplicationWindow.prototype.setAcceptButton = function (v)
{
    this._acceptButton = v;
};

CimsApplicationWindow.prototype.getCancelButton = function ()
{
    return this._cancelButton;
};

CimsApplicationWindow.prototype.setCancelButton = function (v)
{
    this._cancelButton = v;
};

_p.addCommand = function (c)
{
    if (c.getOwnerWindow())c.getOwnerWindow().removeCommand(c);
    this._commands[c.toHashCode()] = c;
    c._ownerWindow = this;
};

_p.removeCommand = function (c)
{
    delete this._commands[c.toHashCode()];
    c._ownerWindow = null;
};

_p.updateGlassPane = function (oDialog, bVisible)
{
    this._shownDialogs.remove(oDialog);
    if (bVisible)
    {
        this.add(this._glassPane, oDialog);
        this._glassPane.setZIndex(oDialog.getZIndex());
        if (CimsBrowserCheck.moz)
        {
            oDialog.setZIndex(oDialog.getZIndex() + 1);
        }
        this._shownDialogs.push(oDialog);
    }
    else
    {
        if (this._shownDialogs.length == 0)this.remove(this._glassPane);
        else
        {
            var d = this._shownDialogs[this._shownDialogs.length - 1];
            this._glassPane.setZIndex(d.getZIndex());
            d.setActive(true);
        }
    }
};

_p.setGlassPaneVisible = function (b)
{
    var gp = this._glassPane;
    if (b)
    {
        this.add(gp);
        var cs = this._children;
        var max = 0;
        for (var i = 0; i < cs.length; i++)
        {
            max = Math.max(max, cs[i].getZIndex());
        }
        gp.setZIndex(max + 1);
        gp.setTabIndex(1);
        gp.setHideFocus(true);
        gp.getFocusRoot = function ()
        {
            return this;
        }
        ;
        gp.isFocusRoot = function ()
        {
            return true;
        }
        ;
        gp.setFocused(true);
    }
    else
    {
        if (this._shownDialogs.length == 0)
        {
            if (gp._parent == this)
            {
                this.remove(gp);
                gp.setZIndex(0);
                gp.setTabIndex( - 1);
                gp.getFocusRoot = function ()
                {
                    return this._parent;
                }
                ;
                gp.isFocusRoot = function ()
                {
                    return false;
                }
                ;
            }
        }
    }
};

_p.getGlassPaneVisible = function ()
{
    return this._glassPane.getVisible();
};

CimsApplicationWindow.prototype.getGlobalCursor = function ()
{
    return this._globalCursor;
};

_p.setGlobalCursor = function (sCursor)
{
    this._globalCursor = sCursor;
    var tm = application.getThemeManager();
    if (sCursor == null || sCursor == "")
    {
        tm.removeCssRule("*");
        tm.removeCssRule("");
    }
    else
    {
        tm.addCssRule("*", "cursor:" + sCursor + " !important");
    }
};

_p.getAllowBrowserContextMenu = function ()
{
    return this._eventManager.getAllowBrowserContextMenu();
};

_p.setAllowBrowserContextMenu = function (b)
{
    return this._eventManager.setAllowBrowserContextMenu(b);
};

_p._create = function (oWindow)
{
    this._window = oWindow || window;
    this._document = this._window.document;
    var el = this._element = this._document.body;
    el._biComponent = this;
    this._window._biComponent = this;
    this._document.documentElement._biComponent = this;
    this._eventManager.attachToWindow(this._window);
    this._setHtmlProperties();
    this._setCssProperties();
    if (CimsBrowserCheck.ie)el.onscroll = CimsComponent.__oninlineevent;
    else 
    {
        this._setHtmlAttributes();
        el.onscroll = el.onfocus = CimsComponent.__oninlineevent;
    }
    this._created = true;
    var cs = this._children;
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        cs[i]._addHtmlElementToParent(this);
    }
};

_p.dispose = function ()
{
    if (this.getDisposed())return;
    CimsComponent.prototype.dispose.call(this);
    if (this._cursorStyleEl)
    {
        this._cursorStyleEl.disabled = true;
        this._cursorStyleEl.cssText = "";
        this._cursorStyleEl = null}
    for (var i = this._shownDialogs.length - 1; i >= 0; i--)this._shownDialogs[i] = null; this._shownDialogs = null; for (var c in this._commands)delete this._commands; this._commands = null; this._glassPane.dispose(); this._window.document.documentElement._biComponent = null; this._window._biComponent = null; this._window = null; };

_p._invalidBoundaries = false;
_p._onresize = function (e)
{
    var b = this._window.document.body;
    var newW = b.offsetWidth;
    var newH = b.offsetHeight;
    if (this._lastResizeW != newW || this._lastResizeH != newH)
    {
        this._lastResizeW = newW;
        this._lastResizeH = newH;
        (new CimsPopupManager).hideAutoHiding();
        this.invalidateLayout();
        this.dispatchEvent(new CimsEvent("resize"));
    }
};

_p._onkeyevent = function (e)
{
    this._focusManager.processKeyEvent(this, e);
};

_p._ondefaultbuttonkeydown = function (e)
{
    var c;
    for (var hc in this._commands)
    {
        c = this._commands[hc];
        if (c.getEnabled() && c.matchesKeyboardEvent(e))
        {
            if (!c.execute())e.preventDefault();
        }
    }
    var t = e.getTarget();
    switch (e.getKeyCode())
        {
        case CimsKeyboardEvent.ENTER:
            if (this._acceptButton && this._acceptButton.getEnabled() &&!t._acceptsEnter &&!e.getAltKey())
            {
                this._acceptButton.dispatchEvent(new CimsEvent("action"));
                if (this._acceptButton.getCommand())
                {
                    this._acceptButton.getCommand().execute()}
            }
            break;
        case CimsKeyboardEvent.ESC:
            if (this._cancelButton && this._cancelButton.getEnabled() &&!t._acceptsEsc)
            {
                this._cancelButton.dispatchEvent(new CimsEvent("action"));
                if (this._cancelButton.getCommand())
                {
                    this._cancelButton.getCommand().execute()}
            }
            break;
    }
};

_p._getSize = function ()
{
    var oldInnerSize = this._getInnerSize();
    if (this._diff == null)this._diff = 
    {
        width : Number(this._insetLeft) + Number(this._insetRight), height : Number(this._insetTop) + Number(this._insetBottom)}
    ;
    this._window.resizeTo(oldInnerSize.width + this._diff.width, oldInnerSize.height + this._diff.height);
    var newInnerSize = this._getInnerSize();
    var diff = 
    {
        width : oldInnerSize.width - newInnerSize.width + this._diff.width, height : oldInnerSize.height - newInnerSize.height + this._diff.height}
    ;
    this._window.resizeTo(oldInnerSize.width + diff.width, oldInnerSize.height + diff.height);
    this._diff = diff;
    return {width : oldInnerSize.width + diff.width, height : oldInnerSize.height + diff.height};
};

_p._getInnerSize = function ()
{
    return {width : this.getClientWidth(), height : this.getClientHeight()};
};

_p._getInsets = function ()
{
    if (CimsBrowserCheck.ie)
    {
        var oldScreenLeft = this._window.screenLeft;
        var oldScreenTop = this._window.screenTop;
        if (this._insets == null)this._insets = 
        {
            left : Number(this._insetLeft), top : Number(this._insetTop)}
        ;
        this._window.moveTo(oldScreenLeft - this._insets.left, oldScreenTop - this._insets.top);
        var newScreenLeft = this._window.screenLeft;
        var newScreenTop = this._window.screenTop;
        var res = 
        {
            left : newScreenLeft - oldScreenLeft + this._insets.left, top : newScreenTop - oldScreenTop + this._insets.top}
        ;
        this._window.moveTo(oldScreenLeft - res.left, oldScreenTop - res.top);
        return this._insets = res;
    }
    else 
    {
        var bo = this._document.getBoxObjectFor(this._document.documentElement);
        return { left : bo.screenX - this._window.screenX, top : bo.screenY - this._window.screenY};
    }
};


//////////////////
// CimsFocusManager
//////////////////
function CimsFocusManager()
{
};

_p = _mExtend(CimsFocusManager, CimsObject, "CimsFocusManager");
_p.compareTabOrder = function (c1, c2)
{
    if (c1 === c2)return 0;
    var t1 = c1.getTabIndex();
    var t2 = c2.getTabIndex();
    if (t1 != t2)return t1 - t2;
    var y1 = c1.getScreenTop();
    var y2 = c2.getScreenTop();
    if (y1 != y2)return y1 - y2;
    var x1 = c1.getScreenLeft();
    var x2 = c2.getScreenLeft();
    if (x1 != x2)return x1 - x2;
    var z1 = c1.getZIndex();
    var z2 = c2.getZIndex();
    if (z1 != z2)return z1 - z2;
    return 0;
};

_p.getComponentAfter = function (oContainer, oComponent)
{
    if (oContainer == oComponent)return this.getFirstComponent(oContainer);
    if (oComponent._anonymous)oComponent = oComponent.getParent();
    var out = 
    {
    }
    ;
    this._getAfter(oContainer, oComponent, out);
    return out.value || this.getFirstComponent(oContainer);
};

_p.getComponentBefore = function (oContainer, oComponent)
{
    if (oContainer == oComponent)return this.getLastComponent(oContainer);
    if (oComponent._anonymous)oComponent = oComponent.getParent();
    var out = 
    {
    }
    ;
    this._getBefore(oContainer, oComponent, out);
    return out.value || this.getLastComponent(oContainer);
};

_p.processKeyEvent = function (oContainer, e)
{
    if (e.getKeyCode() == CimsKeyboardEvent.TAB && (CimsBrowserCheck.moz && e.getType() == "keypress" || CimsBrowserCheck.ie && e.getType() == "keydown"))
    {
        if (e.getDefaultPrevented())return;
        e.preventDefault();
        e.stopPropagation();
        var current = oContainer.getActiveComponent();
        var next;
        if (!e.getShiftKey())
        {
            if (current)next = this.getComponentAfter(oContainer, current);
            else next = this.getFirstComponent(oContainer);
        }
        else 
        {
            if (current)next = this.getComponentBefore(oContainer, current);
            else next = this.getLastComponent(oContainer);
        }
        if (next)
        {
            if (current)
            {
                if (CimsBrowserCheck.moz)
                {
                    current._blurComponent();
                }
                if (typeof current._deselectOnTabBlur == "function")current._deselectOnTabBlur();
            }
            next.setFocused(true);
            next._focusComponent();
            if (typeof next._selectOnTabFocus == "function")next._selectOnTabFocus();
        }
    }
};

_p.getFirstComponent = function (oContainer)
{
    return this._getFirst(oContainer, null);
};

_p.getLastComponent = function (oContainer)
{
    return this._getLast(oContainer, null);
};

_p._getAfter = function (oCont, oComp, oRes)
{
    var cs = oCont.getTabChildren();
    var l = cs.length;
    var c = oRes.value;
    for (var i = 0; i < l; i++)
    {
        if (cs[i].getCanFocus() && cs[i].getTabIndex() > 0 && this.compareTabOrder(oComp, cs[i]) < 0)
        {
            if (!c || this.compareTabOrder(cs[i], c) < 0)
            {
                oRes.value = c = cs[i];
            }
        }
        if (cs[i].hasChildren() &&!cs[i].isFocusRoot())
        {
            this._getAfter(cs[i], oComp, oRes);
            c = oRes.value;
        }
    }
};

_p._getBefore = function (oCont, oComp, oRes)
{
    var cs = oCont.getTabChildren();
    var l = cs.length;
    var c = oRes.value;
    for (var i = 0; i < l; i++)
    {
        if (cs[i].getCanFocus() && cs[i].getTabIndex() > 0 && this.compareTabOrder(oComp, cs[i]) > 0)
        {
            if (!c || this.compareTabOrder(cs[i], c) > 0)
            {
                oRes.value = c = cs[i];
            }
        }
        if (cs[i].hasChildren() &&!cs[i].isFocusRoot())
        {
            this._getBefore(cs[i], oComp, oRes);
            c = oRes.value;
        }
    }
};

_p._getFirst = function (oCont, oFirst)
{
    var cs = oCont.getTabChildren();
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        if (!(cs[i]instanceof CimsComponent))continue;
        if (cs[i].getCanFocus() && cs[i].getTabIndex() > 0)
        {
            if (oFirst == null || this.compareTabOrder(cs[i], oFirst) < 0)oFirst = cs[i];
        }
        if (!cs[i].isFocusRoot())oFirst = this._getFirst(cs[i], oFirst);
    }
    return oFirst;
};

_p._getLast = function (oCont, oLast)
{
    var cs = oCont.getTabChildren();
    var l = cs.length;
    for (var i = 0; i < l; i++)
    {
        if (!(cs[i]instanceof CimsComponent))continue;
        if (cs[i].getCanFocus() && cs[i].getTabIndex() > 0)
        {
            if (oLast == null || this.compareTabOrder(cs[i], oLast) > 0)oLast = cs[i];
        }
        if (!cs[i].isFocusRoot())oLast = this._getLast(cs[i], oLast);
    }
    return oLast;
};


//////////////////
// CimsFont
//////////////////
function CimsFont(nSize, sName)
{
    if (_inPrototype)return;
    CimsObject.call(this);
    if (nSize != null)this._size = nSize;
    if (sName != null)this._name = sName;
}
_p = _mExtend(CimsFont, CimsObject, "CimsFont");
CimsFont.prototype.getSize = function ()
{
    return this._size;
};

CimsFont.prototype.setSize = function (v)
{
    this._size = v;
};

CimsFont.prototype.getBold = function ()
{
    return this._bold;
};

CimsFont.prototype.setBold = function (v)
{
    this._bold = v;
};

CimsFont.prototype.getItalic = function ()
{
    return this._italic;
};

CimsFont.prototype.setItalic = function (v)
{
    this._italic = v;
};

CimsFont.prototype.getUnderline = function ()
{
    return this._underline;
};

CimsFont.prototype.setUnderline = function (v)
{
    this._underline = v;
};

CimsFont.prototype.getStrikeout = function ()
{
    return this._strikeout;
};

CimsFont.prototype.setStrikeout = function (v)
{
    this._strikeout = v;
};

CimsFont.prototype.getName = function ()
{
    return this._name;
};

CimsFont.prototype.setName = function (v)
{
    this._name = v;
};

_p.paintFont = function (oComponent)
{
    if (this._name)oComponent.setStyleProperty("fontFamily", this._name);
    if (this._size != null)oComponent.setStyleProperty("fontSize", this._size + "px");
    if (this._bold != null)oComponent.setStyleProperty("fontWeight", this._bold ? "bold" : "normal");
    if (this._italic != null)oComponent.setStyleProperty("fontStyle", this._italic ? "italic" : "normal");
    var td = null;
    if (this._underline == false && this._strikeout == false)td = "none";
    else if (this._underline != null || this._strikeout != null)
    {
        td = (this._underline ? "underline" : "") + (this._strikeout ? " line-through" : "");
    }
    if (td != null)oComponent.setStyleProperty("textDecoration", td);
};

_p.removeFont = function (oComponent)
{
    oComponent.removeStyleProperty("fontFamily");
    oComponent.removeStyleProperty("fontSize");
    oComponent.removeStyleProperty("fontWeight");
    oComponent.removeStyleProperty("fontStyle");
    oComponent.removeStyleProperty("textDecoration");
};

CimsFont.fromString = function (s)
{
    var f = new CimsFont;
    var parts = s.split(/\s+/);
    var nameSb = [];
    var part;
    for (var i = 0; i < parts.length; i++)
    {
        part = parts[i];
        switch (part)
            {
            case "bold":
                f.setBold(true);
                break;
            case "italic":
                f.setItalic(true);
                break;
            case "underline":
                f.setUnderline(true);
                break;
            case "strikeout":
                f.setStrikeout(true);
                break;
                default : var n = parseFloat(part);
                if (n == part || part.indexOf("px") !=  - 1)f.setSize(n);
                else nameSb.push(part);
                break;
        }
    }
    if (nameSb.length > 0)f.setName(nameSb.join(" "));
    return f;
};


//////////////////
// CimsImagePreloaderManager
//////////////////
function CimsImagePreloaderManager()
{
    if (_inPrototype)return;
    if (CimsImagePreloaderManager._singleton)return CimsImagePreloaderManager._singleton;
    CimsObject.call(this);
    this._imagePreloaders = 
    {
    }
    ;
    CimsImagePreloaderManager._singleton = this;
    application.addEventListener("dispose", this.dispose, this);
}
_p = _mExtend(CimsImagePreloaderManager, CimsObject, "CimsImagePreloaderManager");
_p.getPreloader = function (oUri)
{
    return this._imagePreloaders[String(oUri)];
};

_p.addPreloader = function (oImagePreloader)
{
    this._imagePreloaders[String(oImagePreloader._uri)] = oImagePreloader;
};

_p.hasPreloader = function (oUri)
{
    return this._imagePreloaders[String(oUri)] != null;
};

_p.dispose = function ()
{
    if (this._disposed)return;
    application.removeEventListener("dispose", this.dispose, this);
    for (var uri in this._imagePreloaders)
    {
        this._imagePreloaders[uri].dispose();
        delete this._imagePreloaders[uri];
    }
    CimsImagePreloaderManager._singleton = null;
};



//////////////////
// CimsImagePreloader
//////////////////
function CimsImagePreloader(oUri)
{
    if (_inPrototype)return;
    var man = new CimsImagePreloaderManager();
    var sUri = String(oUri);
    if (man.hasPreloader(sUri))return man.getPreloader(sUri);
    CimsEventTarget.call(this);
    this._uri = oUri;
    this._jsImage = new Image();
    this._jsImage._biImagePreloader = this;
    this._jsImage.onload = CimsImagePreloader.__onload;
    this._jsImage.onerror = CimsImagePreloader.__onerror;
    if (this._uri)this._jsImage.src = sUri;
    man.addPreloader(this);
}
_p = _mExtend(CimsImagePreloader, CimsEventTarget, "CimsImagePreloader");
_p._loaded = false;
CimsImagePreloader.__onload = function ()
{
    this._biImagePreloader._onload();
};

CimsImagePreloader.__onerror = function ()
{
    this._biImagePreloader._onerror();
};

_p.getWidth = function ()
{
    if (CimsBrowserCheck.moz)return this._jsImage.naturalWidth;
    else return this._jsImage.width;
};

_p.getHeight = function ()
{
    if (CimsBrowserCheck.moz)return this._jsImage.naturalHeight;
    else return this._jsImage.height;
};

_p.getLoaded = function ()
{
    if (CimsBrowserCheck.ie)return this._jsImage.readyState == "complete";
    else return this._loaded;
}
_p._isPng=function()
{
	return /\.png$/i.test(this._jsImage.nameProp);
};
_p.dispose = function ()
{
    if (this._disposed)return;
    CimsEventTarget.prototype.dispose.call(this);
    this._jsImage.onload = this._jsImage.onerror = null;
    this._jsImage._biImagePreloader = null;
    this._jsImage = null;
    this._uri = null;
    this._loaded = false;
};

_p._onload = function ()
{
    this._loaded = true;
    this.dispatchEvent(new CimsEvent("load"));
    application.flushLayoutQueue();
};

_p._onerror = function ()
{
    this._loaded = false;
    this.dispatchEvent(new CimsEvent("error"));
    application.flushLayoutQueue();
};



//////////////////
// CimsImage
//////////////////
function CimsImage(oUri, nWidth, nHeight)
{
    if (_inPrototype)return;
    CimsComponent.call(this);
    this.setHtmlProperty("src", CimsImage.BLANK_IMAGE_URI);
    this.setHtmlProperty("alt", "");
    this.setCanSelect(false);
    if (nWidth != null)this.setWidth(nWidth);
    if (nHeight != null)this.setHeight(nHeight);
    if (oUri)this.setUri(oUri);
}
_p = _mExtend(CimsImage, CimsComponent, "CimsImage");
CimsImage.BLANK_IMAGE_URI = application.getPath() + "images/blank.gif";
CimsImage.fromUri = function (oUri)
{
    return new CimsImage(oUri);
};

_p._uri = null;
_p._tagName = "IMG";
_p._width = null;
_p._height = null;
_p.setUri = function (oUri)
{
    if (this._uri != oUri)
    {
        if (this._imagePreloader)
        {
            this._imagePreloader.removeEventListener("load", this._onload, this);
            this._imagePreloader.removeEventListener("error", this._onerror, this);
        }
        if (oUri != null)
        {
            if (oUri instanceof CimsUri)this._uri = oUri;
            else this._uri = new CimsUri(application.getAdfPath(), oUri);
        }
        else this._uri = null;
        if (this._uri)
        {
            this._imagePreloader = new CimsImagePreloader(this._uri);
            if (this._imagePreloader.getLoaded())this._onload();
            else 
            {
                this._imagePreloader.addEventListener("load", this._onload, this);
                this._imagePreloader.addEventListener("error", this._onerror, this);
            }
        }
    }
};

CimsImage.prototype.getUri = function ()
{
    return this._uri;
};

_p.getPreferredWidth = function ()
{
    if (this._preferredWidth != null)return this._preferredWidth;
    if (this._imagePreloader)return this._imagePreloader.getWidth();
    throw new Error("No image file");
};

_p.getPreferredHeight = function ()
{
    if (this._preferredHeight != null)return this._preferredHeight;
    if (this._imagePreloader)return this._imagePreloader.getHeight();
    throw new Error("No image file");
};

_p.getWidth = function ()
{
    if (this._width != null && (this._left == null || this._right == null))
    {
        return this._width;
    }
    else 
    {
        if (!this._element || this._element.style.width == "")return this.getPreferredWidth();
        return CimsComponent.prototype.getWidth.call(this);
    }
};

_p.getHeight = function ()
{
    if (this._height != null && (this._top == null || this._bottom == null))
    {
        return this._height;
    }
    else 
    {
        if (!this._element || this._element.style.height == "")return this.getPreferredHeight();
        return CimsComponent.prototype.getHeight.call(this);
    }
};

_p.getLoaded = function ()
{
    if (this._imagePreloader)return this._imagePreloader.getLoaded();
    throw new Error("No image file");
};

_p.dispose = function ()
{
    if (this._disposed)return;
    if (this._imagePreloader)
    {
        this._imagePreloader.removeEventListener("load", this._onload, this);
        this._imagePreloader.removeEventListener("error", this._onerror, this);
    }
    this._imagePreloader = null;
    if (this._element)this._element.style.filter = "none";
    CimsComponent.prototype.dispose.call(this);
};



_p._create = function (oDocument)
{
    CimsComponent.prototype._create.call(this, oDocument);
    this._element.removeAttribute("width");
    this._element.removeAttribute("height");
};

_p._recreate = function ()
{
    if (!this._created || this._disposed)return;
    var el = this._element;
    if (!el ||!el.parentNode)return;
    if (el)
    {
        el._biComponent = null;
        el.onscroll = el.onresize = el.onlosecapture = null;
        el.style.filter = "";
    }
    this._create(this._document);
    if (el.parentNode)el.parentNode.replaceChild(this._element, el);
};

_p._onload = function ()
{
    if (CimsBrowserCheck.ie)
    {
        if (this._isPng())
        {
            var w = this._width;
            var h = this._height;
            this.setHtmlProperty("src", CimsImage.BLANK_IMAGE_URI);
            if (w == null)this.setStyleProperty("width", this.getPreferredWidth() + "px");
            if (h == null)this.setStyleProperty("height", this.getPreferredHeight() + "px");
            this._recreate();
            this.setStyleProperty("filter", "progid:DXImageTransform.Microsoft." + "AlphaImageLoader(src='" + this._uri + "',sizingMethod='scale')");
        }
        else 
        {
            this.removeStyleProperty("filter");
            this.setHtmlProperty("src", String(this._uri));
            if (this._width == "" || this._width == null)this.removeStyleProperty("width");
            if (this._height == "" || this._height == null)this.removeStyleProperty("height");
        }
    }
    else 
    {
        this.setHtmlProperty("src", String(this._uri));
    }
    if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
    this.dispatchEvent(new CimsEvent("load"));
};

_p._onerror = function ()
{
    this.dispatchEvent(new CimsEvent("error"));
};


_p._isPng = function ()
{
    if (this._imagePreloader)return this._imagePreloader._isPng();
    return false;
};

if (CimsBrowserCheck.ie)
{
    _p.setOpacity = function (n)
    {
        if (this._opacity != n)
        {
            this._opacity = n;
            var x = Math.max(0, Math.min(100, Math.round(n * 100)));
            var base = this._isPng() ? "progid:DXImageTransform.Microsoft." + "AlphaImageLoader(src='" + this._uri + "',sizingMethod='scale')" : "";
            if (x == 100)this.setStyleProperty("filter", base);
            else this.setStyleProperty("filter", "Alpha(Opacity=" + x + ") " + base);
        }
    }
    ;
}
_p.getIconHtml = function (bHasText, bEnabled, sIconPosition, nIconTextGap, sClassName)
{
    if (typeof bHasText != "boolean")
    {
        throw new Error("CimsImage getIconHtml has changed");
    }
    var w = this._width;
    var h = this._height;
    if (this.getLoaded())
    {
        if (w == null)w = this.getPreferredWidth();
        if (h == null)h = this.getPreferredHeight();
    }
    var marginSide, blockStyle = "";
    switch (sIconPosition)
        {
        case "right":
            marginSide = "left";
            break;
        case "top":
            marginSide = "bottom";
            blockStyle = "display:block;";
            break;
        case "bottom":
            marginSide = "top";
            blockStyle = "display:block;";
            break;
            default : marginSide = "right";
            break;
    }
    var iconTextGap = bHasText ? nIconTextGap : 0;
    if (CimsBrowserCheck.ie)
    {
        var isPng = this._isPng();
        var uri =!isPng ? this.getUri() : CimsImage.BLANK_IMAGE_URI;
        var imgFilter;
        if (isPng)
        {
            imgFilter = "filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + this.getUri() + "',sizingMethod='scale');";
            spanFilter = "filter:gray() alpha(opacity=50);";
        }
        else
        {
            imgFilter = bEnabled ? "" : "filter:gray() alpha(opacity=50);";
            spanFilter = "";
        }
        return "<span style=\"" + (!bEnabled && isPng ? spanFilter : "") + "width:1px;" + blockStyle + (h ? "height:" + (h + 1) + "px;" : "") + "\">" + "<img alt=\"\" src=\"" + uri + "\" style=\"vertical-align:middle;" + (w ? "width:" + w + "px;" : "") + (h ? "height:" + h + "px;" : "") + blockStyle + imgFilter + "margin-" + marginSide + ":" + iconTextGap + "px;\"" + (sClassName ? " class=\"" + sClassName + "\"" : "") + "></span>";
    }
    else 
    {
        var brBefore = sIconPosition == "bottom" && bHasText ? "<br>" : "";
        var brAfter = sIconPosition == "top" && bHasText ? "<br>" : "";
        return brBefore + "<img alt=\"\" src=\"" + this.getUri() + "\" style=\"vertical-align:middle;" + "width:" + w + "px;" + "height:" + h + "px;" + (!bEnabled ? "-moz-opacity:0.5;" : "") + "margin-" + marginSide + ":" + iconTextGap + "px;\"" + (sClassName ? " class=\"" + sClassName + "\"" : "") + ">" + brAfter;
    }
};



//////////////////
// CimsLabel
//////////////////
function CimsLabel(sText)
{
    if (_inPrototype)return;
    CimsComponent.call(this);
    if (sText)this._text = sText;
    this.setCssClassName("bi-label");
    this.setCanSelect(false);
    this.setWrap(false);
};

_p = _mExtend(CimsLabel, CimsComponent, "CimsLabel");
_p._labelFor = null;
_p._text = "";
_p._html = null;
_p._realHtml = null;
_p._realText = null;
_p._mnemonic = null;
_p._icon = null;
_p._drawIcon = false;
_p._iconPosition = "left";
_p._iconTextGap = 3;
_p._labelFor = null;
if (!CimsBrowserCheck.moz)_p._tagName = "LABEL";
CimsLabel.htmlToText = function (s)
{
    return String(s).replace(/\s+|<([^>])+>|&amp;|&lt;|&gt;|&quot;|&nbsp;|&#[0-9]+;|&#x[0-9a-fA-F];]/gi, CimsLabel._htmlToText);
};

CimsLabel._htmlToText = function (s)
{
    switch (s)
        {
        case "&amp;":
            return "&";
        case "&lt;":
            return "<";
        case "&gt;":
            return ">";
        case "&quot;":
            return "\"";
        case "&nbsp;":
            return String.fromCharCode(160);
            default : if (s.substring(0, 3) == "&#x")
            {
                return String.fromCharCode(parseInt("0x" + s.substring(3, s.length - 1)));
            }
            if (s.substring(0, 2) == "&#")
            {
                return String.fromCharCode(s.substring(2, s.length - 1));
            }
            if (/\s+/.test(s))return " ";
            if (/^<BR/gi.test(s))return "\n";
            return "";
    }
};

CimsLabel.textToHtml = function (s)
{
    return String(s).replace(/&|<|>|\n|\u00A0/g, CimsLabel._textToHtml);
};

CimsLabel._textToHtml = function (s)
{
    switch (s)
        {
        case "&":
            return "&amp;";
        case "<":
            return "&lt;";
        case ">":
            return "&gt;";
        case "\n":
            return "<BR>";
            default : return "&nbsp;";
    }
};

CimsLabel._textToHtml2 = function (s)
{
    return String(s).replace(/&|<|>|\u00A0/g, CimsLabel._textToHtml);
};

_p.setText = function (sText)
{
    this._text = String(sText);
    this._html = null;
    this._setHtml();
};

_p.getText = function ()
{
    if (this._text != null)return this._text;
    if (this._html != null)
    {
        return CimsLabel.htmlToText(this._html);
    }
    return "";
};

_p.setHtml = function (sHtml)
{
    this._html = String(sHtml);
    this._text = null;
    this._setHtml();
};

_p.getHtml = function ()
{
    if (this._html != null)return this._html;
    if (this._text != null)
    {
        return CimsLabel.textToHtml(this._text);
    }
    return "";
};

_p._setHtml = function ()
{
    if (!this._created)return;
    var el;
    if (CimsBrowserCheck.ie && this._html == null &&!this._drawIcon && this._mnemonic == null)
    {
        if (this._realText == this._text)return;
        this._realHtml = null;
        this._realText = this._text;
        el = this._element;
        if (!this.hasChildren())el.innerText = this._text;
        else 
        {
            while (el.firstChild != this.getFirstChild()._element)el.removeChild(el.firstChild);
            el.insertAdjacentText("AfterBegin", this._text);
        }
    }
    else 
    {
        var iconBefore = this._iconPosition == "left" || this._iconPosition == "top";
        var sHtml = this._html != null ? this._html : (this._text != null ? CimsLabel.textToHtml(this._text) : "");
        if (this._mnemonic)sHtml = CimsLabel.addMnemonic(sHtml, this._mnemonic);
        var s = (iconBefore ? this._getIconHtml() : "") + sHtml + (!iconBefore ? this._getIconHtml() : "");
        if (this._realHtml == s)return;
        this._realHtml = s;
        this._realText = null;
        el = this._element;
        if (!this.hasChildren())el.innerHTML = s;
        else 
        {
            while (el.firstChild && el.firstChild != this.getFirstChild()._element)el.removeChild(el.firstChild);
            if (CimsBrowserCheck.ie)el.insertAdjacentHTML("AfterBegin", s);
            else 
            {
                var r = this._document.createRange();
                r.selectNodeContents(el);
                r.collapse(true);
                var df = r.createContextualFragment(s);
                el.insertBefore(df, el.firstChild);
                el.normalize();
            }
        }
        if (CimsBrowserCheck.moz)
        {
            this._mozForceReflow();
        }
    }
    if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
};

_p._mozForceReflow = function ()
{
    var el = this._element;
    var style = el.style;
    if (this._height != null || this._top != null && this._bottom != null)
    {
        return;
    }
    if (this._iconPosition == "top" || this._iconPosition == "bottom" || style.paddingLeft || style.paddingRight || style.paddingTop || style.paddingBottom || style.padding || style.textAlign)
    {
        var s = el.offsetHeight;
        var of = style.overflow;
        style.overflow = "visible";
        style.overflow = of;
    }
};

CimsLabel.addMnemonic = function (sHtml, sMnemonic)
{
    if (!sHtml ||!sMnemonic)return sHtml;
    var re = new RegExp("^(((<([^>]|" + sMnemonic + ")+>)|(&([^;]|" + sMnemonic + ")+;)|[^&" + sMnemonic + "])*)(" + sMnemonic + ")", "i");
    if (re.test(sHtml))
    {
        return RegExp.$1 + "<span class=\"mnemonic\">" + RegExp.$7 + "</span>" + RegExp.rightContext;
    }
    else 
    {
        return sHtml + "(<span class=\"mnemonic\">" + sMnemonic + "</span>)";
    }
};

_p.setMnemonic = function (sMnemonic)
{
    if (this._mnemonic != sMnemonic)
    {
        this._mnemonic = sMnemonic;
        this._setHtml();
    }
};

CimsLabel.prototype.getMnemonic = function ()
{
    return this._mnemonic;
};

_p.setFont = function (oFont)
{
    if (this._font)this._font.removeFont(this);
    this._font = oFont;
    if (oFont)oFont.paintFont(this);
    if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
};

_p.getFont = function ()
{
    return this._font ? this._font : new CimsFont;
};

_p.setLabelFor = function (oComponent)
{
    this._labelFor = oComponent;
    this.setHtmlProperty("htmlFor", oComponent == null ? "" : oComponent.getHtmlProperty("id"));
};

CimsLabel.prototype.getLabelFor = function ()
{
    return this._labelFor;
};

_p.setWrap = function (bWrap)
{
    this._wrap = bWrap;
    this.setStyleProperty("whiteSpace", bWrap ? "normal" : "nowrap");
    if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
};

_p.getWrap = function ()
{
    return this._wrap;
};

if (CimsBrowserCheck.ie)
{
    _p.setOverflowX = function (sOverflowX)
    {
        this.setStyleProperty("textOverflow", sOverflowX == "hidden" ? "ellipsis" : "clip");
        this.setStyleProperty("overflowX", sOverflowX);
    }
    ;
}
_p.setPadding = function (nLeft, nRight, nTop, nBottom)
{
    if (arguments.length == 1)
    {
        nRight = nTop = nBottom = nLeft;
    }
    else if (arguments.length == 2)
    {
        nTop = nBottom = nRight;
        nRight = nLeft;
    }
    this.setStyleProperty("paddingLeft", nLeft + "px");
    this.setStyleProperty("paddingRight", nRight + "px");
    this.setStyleProperty("paddingTop", nTop + "px");
    this.setStyleProperty("paddingBottom", nBottom + "px");
    if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
    this.invalidateLayout();
};

_p.setPaddingLeft = function (n)
{
    this._setPadding("paddingLeft", n);
};

_p.getPaddingLeft = function ()
{
    return parseInt(this.getStyleProperty("paddingLeft"));
};

_p.setPaddingRight = function (n)
{
    this._setPadding("paddingRight", n);
};

_p.getPaddingRight = function ()
{
    return parseInt(this.getStyleProperty("paddingRight"));
};

_p.setPaddingTop = function (n)
{
    this._setPadding("paddingTop", n);
};

_p.getPaddingTop = function ()
{
    return parseInt(this.getStyleProperty("paddingTop"));
};

_p.setPaddingBottom = function (n)
{
    this._setPadding("paddingBottom", n);
};

_p.getPaddingBottom = function ()
{
    return parseInt(this.getStyleProperty("paddingBottom"));
};

_p._setPadding = function (s, n)
{
    this.setStyleProperty(s, n + "px");
    if (!this.getHasFixedWidth() ||!this.getHasFixedHeight())this.invalidateParentLayout("size");
    this.invalidateLayout();
};

_p.setAlign = function (sAlign)
{
    if (sAlign)this.setStyleProperty("textAlign", sAlign);
    else this.removeStyleProperty("textAlign");
};

_p.getAlign = function ()
{
    return this.getStyleProperty("textAlign");
};

if (CimsBrowserCheck.ie)
{
    _p.getPreferredWidth = function ()
    {
        if (this._preferredWidth != null)return this._preferredWidth;
        if (!this._created)throw new Error("Visual property on non created component");
        var oldDisplay;
        var hidden = this._element.runtimeStyle.display == "none";
        if (hidden)
        {
            oldDisplay = this._element.runtimeStyle.display;
            this._element.runtimeStyle.display = "";
        }
        this._element.runtimeStyle.width = "auto";
        this._element.runtimeStyle.height = "auto";
        CimsComponent.flushLayoutComponent(this);
        var r = this._document.body.createTextRange();
        r.moveToElementText(this._element);
        var bcr = r.getBoundingClientRect();
        var res = bcr.right - bcr.left + this.getInsetLeft() + this.getPaddingLeft() + this.getInsetRight() + this.getPaddingRight();
        if (hidden)
        {
            this._element.runtimeStyle.display = oldDisplay;
        }
        this._element.runtimeStyle.width = "";
        this._element.runtimeStyle.height = "";
        return Math.max(0, res);
    }
    ;
    _p.getPreferredHeight = function ()
    {
        if (this._preferredHeight != null)return this._preferredHeight;
        if (!this._created)throw new Error("Visual property on non created component");
        var oldDisplay;
        var hidden = this._element.runtimeStyle.display == "none";
        if (hidden)
        {
            oldDisplay = this._element.runtimeStyle.display;
            this._element.runtimeStyle.display = "";
        }
        this._element.runtimeStyle.width = "auto";
        this._element.runtimeStyle.height = "auto";
        CimsComponent.flushLayoutComponent(this);
        var r = this._document.body.createTextRange();
        r.moveToElementText(this._element);
        var bcr = r.getBoundingClientRect();
        var res = bcr.bottom - bcr.top + this.getInsetTop() + this.getPaddingTop() + this.getInsetBottom() + this.getPaddingBottom();
        if (hidden)
        {
            this._element.runtimeStyle.display = oldDisplay;
        }
        this._element.runtimeStyle.width = "";
        this._element.runtimeStyle.height = "";
        return Math.max(0, res);
    }
    ;
}
_p.setIcon = function (oImage)
{
    if (this._icon != oImage)
    {
        if (this._icon instanceof CimsEventTarget)
        {
            this._icon.removeEventListener("load", this._oniconload, this);
        }
        this._icon = oImage;
        this._drawIcon = oImage != null;
        this._setHtml();
        if (this._icon instanceof CimsImage)
        {
            if (this._icon.getLoaded())this._oniconload();
            else this._icon.addEventListener("load", this._oniconload, this);
        }
    }
};

CimsLabel.prototype.getIcon = function ()
{
    return this._icon;
};

_p.setIconPosition = function (s)
{
    if (this._iconPosition != s)
    {
        this._iconPosition = s;
        this._setHtml();
    }
};

CimsLabel.prototype.getIconPosition = function ()
{
    return this._iconPosition;
};

_p.setIconTextGap = function (n)
{
    if (this._iconTextGap != n)
    {
        this._iconTextGap = n;
        this._setHtml();
    }
};

CimsLabel.prototype.getIconTextGap = function ()
{
    return this._iconTextGap;
};

_p.setEnabled = function (bEnabled)
{
    CimsComponent.prototype.setEnabled.call(this, bEnabled);
    this._setHtml();
};

_p._getIconHtml = function ()
{
    if (!this._icon)return "";
    else return this._icon.getIconHtml(!(this._html == "" || this._text == ""), this._enabled, this._iconPosition, this._iconTextGap);
};

_p._createChildren = function (oDocument, bLayout)
{
    this._setHtml();
    CimsComponent.prototype._createChildren.call(this, oDocument, bLayout);
};

_p.dispose = function ()
{
    this._labelFor = null;
    if (this._icon instanceof CimsEventTarget)
    {
        this._icon.removeEventListener("load", this._oniconload, this);
    }
    CimsComponent.prototype.dispose.call(this);
};

_p._oniconload = function ()
{
    this._setHtml();
};

_p.addXmlNode = function (oNode, oXmlResourceParser)
{
    var s;
    if (oNode.nodeType == 3)
    {
        s = oNode.nodeValue;
        if (oNode.parentNode.childNodes.length == 1)
        {
            if (!/^\s+$/.test(s))this.setText(s.trim());
        }
        else 
        {
            if (oNode == oNode.parentNode.firstChild && s.match(/^\s+/m))
            {
                s = s.replace(/^\s+/m, "");
            }
            else if (oNode == oNode.parentNode.lastChild && s.match(/\s+$/m))
            {
                s = s.replace(/\s+$/m, "");
            }
            if (s != "")
            {
                this.setHtml(this.getHtml() + CimsLabel._textToHtml2(s));
            }
        }
    }
    else if (oNode.nodeType == 1)
    {
        var xhtmlNs = "http://www.w3.org/1999/xhtml";
        var ns = oNode.namespaceURI;
        if (ns == xhtmlNs)
        {
            var prefix = oNode.prefix;
            s = oNode.xml.replace(new RegExp("<" + prefix + ":", "g"), "<").replace(new RegExp("</" + prefix + ":", "g"), "</");
            this.setHtml(this.getHtml() + s);
        }
        else 
        {
            CimsComponent.prototype.addXmlNode.call(this, oNode, oXmlResourceParser);
        }
    }
};

_p.setAttribute = function (sName, sValue, oXmlResourceParser)
{
    switch (sName)
        {
        case "icon":
            this.setIcon(CimsImage.fromUri(sValue));
            break;
        case "labelFor":
            if (sValue.charAt(0) == "#")sValue = sValue.substr(1);
            var c = oXmlResourceParser.getComponentById(sValue);
            this.setLabelFor(c);
            break;
        case "font":
            if (sValue.charAt(0) == "#")
            {
                sValue = sValue.substr(1);
                var f = oXmlResourceParser.getComponentById(sValue);
                this.setFont(f);
            }
            else this.setFont(CimsFont.fromString(sValue));
            break;
        case "padding":
            var parts = sValue.split(/\s+/);
        for (var i = 0; i < parts.length; i++)parts[i] = parseFloat(parts[i]); this.setPadding.apply(this, parts); break; default : CimsComponent.prototype.setAttribute.apply(this, arguments); }
};

//////////////////
// CimsDragEvent
//////////////////
function CimsDragEvent(sType, oMouseEvent)
{
    if (_inPrototype)return;
    CimsMouseEvent.call(this, sType, oMouseEvent && oMouseEvent._event);
    this._manager = new CimsDragAndDropManager;
}
_p = _mExtend(CimsDragEvent, CimsMouseEvent, "CimsDragEvent");
CimsDragEvent.prototype.getManager = function ()
{
    return this._manager;
};

_p.startDrag = function ()
{
    if (this._type != "dragstart")throw new Error("CimsDragEvent startDrag can only be called during the dragstart event");
    this.stopPropagation();
    this._manager.startDrag();
};

_p.addData = function (sType, oData)
{
    this._manager.addData(sType, oData);
};

_p.getData = function (sType)
{
    return this._manager.getData(sType);
};

_p.clearData = function ()
{
    this._manager.clearData();
};

_p.getDropDataTypes = function ()
{
    return this._manager.getDropDataTypes();
};

_p.addAction = function (sAction)
{
    this._manager.addAction(sAction);
};

_p.removeAction = function (sAction)
{
    this._manager.removection(sAction);
};

_p.getAction = function ()
{
    return this._manager.getAction();
};

_p.clearActions = function ()
{
    this._manager.clearActions();
};

_p.getTarget = function ()
{
    switch (this._type)
        {
        case "dragstart":
        case "dragend":
        case "dragover":
        case "dragout":
        case "dragmove":
            return this._target;
        case "dragdrop":
            return this._manager.getDestination();
            default : return CimsMouseEvent.prototype.getTarget.call(this);
    }
};

_p.getRelatedTarget = function ()
{
    switch (this._type)
        {
        case "dragover":
        case "dragout":
            return this._relatedTarget;
        case "dragdrop":
            return this._manager.getSource();
        case "dragend":
            return this._manager.getDestination();
            default : return CimsMouseEvent.prototype.getRelatedTarget.call(this);
    }
};

_p.dispose = function ()
{
    if (this.getDisposed())return;
    CimsMouseEvent.prototype.dispose.call(this);
    this._relatedTarget = null;
};

_p.setDragIcon = function (oComp)
{
    this._manager.setDragIcon(oComp);
};

_p.getDragIcon = function ()
{
    return this._manager.getDragIcon();
};

_p.getRealTarget = function ()
{
    return CimsMouseEvent.prototype.getTarget.call(this);
};

//////////////////
// CimsDragAndDropManager
//////////////////
function CimsDragAndDropManager()
{
    if (_inPrototype)return;
    if (CimsDragAndDropManager._singleton)return CimsDragAndDropManager._singleton;
    CimsObject.call(this);
    this._data = 
    {
    }
    ;
    this._actions = 
    {
    }
    ;
    return CimsDragAndDropManager._singleton = this;
}
_p = _mExtend(CimsDragAndDropManager, CimsObject, "CimsDragAndDropManager");
CimsDragAndDropManager.MOVE_ICON = new CimsImage(application.getPath() + "images/move.gif", 13, 9);
CimsDragAndDropManager.COPY_ICON = new CimsImage(application.getPath() + "images/copy.gif", 19, 15);
CimsDragAndDropManager.ALIAS_ICON = new CimsImage(application.getPath() + "images/alias.gif", 19, 15);
CimsDragAndDropManager.NO_DROP_ICON = new CimsImage(application.getPath() + "images/nodrop.gif", 20, 20);
CimsDragAndDropManager.prototype.getSource = function ()
{
    return this._source;
};

CimsDragAndDropManager.prototype.getDestination = function ()
{
    return this._destination;
};

_p.addData = function (sType, oData)
{
    this._data[sType] = oData;
};

_p.getData = function (sType)
{
    return this._data[sType];
};

_p.clearData = function ()
{
    this._data = 
    {
    }
    ;
};

_p.getDropDataTypes = function ()
{
    var dst = this.getDestination();
    if (!dst)return[];
    var res = [];
    var dstTypes = dst.getDropDataTypes();
    for (var i = 0; i < dstTypes.length; i++)
    {
        if (dstTypes[i]in this._data)res.push(dstTypes[i]);
    }
    return res;
};

_p.startDrag = function ()
{
    if (!this._dragInfo)throw new Error("Invalid use of CimsDragAndDropManager startDrag");
    this._dragInfo.dragging = true;
    this._source = this._dragInfo.startComponent;
};

_p.handleMouseEvent = function (e)
{
    switch (e.getType())
        {
        case "mousedown":
            this.handleMouseDown(e);
            return;
        case "mouseup":
            this.handleMouseUp(e);
            return;
        case "mousemove":
            this.handleMouseMove(e);
            return;
    }
};

_p.handleMouseDown = function (e)
{
    if (!e.getDefaultPrevented())
    {
        this._dragInfo = 
        {
            dragging : false, hasFiredDragStart : false, startScreenX : e.getScreenX(), startScreenY : e.getScreenY(), startComponent : e.getTarget(), clientX : e.getClientX(), clientY : e.getClientY()}
        ;
    }
};

_p.handleMouseMove = function (e)
{
    if (!this._dragInfo)return;
    var c;
    if (this._dragInfo.dragging)
    {
        this._dragInfo.clientX = e.getClientX();
        this._dragInfo.clientY = e.getClientY();
        c = this.getDropTarget(e);
        if (!c)this.setAction(null);
        else this.setAction(this._getAction(e.getShiftKey(), e.getCtrlKey(), e.getAltKey()));
        this._fireDragOverOut(this._dragInfo.over, c, e);
        this._dragInfo.over = c;
        this._updateIcon();
        if (c)this._scrollDropTarget(c, e);
    }
    else if (!this._dragInfo.hasFiredDragStart)
    {
        if (Math.abs(e.getScreenX() - this._dragInfo.startScreenX) > 5 || Math.abs(e.getScreenY() - this._dragInfo.startScreenY) > 5)
        {
            c = this._dragInfo.startComponent;
            c.dispatchEvent(new CimsDragEvent("dragstart", e));
            this._dragInfo.hasFiredDragStart = true;
            if (this._dragInfo.dragging)
            {
                this._fireDragOverOut(this._dragInfo.over, c, e);
                this._dragInfo.over = this._dragInfo.startComponent = c;
                application.getWindow().setCapture(true);
                application.getWindow().addEventListener("losecapture", this.cancelDrag, this);
            }
        }
    }
};

_p._fireDragOverOut = function (oFrom, oTo, e)
{
    if (oFrom && oFrom != oTo)
    {
        var outEvent = new CimsDragEvent("dragout", e);
        outEvent._relatedTarget = oTo;
        oFrom.dispatchEvent(outEvent);
        outEvent.dispose();
    }
    if (oTo)
    {
        if (oFrom != oTo)
        {
            var overEvent = new CimsDragEvent("dragover", e);
            overEvent._relatedTarget = oFrom;
            oTo.dispatchEvent(overEvent);
            overEvent.dispose();
        }
        var moveEvent = new CimsDragEvent("dragmove", e);
        oTo.dispatchEvent(moveEvent);
        moveEvent.dispose();
    }
};

_p.handleMouseUp = function (e)
{
    if (!this._dragInfo)return;
    if (this._dragInfo.dragging)this._endDrag(this.getDropTarget(e), e);
    else this._dragInfo = null;
};

_p.handleKeyboardEvent = function (e)
{
    switch (e.getType())
        {
        case "keydown":
            this.handleKeyDown(e);
            return;
        case "keyup":
            this.handleKeyUp(e);
            return;
    }
};

_p.handleKeyDown = function (e)
{
    if (!this._dragInfo)return;
    if (e.getKeyCode() == CimsKeyboardEvent.ESC)
    {
        this.cancelDrag();
    }
    else if (e.getKeyCode() == CimsKeyboardEvent.SHIFT || e.getKeyCode() == CimsKeyboardEvent.CTRL || e.getKeyCode() == CimsKeyboardEvent.ALT)
    {
        if (this._action != null)
        {
            this.setAction(this._getAction(e.getShiftKey(), e.getCtrlKey(), e.getAltKey()));
            this._updateIcon();
        }
    }
};

_p.handleKeyUp = function (e)
{
    if (!this._dragInfo)return;
    var bShiftPressed = e.getKeyCode() == CimsKeyboardEvent.SHIFT;
    var bCtrlPressed = e.getKeyCode() == CimsKeyboardEvent.CTRL;
    var bAltPressed = e.getKeyCode() == CimsKeyboardEvent.ALT;
    if (bShiftPressed || bCtrlPressed || bAltPressed)
    {
        if (this._action != null)
        {
            this.setAction(this._getAction(!bShiftPressed && e.getShiftKey(), !bCtrlPressed && e.getCtrlKey(), !bAltPressed && e.getAltKey()));
            this._updateIcon();
        }
    }
};

_p.cancelDrag = function (e)
{
    this._endDrag(null, e);
};

_p._endDrag = function (c, e)
{
    application.getWindow().removeEventListener("losecapture", this.cancelDrag, this);
    application.getWindow().setCapture(false);
    var over = this._dragInfo && this._dragInfo.over;
    var p, ns, ps;
    if (this._currentDragIcon)
    {
        p = this._currentDragIcon.getParent();
        ns = this._currentDragIcon.getNextSibling();
        ps = this._currentDragIcon.getPreviousSibling();
    }
    if (c)
    {
        this._destination = c;
        c.dispatchEvent(new CimsDragEvent("dragdrop", e));
    }
    var src = this.getSource();
    if (src)
    {
        src.dispatchEvent(new CimsDragEvent("dragend", e));
    }
    this._fireDragOverOut(over, null, e);
    if (this._currentDragIcon && p == this._currentDragIcon.getParent() && (ns == this._currentDragIcon.getNextSibling() || ps == this._currentDragIcon.getPreviousSibling()))
    {
        this._removeIcon();
    }
    if (this._dragInfo)
    {
        this._dragInfo.over = null;
        this._dragInfo = null;
    }
    this.clearData();
    this.clearActions();
    this._source = null;
    this._destination = null;
};

_p._removeIcon = function ()
{
    if (this._currentDragIcon && this._currentDragIcon.getParent())
    {
        this._currentDragIcon.getParent().remove(this._currentDragIcon);
    }
    this._currentDragIcon = null;
};

_p._updateIcon = function ()
{
    var win = application.getWindow();
    var icon = this._getDragIcon();
    if (this._currentDragIcon && icon != this._currentDragIcon && this._currentDragIcon.getParent() == win)
    {
        win.remove(this._currentDragIcon);
    }
    if (icon.getParent() != win)win.add(icon);
    this._currentDragIcon = icon;
    this._currentDragIcon.setLocation(this._dragInfo.clientX + 5, this._dragInfo.clientY + 15);
};

_p.supportsDrop = function (oComponent)
{
    var types = oComponent.getDropDataTypes();
    for (var i = 0; i < types.length; i++)
    {
        if (types[i]in this._data)return true;
    }
    return false;
};

_p.getDropTarget = function (e)
{
    var c = e.getTarget();
    while (c != null)
    {
        if ("_beforeSupportsDrop"in c)c._beforeSupportsDrop(e);
        if (this.supportsDrop(c))return c;
        c = c.getParent();
    }
    return null;
};

_p.addAction = function (sAction)
{
    this._actions[sAction] = true;
    if (!this._action)this._action = sAction;
};

_p.clearActions = function ()
{
    this._actions = 
    {
    }
    ;
    this._action = null;
};

_p.removeAction = function (sAction)
{
    delete this._actions[sAction];
    if (this._action == sAction)this._action = null;
};

_p.getAction = function ()
{
    return this._action;
};

_p.setAction = function (s)
{
    if (s != null &&!(s in this._actions))this.addAction(s);
    this._action = s;
};

CimsDragAndDropManager.prototype.getDragIcon = function ()
{
    return this._dragIcon;
};

_p.setDragIcon = function (oComp)
{
    this._dragIcon = oComp;
    if (this._dragInfo)this._updateIcon();
};

_p._getDragIcon = function ()
{
    if (this._action == null)return CimsDragAndDropManager.NO_DROP_ICON;
    if (this._dragIcon)return this._dragIcon;
    if (this._action == "move")return CimsDragAndDropManager.MOVE_ICON;
    if (this._action == "copy")return CimsDragAndDropManager.COPY_ICON;
    if (this._action == "alias")return CimsDragAndDropManager.ALIAS_ICON;
    return CimsDragAndDropManager.NO_DROP_ICON;
};

_p._getAction = function (bShift, bCtrl, bAlt)
{
    if (bShift && bCtrl && this._supportAction("alias"))return "alias";
    else if (bShift && bAlt && this._supportAction("copy"))return "copy";
    else if (bShift && this._supportAction("move"))return "move";
    else if (bAlt && this._supportAction("alias"))return "alias";
    else if (bCtrl && this._supportAction("copy"))return "copy";
    else 
    {
        for (var action in this._actions)return action; }
    return null;
};

_p._supportAction = function (sAction)
{
    return sAction in this._actions;
};

_p._scrollDropTarget = function (c, e)
{
    var cw = c.getClientWidth();
    var ch = c.getClientHeight();
    var x = e.getOffsetX();
    var y = e.getOffsetY();
    var canScrollX = c.getScrollWidth() > cw;
    var canScrollY = c.getScrollHeight() > ch;
    if (canScrollX)
    {
        if (x < 20)c.setScrollLeft(c.getScrollLeft() - 5);
        else if (cw - x < 20)c.setScrollLeft(c.getScrollLeft() + 5);
    }
    if (canScrollY)
    {
        if (y < 20)c.setScrollTop(c.getScrollTop() - 5);
        else if (ch - y < 20)c.setScrollTop(c.getScrollTop() + 5);
    }
};

_p.dispose = function ()
{
    if (this.getDisposed())return;
    CimsObject.prototype.dispose.call(this);
    this._data = null;
    this._actions = null;
    this._source = null;
    this._destination = null;
    this._dragInfo = null;
    this._dragIcon = null;
    CimsDragAndDropManager.MOVE_ICON.dispose();
    CimsDragAndDropManager.MOVE_ICON = null;
    CimsDragAndDropManager.COPY_ICON.dispose();
    CimsDragAndDropManager.COPY_ICON = null;
    CimsDragAndDropManager.ALIAS_ICON.dispose();
    CimsDragAndDropManager.ALIAS_ICON = null;
    CimsDragAndDropManager.NO_DROP_ICON.dispose();
    CimsDragAndDropManager.NO_DROP_ICON = null;
};

//////////////////
// CimsTimerManager
//////////////////
function CimsTimerManager()
{
    if (_inPrototype)return;
    if (CimsTimerManager._singleton)return CimsTimerManager._singleton;
    CimsObject.call(this);
    this._timers = 
    {
    }
    ;
    CimsTimerManager._singleton = this;
    application.addEventListener("dispose", this.dispose, this);
}
_p = _mExtend(CimsTimerManager, CimsObject, "CimsTimerManager");
_p.add = function (oTimer)
{
    this._timers[oTimer.toHashCode()] = oTimer;
};

_p.remove = function (oTimer)
{
    delete this._timers[oTimer.toHashCode()];
};

_p.dispose = function ()
{
    if (this._disposed)return;
    CimsObject.prototype.dispose.call(this);
    for (var hc in this._timers)
    {
        this._timers[hc].dispose();
        delete this._timers[hc];
    }
};

//////////////////
// CimsTimer
//////////////////
function CimsTimer(nInterval)
{
    if (_inPrototype)return;
    CimsEventTarget.call(this);
    (new CimsTimerManager).add(this);
    if (nInterval >= 0)this._interval = nInterval;
    var oThis = this;
    this.__ontick = function ()
    {
        oThis._ontick();
    }
    ;
}
_p = _mExtend(CimsTimer, CimsEventTarget, "CimsTimer");
_p._enabled = false;
_p._interval = 1000;
_p._intervalHandle = null;
CimsTimer.prototype.getEnabled = function ()
{
    return this._enabled;
};

CimsTimer.prototype.setEnabled = function (v)
{
    this._enabled = v;
};

CimsTimer.prototype.getInterval = function ()
{
    return this._interval;
};

_p.setInterval = function (nInterval)
{
    if (this._enabled)this.stop();
    this._interval = nInterval;
};

_p.start = function ()
{
    if (this._enabled)this.stop();
    this._enabled = true;
    this._intervalHandle = window.setInterval(this.__ontick, this._interval);
};

_p.stop = function ()
{
    this._enabled = false;
    window.clearInterval(this._intervalHandle);
    this._intervalHandle = null;
};

_p._ontick = function ()
{
    if (this._enabled)
    {
        var e = new CimsEvent("tick");
        this.dispatchEvent(e);
        e.dispose();
        application.flushLayoutQueue();
    }
};

_p.dispose = function ()
{
    if (this._disposed)return;
    this.stop();
    this.__ontick = null;
    CimsEventTarget.prototype.dispose.call(this);
};

CimsTimer.callOnce = function (fun, time, obj)
{
    var t = new CimsTimer(time != null ? time : 1);
    t.addEventListener("tick", function (e)
    {
        fun.call(obj, e);
        t.stop();
        t.dispose();
        obj = null;
    }
    , obj);
    t.start();
};

//////////////////
// CimsPopupManager
//////////////////
function CimsPopupManager()
{
    if (_inPrototype)return;
    if (CimsPopupManager._singleton)return CimsPopupManager._singleton;
    CimsObject.call(this);
    CimsPopupManager._singleton = this;
    this._showingPopups = 
    {
    }
    ;
}
_p = _mExtend(CimsPopupManager, CimsObject, "CimsPopupManager");
CimsPopupManager.prototype.addShowing = function (oPopup)
{
    this._showingPopups[oPopup.toHashCode()] = oPopup;
};

CimsPopupManager.prototype.removeShowing = function (oPopup)
{
    delete this._showingPopups[oPopup.toHashCode()];
};

CimsPopupManager.prototype.hideAutoHiding = function (oTarget)
{
    var p;
    for (var hc in this._showingPopups)
    {
        p = this._showingPopups[hc];
        if (!p._autoHide)continue;
        if (!oTarget || p != oTarget && (!p.contains(oTarget) || p.getVisible() &&!p.getIsVisible()) && new Date - p.getShowTimeStamp() > 100)
        {
            p.setVisible(false);
        }
    }
};

//////////////////
// CimsPopup
//////////////////
function CimsPopup(sText)
{
    if (_inPrototype)return;
    CimsLabel.call(this, sText);
    this.setCssClassName("bi-popup");
    this.setZIndex(1e6);
    this._style.visibility = "hidden";
}
_p = _mExtend(CimsPopup, CimsLabel, "CimsPopup");
_p._autoHide = true;
_p._allowOffScreen = false;
_p._relLeft = null;
_p._relTop = null;
_p._relRight = null;
_p._relBottom = null;
_p._screenLeft = null;
_p._screenTop = null;
_p._popupManager = new CimsPopupManager();
_p._wasShowing = false;
_p._showTimeStamp = new Date(0);
_p._hideTimeStamp = new Date(0);
_p._shadowSize = CimsBrowserCheck.ie ? 3 : 0;
_p.setScreenLeft = function (nLeft)
{
    if (this._screenLeft != nLeft)
    {
        this._screenLeft = nLeft;
        this._relLeft = null;
        this.layoutComponent();
    }
};

_p.setScreenTop = function (nTop)
{
    if (this._screenTop != nTop)
    {
        this._screenTop = nTop;
        this._relTop = null;
        this.layoutComponent();
    }
};

_p.setLeft = function (nLeft)
{
    if (this._relLeft != nLeft)
    {
        this._screenLeft = null;
        this._relLeft = nLeft;
        this.layoutComponent();
    }
};

_p.setTop = function (nTop)
{
    if (this._relTop != nTop)
    {
        this._screenTop = null;
        this._relTop = nTop;
        this.layoutComponent();
    }
};

_p.setLocation = function (nLeft, nTop)
{
    this.setLeft(nLeft);
    this.setTop(nTop);
};

_p.setClientLeft = function (nLeft)
{
    if (this._left != nLeft)
    {
        this._screenLeft = null;
        this._relLeft = null;
        this._left = nLeft;
        this.layoutComponent();
    }
};

_p.setClientTop = function (nTop)
{
    if (this._top != nTop)
    {
        this._screenTop = null;
        this._relTop = null;
        this._top = nTop;
        this.layoutComponent();
    }
};

_p.setVisible = function (bVisible)
{
    if (this.getVisible() == bVisible)return;
    if (this._lazyCreate &&!this.getCreated() && bVisible)
    {
        var p = this.getParent();
        if (p && p.getCreated())
        {
            this.setStyleProperty("visibility", "inherit");
            this._addHtmlElementToParent(p, this.getNextSibling(), true);
            this.setStyleProperty("visibility", "hidden");
        }
    }
    if (this.getCreated())
    {
        if (bVisible)
        {
            if (!this._element.parentNode || this._element.parentNode.nodeType != 1)this._addHtmlElementToParent(this._parent);
            this.removeStyleProperty("display");
            this.dispatchEvent(new CimsEvent("beforeshow"));
            this.setStyleProperty("visibility", bVisible ? "inherit" : "hidden");
            this.pack();
            this.layoutAllChildren();
            this.layoutComponent();
            this.bringToFront();
        }
        else
        {
            this.setStyleProperty("display", "none");
        }
    }
    this.setStyleProperty("visibility", bVisible ? "inherit" : "hidden");
    if (this.getIsVisible() != this._wasShowing)
    {
        if (bVisible)this._dispatchShow();
        else this._dispatchHide();
    }
};

_p.getCanFocus = function ()
{
    return true;
};

_p.bringToFront = function ()
{
    var p = this._parent;
    if (this.getCreated() && p)
    {
        var max =  - Infinity;
        if (CimsBrowserCheck.ie)
        {
            var cs = this._document.body.children;
            for (var i = 0; i < cs.length; i++)
            {
                if (cs[i].nodeType == 1)max = Math.max(max, cs[i].currentStyle.zIndex);
            }
        }
        else 
        {
            var cs = this._document.body.childNodes;
            var view = this._document.defaultView;
            var zi;
            for (var i = 0; i < cs.length; i++)
            {
                if (cs[i].nodeType == 1)
                {
                    zi = cs[i].style.zIndex;
                    if (zi == "" || isNaN(zi))
                    {
                        zi = view.getComputedStyle(cs[i], "").zIndex;
                        if (zi == "" || isNaN(zi))zi = 0;
                    }
                    max = Math.max(max, zi);
                }
            }
        }
        this.setZIndex(max + 1);
    }
};

_p.sendToBack = function ()
{
    var p = this._parent;
    if (this.getCreated() && p)
    {
        var min = Infinity;
        if (CimsBrowserCheck.ie)
        {
            var cs = this._document.body.children;
            for (var i = 0; i < cs.length; i++)
            {
                if (cs[i].nodeType == 1)min = Math.min(min, cs[i].currentStyle.zIndex);
            }
        }
        else 
        {
            cs = this._document.body.childNodes;
            var view = this._document.defaultView;
            for (i = 0; i < cs.length; i++)
            {
                if (cs[i].nodeType == 1)min = Math.min(min, view.getComputedStyle(cs[i], "").zIndex);
            }
        }
        this.setZIndex(min - 1);
    }
};

CimsPopup.prototype.getAutoHide = function ()
{
    return this._autoHide;
};

CimsPopup.prototype.setAutoHide = function (v)
{
    this._autoHide = v;
};

CimsPopup.prototype.getAllowOffScreen = function ()
{
    return this._allowOffScreen;
};

CimsPopup.prototype.setAllowOffScreen = function (v)
{
    this._allowOffScreen = v;
};

CimsPopup.prototype.getShowTimeStamp = function ()
{
    return this._showTimeStamp;
};

CimsPopup.prototype.getHideTimeStamp = function ()
{
    return this._hideTimeStamp;
};

_p.layoutComponent = function ()
{
    if (!this.getCreated())return;
    var root = this.getTopLevelComponent();
    if (!root)return;
    var oldLeft = this._left;
    var oldRight = this._right;
    var oldTop = this._top;
    var oldBottom = this._bottom;
    var oldHeight = this._height;
    if (this._relativeToComponent)this._layoutRelative();
    else 
    {
        var sl = root.getScrollLeft();
        var p = this._parent;
        if (this._relLeft != null)this._left = p.getClientLeft() + p.getInsetLeft() + this._relLeft;
        else if (this._screenLeft != null)
        {
            if (CimsBrowserCheck.ie)
            {
                this._left = this._screenLeft - this._document.parentWindow.screenLeft;
            }
            else 
            {
                var doc = this._document;
                this._left = this._screenLeft - doc.getBoxObjectFor(doc.documentElement).screenX;
            }
            this._left += sl;
        }
        if (this._right != null)this._right = p.getClientLeft() + p.getWidth() - p.getInsetRight() - this._right;
        if (!this._allowOffScreen)
        {
            var h = root.getClientWidth();
            if (this._left != null)this._left = Math.max(sl, this._left);
            if (this._right != null)this._right = Math.max(0, this._right);
            if (this._width != null)this._width = Math.min(h, this._width);
            if (this._left != null && this._width != null && this._left + this._width > h + sl)
            {
                this._left = h + sl - this._width;
                this._right = null;
            }
            else if (this._right != null && this._width != null && this._right + this._width > h)
            {
                this._left = 0;
                this._right = null;
            }
        }
        var st = root.getScrollTop();
        if (this._relTop != null)this._top = p.getClientTop() + p.getInsetTop() + this._relTop;
        else if (this._screenTop != null)
        {
            if (CimsBrowserCheck.ie)
            {
                this._top = this._screenTop - this._document.parentWindow.screenTop;
            }
            else 
            {
                doc = this._document;
                this._top = this._screenTop - doc.getBoxObjectFor(doc.documentElement).screenY;
            }
            this._top += st;
        }
        if (this._bottom != null)this._bottom = p.getClientTop() + p.getHeight() - p.getInsetBottom() - this._bottom;
        if (!this._allowOffScreen)
        {
            h = root.getClientHeight();
            if (this._top != null)this._top = Math.max(st, this._top);
            if (this._bottom != null)this._bottom = Math.max(0, this._bottom);
            if (this._height != null)this._height = Math.min(h, this._height);
            if (this._top != null && this._height != null && this._top + this._height > h + st)
            {
                this._top = h + st - this._height;
                this._bottom = null;
            }
            else if (this._bottom != null && this._height != null && this._bottom + this._height > h)
            {
                this._top = 0;
                this._bottom = null;
            }
        }
    }
    root.layoutChild(this);
    this._left = oldLeft;
    this._right = oldRight;
    this._top = oldTop;
    this._bottom = oldBottom;
    this._height = oldHeight;
};

_p.positionRelativeToComponent = function (oComponent, sDir)
{
    this._relativeToComponent = oComponent;
    this._relativeDirection = sDir || "vertical";
    this.layoutComponent();
};

_p._layoutRelative = function ()
{
    var comp = this._relativeToComponent;
    var compLeft = comp.getClientLeft();
    var compTop = comp.getClientTop();
    var compWidth = comp.getWidth();
    var compHeight = comp.getHeight();
    var width = this.getPreferredWidth();
    var height = this.getPreferredHeight();
    var docWidth = this._document.body.clientWidth;
    var docHeight = this._document.body.clientHeight;
    this._left = null;
    this._right = null;
    this._top = null;
    this._bottom = null;
    if (this._relativeDirection == "vertical")
    {
        if (compLeft + width <= docWidth)this._left = compLeft;
        else if (docWidth >= width)this._left = docWidth - width;
        else 
        {
            if (!this._allowOffScreen)
            {
                this._left = 0;
                this._width = docWidth;
            }
            else 
            {
                this._left = 0;
                this._width = width;
            }
        }
    }
    else
    {
        if (compLeft + compWidth + width <= docWidth)this._left = compLeft + compWidth;
        else if (compLeft - width >= 0)this._left = compLeft - width;
        else if (docWidth - compLeft - compWidth >= compLeft)
        {
            this._left = compLeft + compWidth;
            if (!this._allowOffScreen)this._width = docWidth - compLeft - compWidth;
            else this._width = width;
        }
        else 
        {
            if (!this._allowOffScreen)
            {
                this._left = 0;
                this._width = compLeft;
            }
            else 
            {
                this._left = compLeft - width;
                this._width = width;
            }
        }
    }
    this._left += this.getTopLevelComponent().getScrollLeft();
    if (this._relativeDirection == "vertical")
    {
        if (compTop + compHeight + height <= docHeight)this._top = compTop + compHeight;
        else if (compTop >= height)
        {
            this._top = compTop - height;
        }
        else if (docHeight - compTop - compHeight >= compTop)
        {
            this._top = compTop + compHeight;
            if (!this._allowOffScreen)this._height = docHeight - compTop - compHeight;
            else this._height = height;
        }
        else 
        {
            if (!this._allowOffScreen)
            {
                this._top = 0;
                this._height = compTop;
            }
            else 
            {
                this._top = compTop - height;
                this._height = height;
            }
        }
    }
    else 
    {
        if (compTop + height <= docHeight)this._top = compTop;
        else if (compTop + compHeight - height >= 0 && compTop + compHeight <= docHeight)this._top = compTop + compHeight - height;
        else if (docHeight >= height)
        {
            this._top = docHeight - height;
        }
        else
        {
            if (!this._allowOffScreen)
            {
                this._top = 0;
                this._height = docHeight;
            }
            else 
            {
                this._top = 0;
                this._height = height;
            }
        }
    }
    this._top += this.getTopLevelComponent().getScrollTop();
};

_p._dispatchShow = function ()
{
    this._popupManager.addShowing(this);
    this._popupManager.hideAutoHiding(this);
    this._wasShowing = true;
    this._showTimeStamp = new Date;
    this.dispatchEvent(new CimsEvent("show"));
};

_p._dispatchHide = function ()
{
    this._popupManager.removeShowing(this);
    this._wasShowing = false;
    this._hideTimeStamp = new Date;
    this.dispatchEvent(new CimsEvent("hide"));
};

_p.getInsetRight = function ()
{
    var el = this._element;
    if (CimsBrowserCheck.ie && this.getStyleProperty("overflowY") == "hidden" || el.clientWidth == 0)
    {
        return CimsLabel.prototype.getInsetRight.call(this);
    }
    return CimsLabel.prototype.getInsetRight.call(this) - this._shadowSize;
};

_p.getInsetBottom = function ()
{
    var el = this._element;
    if (CimsBrowserCheck.ie && this.getStyleProperty("overflowX") == "hidden" || el.clientHeight == 0)
    {
        return CimsLabel.prototype.getInsetBottom.call(this);
    }
    return CimsLabel.prototype.getInsetBottom.call(this) - this._shadowSize;
};

_p.getWidth = function ()
{
    return CimsLabel.prototype.getWidth.call(this) - this._shadowSize;
};

_p.getHeight = function ()
{
    return CimsLabel.prototype.getHeight.call(this) - this._shadowSize;
};

_p._addHtmlElementToParent = function (oParent, oBefore, bLayout)
{
    if (this._lazyCreate &&!this.getVisible())return;
    if (bLayout == null)bLayout = true;
    if (!this._created)this._create(oParent._document);
    this._document.body.appendChild(this._element);
    this._created = true;
    this._createChildren(oParent._document, false);
    this.invalidateParentLayout();
    this.dispatchEvent(CimsComponent._createEvent);
};

_p._removeHtmlElementFromParent = function (oParent)
{
    if (this.getCreated())
    {
        this._element.parentNode.removeChild(this._element);
        this._popupManager.removeShowing(this);
    }
};

_p.dispose = function ()
{
    if (this._disposed)return;
    if (this._element)this._element.style.filter = "none";
    this._popupManager.removeShowing(this);
    this._popupManager = null;
    this._relativeToComponent = null;
    CimsLabel.prototype.dispose.call(this);
};



//////////////////
// CimsToolTipManager
//////////////////
function CimsToolTipManager()
{
    if (_inPrototype)return;
    if (CimsToolTipManager._singleton)return CimsToolTipManager._singleton;
    CimsObject.call(this);
    CimsToolTipManager._singleton = this;
};

_p = _mExtend(CimsToolTipManager, CimsObject, "CimsToolTipManager");
_p._currentToolTip = null;
_p.handleMouseOver = function (e)
{
    var to = e.getTarget();
    var c = to;
    var tt;
    while (c != null &&!(tt = c.getToolTip()))
    {
        c = c.getParent();
    }
    if (this._currentToolTip && (to == this._currentToolTip || this._currentToolTip.contains(to)))return;
    if (this._currentToolTip != tt || this._currentToolTip && this._currentToolTip._toolTipForComponent != c)
    {
        if (this._currentToolTip)
        {
            this._currentToolTip._toolTipForComponent = null;
            this._currentToolTip.setVisible(false);
        }
        if (tt)
        {
            this._currentToolTip = tt;
            tt.positionRelativeToComponent(null);
            tt._startShowTimer();
            this._currentToolTip._toolTipForComponent = c;
        }
    }
};

_p.handleMouseOut = function (e)
{
    var to = e.getRelatedTarget();
    var from = e.getTarget();
    if (this._currentToolTip && (to == this._currentToolTip || this._currentToolTip.contains(to)))return;
    if (to && from.contains(to))return;
    if (this._currentToolTip &&!to)
    {
        this._currentToolTip._toolTipForComponent = null;
        this._currentToolTip.setVisible(false);
        this._currentToolTip = null;
    }
};

_p.handleFocus = function (e)
{
    var c = e.getTarget();
    var tt = c.getToolTip();
    if (tt && this._currentToolTip != tt)
    {
        if (this._currentToolTip)
        {
            this._currentToolTip._toolTipForComponent = null;
            this._currentToolTip.setVisible(false);
        }
        this._currentToolTip = tt;
        tt.positionRelativeToComponent(c);
        tt._startShowTimer();
        this._currentToolTip._toolTipForComponent = c;
    }
};

_p.handleBlur = function (e)
{
    var c = e.getTarget();
    if (!c)return;
    var tt = c.getToolTip();
    if (this._currentToolTip && this._currentToolTip == tt)
    {
        this._currentToolTip._toolTipForComponent = null;
        tt.setVisible(false);
        this._currentToolTip = null;
    }
};

CimsToolTipManager.prototype.getCurrentToolTip = function ()
{
    return this._currentToolTip;
};

CimsToolTipManager.prototype.setCurrentToolTip = function (v)
{
    this._currentToolTip = v;
};

//////////////////
// CimsToolTip
//////////////////
function CimsToolTip(sText)
{
    if (_inPrototype)return;
    CimsPopup.call(this, sText);
    this._showTimer = new CimsTimer();
    this._showTimer.setInterval(this._showInterval);
    this._showTimer.addEventListener("tick", this._onshowtick, this);
    this._hideTimer = new CimsTimer();
    this._hideTimer.setInterval(this._hideInterval);
    this._hideTimer.addEventListener("tick", this._onhidetick, this);
    this.addEventListener("mouseover", this._onmouseover);
    this.addEventListener("mouseout", this._onmouseover);
    this.setCssClassName("bi-tool-tip");
    this.setAppearance("tool-tip");
}
_p = _mExtend(CimsToolTip, CimsPopup, "CimsToolTip");
_p._toolTipManager = new CimsToolTipManager();
_p._showInterval = 1000;
_p._hideInterval = 4000;
_p._hideOnHover = true;
_p._mousePointerOffsetX = 1;
_p._mousePointerOffsetY = 20;
_p._toolTipForComponent = null;
CimsToolTip.prototype.getHideOnHover = function ()
{
    return this._hideOnHover;
};

CimsToolTip.prototype.setHideOnHover = function (v)
{
    this._hideOnHover = v;
};

CimsToolTip.prototype.getMousePointerOffsetX = function ()
{
    return this._mousePointerOffsetX;
};

CimsToolTip.prototype.setMousePointerOffsetX = function (v)
{
    this._mousePointerOffsetX = v;
};

CimsToolTip.prototype.getMousePointerOffsetY = function ()
{
    return this._mousePointerOffsetY;
};

CimsToolTip.prototype.setMousePointerOffsetY = function (v)
{
    this._mousePointerOffsetY = v;
};

_p.setHideInterval = function (nHideInterval)
{
    this._hideInterval = nHideInterval;
    this._hideTimer.setInterval(nHideInterval);
};

CimsToolTip.prototype.getHideInterval = function ()
{
    return this._hideInterval;
};

_p.setShowInterval = function (nShowInterval)
{
    this._showInterval = nShowInterval;
    this._showTimer.setInterval(nShowInterval);
};

CimsToolTip.prototype.getShowInterval = function ()
{
    return this._showInterval;
};

_p._startShowTimer = function ()
{
    if (!this._showTimer.getEnabled())this._showTimer.start();
};

_p.getComponent = function ()
{
    return this._toolTipForComponent;
};

_p.dispose = function ()
{
    this.removeEventListener("mouseover", this._onmouseover);
    this._showTimer.removeEventListener("tick", this._onshowtick, this);
    this._showTimer.dispose();
    this._showTimer = null;
    this._hideTimer.removeEventListener("tick", this._onhidetick, this);
    this._hideTimer.dispose();
    this._hideTimer = null;
    this._toolTipForComponent = null;
    CimsPopup.prototype.dispose.call(this);
};

_p.setVisible = function (bVisible)
{
    if (bVisible &&!this.getParent())
    {
        application.getWindow().add(this);
    }
    this._showTimer.stop();
    this._hideTimer.stop();
    CimsPopup.prototype.setVisible.call(this, bVisible);
};

_p._onmouseover = function (e)
{
    if (this._hideOnHover)this.setVisible(false);
};

_p._onshowtick = function (e)
{
    this._showTimer.stop();
    this.setScreenLeft(CimsMouseEvent.getScreenX() + this._mousePointerOffsetX);
    this.setScreenTop(CimsMouseEvent.getScreenY() + this._mousePointerOffsetY);
    this.setVisible(true);
};

_p._onhidetick = function (e)
{
    this._hideTimer.stop();
    this.setVisible(false);
};

_p._dispatchShow = function ()
{
    this._showTimer.stop();
    this._hideTimer.start();
    CimsPopup.prototype._dispatchShow.call(this);
};

_p._dispatchHide = function ()
{
    this._hideTimer.stop();
    this._showTimer.stop();
    this._toolTipManager._currentToolTip = null;
    CimsPopup.prototype._dispatchHide.call(this);
};

CimsToolTip.getTextToolTip = function (sText)
{
    if (!CimsToolTip._textToolTip)
    {
        CimsToolTip._textToolTip = new CimsToolTip;
    }
    if (CimsToolTip._textToolTip.getParent())CimsToolTip._textToolTip.getParent().remove(CimsToolTip._textToolTip);
    CimsToolTip._textToolTip.setText(sText);
    CimsToolTip._textToolTip.setShowInterval(1000);
    CimsToolTip._textToolTip.setHideInterval(4000);
    return CimsToolTip._textToolTip}
;