@echo off
rem *************************************************************** {COPYRIGHT-TOP}
rem * Licensed Materials - Property of IBM
rem * Restricted Materials of IBM
rem * IBM Tivoli Usage and Accounting Manager
rem * 5724-O33, 5765-UAV, 5765-UA7, 44E7863
rem * (c) Copyright IBM Corp. 2004, 2007 All Rights Reserved.
rem *
rem * US Government Users Restricted Rights - Use, duplication or
rem * disclosure restricted by GSA ADP Schedule Contract with
rem * IBM Corp.
rem **************************************************************** {COPYRIGHT-END}
rem
rem ****************************************************************
rem * TUAM deploy/undeploy/redeploy Installation Script
rem *
rem *    If WAS security is enabled, then a username and password are
rem *    required to stop the server.  If security is disabled, then
rem *    any supplied user and password are ignored by WAS.
rem *
rem * Usage: deployTuam  install | remove | replace [user] [password]
rem ****************************************************************

set cwd=%cd%
call "%~dp0..\..\bin\setupEnv"
set PROFILE=TIPProfile
set USERNAME=default
set PASSWORD=default
set PATH=%TIP_HOME%\profiles\%PROFILE%\bin;%PATH%

if %1x==x goto syntax

if %2x==x goto defaultuser
set USERNAME=%2
:defaultuser

if %3x==x goto defaultpassword
set PASSWORD=%3
:defaultpassword

if %1x==installx goto install
if %1x==removex goto remove
if %1x==replacex goto replace
goto syntax

:remove
:replace 
:install

cd %TUAM_HOME%
echo Invoking WAS Installer

call wsadmin -f "%TUAM_HOME%\setup\console\deployTUAMConsole.py" %1 lib -user %USERNAME% -password %PASSWORD%
if ERRORLEVEL 1 goto error
del /q %TUAM_HOME%\setup\console\aucConsoleAUIML.war

echo All Done!

goto done

:syntax
echo Usage: deployTuam  install [user] [password]
echo        deployTuam  remove  [user] [password]
echo        deployTuam  replace [user] [password]
goto done

:error
echo deployTuam failed!  Exiting with error: %ERRORLEVEL%
exit /b %ERRORLEVEL%
:done
cd %cwd%
