REM ****************************************************************
REM * Licensed Materials - Property of IBM
REM * IBM Tivoli Usage and Accounting Manager
REM * 5724-O33, 5765-UAV, 5765-UA7, 44E7863
REM * (C) Copyright IBM Corp. 2011
REM *
REM * The source code for this program is not published or otherwise
REM * divested of its trade secrets, irrespective of what has been
REM * deposited with the U.S. Copyright Office.
REM *****************************************************************
REM
REM *****************************************************************
REM * This script is run to configure TUAM web reporting App Pool setting in IIS.
REM *
REM * Syntax:
REM *    disable32bitAppPool.vbs
REM *****************************************************************

Option Explicit
On Error Resume Next


Const DEFAULT_PATH = "IIS://localhost/W3SVC/1/ROOT"
Const VIRTUAL_PATH = "IIS://localhost/W3SVC/1/ROOT/TUAM"

Dim ErrorMsg
Dim Enabled 

Enabled = false

WScript.Echo "Calling... "+ DEFAULT_PATH    
Call UpdateWebInfo(DEFAULT_PATH)

WScript.Echo "Calling... "+ VIRTUAL_PATH
Call UpdateWebInfo(VIRTUAL_PATH)     
    
If Enabled = False Then
WScript.Echo ErrorMsg
End If

If Enabled = True Then
WScript.Echo "The TUAM Pool has been updated"
End If


Sub UpdateWebInfo(SitePath)

    On Error Resume Next
    
    Dim SiteObject
    Set SiteObject = GetObject(SitePath)
    
    If (Err.Number <> 0) Then
        'WScript.Echo "Unable to Access TUAM Web Site : "+ SitePath
        ErrorMsg = "Unable to Access TUAM Web Site : "+ SitePath
        exit sub
    End If    
    
    Dim objWMIService
        Set objWMIService = GetObject("winmgmts:\\.\root\cimv2")
    
    
     Dim newAppPool    
     set newAppPool = GetObject("IIS://localhost/w3svc/AppPools/TUAM Pool")
     newAppPool.enable32BitAppOnWin64=0
     newAppPool.SetInfo
     WScript.Echo "Enabled..."
     Enabled = true
    
    
              
End Sub