	// ***********************************************************************************
	// Javascript library for prompts in Cognos Reports
	//
	// Provided as part of Tivoli Usage and Accounting Manager 7.3.0.4
	// ***********************************************************************************

   // Function to reprompt 
   function requeryPrompts()
   {
      SetPromptControl('reprompt');
   }

   // Functions to Clear Text from text box
   function clearStartAccountText()
   {
      fWR._textEditBoxStartingAccountCodeTextPrompt.value = "";  
      canSubmitPrompt();
   }

   function clearEndAccountText()
   {
      fWR._textEditBoxEndingAccountCodeTextPrompt.value = "";  
      canSubmitPrompt();
   }

   // Functions to manage Account code prompt for custom option
   function setStartAccountToCustom()
   {
      fWR._oLstChoicesStartingAccountCodePrompt[3].selected=true;
   }

   function setEndAccountToCustom()
   {
      fWR._oLstChoicesEndingAccountCodePrompt[3].selected=true;
   }

   // Function to initialise Account Prompts
   function initCustomAccountPrompts()
   {      

      // Clear the Account Code text boxes when Account Option chosen
      fWR._oLstChoicesStartingAccountCodePrompt.onchange = clearStartAccountText;
      fWR._oLstChoicesEndingAccountCodePrompt.onchange = clearEndAccountText;
  
      // Set to Custom if text entered
      fWR._textEditBoxStartingAccountCodeTextPrompt.onchange = setStartAccountToCustom;
      fWR._textEditBoxEndingAccountCodeTextPrompt.onchange = setEndAccountToCustom;
	 
	}
	
   // Function to set the year prompt to current year    
   function setYearPrompt()
   {

      // Set Year Prompt to Current Year
      var yearPrompt = fWR._oLstChoicesYearPrompt;
      if ((yearPrompt.options.selectedIndex == 0) || (yearPrompt.options.selectedIndex == 1))
      {
        now = new Date
        thisYear=now.getFullYear()
        for (var i=0;i < yearPrompt.length; i++)
        {
           if(yearPrompt[i].value==thisYear)
           {
              yearPrompt[i].selected=true;
           }
        }
      }
    }

   // Function to set the year prompt to current year    
   function setYearPrompt2()
   {

      // Set Year Prompt to Current Year
      var yearPrompt = fWR._oLstChoicesYearPrompt;
      if ((yearPrompt.options.selectedIndex == 0) || (yearPrompt.options.selectedIndex == 1))
      {
        now = new Date
        thisYear=fWR._oLstChoicesThisYearPrompt[2].value;
        for (var i=0;i < yearPrompt.length; i++)
        {
           if(yearPrompt[i].value==thisYear)
           {
              yearPrompt[i].selected=true;
           }
        }
      }
    }	
	
   function setPeriodPrompt()
   {

   // Function to set Period Prompt to Current Period
     var periodPrompt = fWR._oLstChoicesPeriodPrompt;
     if ((periodPrompt .options.selectedIndex == 0) || (periodPrompt .options.selectedIndex == 1))
     {

        thisPeriod=fWR._oLstChoicesThisPeriodPrompt[2].value;
        for (var i=0;i < periodPrompt.length; i++)
        {
           if(periodPrompt[i].value==thisPeriod)
           {
              periodPrompt[i].selected=true;
           }
        }
     }	
   }
   
   // Function to set date prompts
   function setDates()
   {

     // Get Dates from hidden lookup prompts
     var startDate = fWR._oLstChoicesStartDateFilter.options[2].value;
     var endDate = fWR._oLstChoicesEndDateFilter.options[2].value;

     //Convert into Dates  
     var startConvDate = new Date(startDate.substr(0,startDate.indexOf('.')).replace(/-/g,"/").replace('T',' '));
     var endConvDate = new Date(endDate.substr(0,startDate.indexOf('.')).replace(/-/g,"/").replace('T',' '));

     // If end date is default date then first time so set to today
     if (endConvDate.getFullYear() == 1900)
     {
       var today = new Date();
       endConvDate = today;
      }
   
     // Set Prompt Values
     pickerControlStartDatePrompt.setValue(startConvDate.getFullYear() + "-" + (startConvDate.getMonth()+1) + "-" + startConvDate.getDate()); 
     pickerControlEndDatePrompt.setValue(endConvDate.getFullYear() + "-" + (endConvDate.getMonth()+1) + "-" + endConvDate.getDate());

   }	

   // Function to set Last Sorted Sequence Character prompt
   function initLastSortedSeqChar()
   {

     fWR._oLstChoicesLastSortedSeqCharFilter[2].selected=true;

   }

   // Function to set current period hidden prompt
   function initThisPeriodPrompt()
   {

     fWR._oLstChoicesThisPeriodPrompt[2].selected=true;

   }

   // Function to set current year hidden prompt
   function initThisYearPrompt()
   {

     fWR._oLstChoicesThisYearPrompt[2].selected=true;

   }   
   
   // Function to set Identifier Filters
   function initIdentifierFilter()
   {

      fWR._oLstChoicesIdentifier2Filter[2].selected=true;
      fWR._oLstChoicesIdentifier3Filter[2].selected=true;

   }
   
   // Function to initialise Account Prompts
   function initAccountPrompts()
   {   
   
     // Requery to get Account Information
     fWR._oLstChoicesAccountStructurePrompt.onchange = requeryPrompts;
     fWR._oLstChoicesAccountLevelPrompt.onchange = requeryPrompts;

     fWR._oLstChoicesAccountStructureStartFilter[2].selected=true;
     fWR._oLstChoicesAccountStructureLengthFilter[2].selected=true;

     initCustomAccountPrompts()

   }   

   // Function to initialise Account Prompts
   function initAccountPrompts2()
   {   
   
     // Requery to get Account Information
     fWR._oLstChoicesAccountStructurePrompt.onchange = requeryPrompts;

     fWR._oLstChoicesAccountStructureStartFilter[2].selected=true;
     fWR._oLstChoicesAccountStructureLengthFilter[2].selected=true;

     initCustomAccountPrompts()

   }      
   
   // Function to initialise Previous Period Prompts
   function initPreviousPeriodPrompts()
   {

     fWR._oLstChoicesPreviousPeriodFilter[2].selected=true;
     fWR._oLstChoicesPreviousYearFilter[2].selected=true;
     fWR._oLstChoicesPreviousPreviousPeriodFilter[2].selected=true;
     fWR._oLstChoicesPreviousPreviousYearFilter[2].selected=true;
   
   }
   
   // Function to initialise Account Structure Length Prompts
   function initAccountStructureLengthPrompts()
   {

     fWR._oLstChoicesAccountStructureLength1Filter[2].selected=true;
     fWR._oLstChoicesAccountStructureLength2Filter[2].selected=true;
     fWR._oLstChoicesAccountStructureLength3Filter[2].selected=true;
     fWR._oLstChoicesAccountStructureLength4Filter[2].selected=true;
   
   }
   
   // Function to set date prompt when date option changed
   function initDatePrompts()
   {
     setDates();

     fWR._oLstChoicesStartDateFilter.options[2].selected = true;
     fWR._oLstChoicesEndDateFilter.options[2].selected = true;

     fWR._oLstChoicesDatePrompt.onchange = setDates;
	}
	
	// Function to initialise and set typical Account and Year prompt combination
    function initAccountYear()
    {   
       initAccountPrompts();
       setYearPrompt();
	   initLastSortedSeqChar();
    }
	
	// Function to initialise and set typical Account and Year / Period prompt combination
    function initAccountYearPeriod()
    {   
	   initAccountPrompts();
	   initThisYearPrompt();
	   initThisPeriodPrompt();
	   setYearPrompt2();
	   setPeriodPrompt();
	   initLastSortedSeqChar();
    }	
	
	// Function to initialise and set typical Account and Date prompt combination
    function initAccountDate()
    {   
       initAccountPrompts();
       initDatePrompts();
	   initLastSortedSeqChar();
    }	

	// Get Document Handle as Global
  var fWR = (typeof getFormWarpRequest == "function" ?
  getFormWarpRequest() : document.forms["formWarpRequest"]);
  if ( !fWR || fWR == undefined) { fWR = ( formWarpRequest_THIS_ ?
    formWarpRequest_THIS_ : formWarpRequest_NS_ );}

	  
	  
	  