@echo off

setlocal ENABLEDELAYEDEXPANSION
set basedir=%cd%

set user=tipadmin
set passwd=tippass
if not "%1" == "" (
	set user=%1
)
if not "%2" == "" (
	set passwd=%2
)
set base=7.3.0
set fixpack=4

echo Searching for installed components...

pushd "%SI_PATH%\bin" 2>nul
if ERRORLEVEL 1 (
	pushd "%USERPROFILE%\acsi_%USERNAME%" 2>nul
	if ERRORLEVEL 1 (
		pushd "%PROGRAMFILES(x86)%\IBM\Common\acsi\bin" 2>nul
		if ERRORLEVEL 1 (
			pushd "%PROGRAMFILES%\IBM\Common\acsi\bin"
			if ERRORLEVEL 1 (
				echo Unable to find DE
				exit /b 1
			)
		)
	)
)
call ..\setenv.cmd
set patched=0
for /f "delims=, tokens=2,4,5,6" %%i in ('de_lsrootiu.cmd ^| find "IU,TIPCore"') do (
    set tipver=%%j
    set TIP_HOME=%%k
    !TIP_HOME!\profiles\TIPProfile\bin\serverStatus.bat server1 -username %user% -password %passwd% | find "ADMU0508I" >NUL:
	if not !ERRORLEVEL! == 0 (
		echo Unable to check TIP server status - please ensure server is running
		echo and check %user% password is correct.
		echo
		echo usage: applyFixpack.bat tipadmin password
		exit /b 1
	)
    
)
for /f "delims=, tokens=2,4,5,6" %%i in ('de_lsrootiu.cmd ^| find "IU,TUAM_" ^| sort') do (
	if "%%j" == "%base%.%fixpack%" (
		set TUAM_HOME=%%k
		if exist "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i\." (
			echo Undoing patch for %%i
			if "%%i" == "TUAM_UI" (
				call %%k\bin\setupEnv
			    set uid=%%l
				rem As the non-fixpack deploy script doesn't have the path space fix, we want to keep the
				rem fixpack one around until we have redeployed the original 7.3.0.1 war.
				copy /y "!TUAM_HOME!\setup\console\deployTuam.bat" "!TUAM_HOME!\setup\console\deployTuam_fp2.bat" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				copy /y "!TUAM_HOME!\setup\console\deployTUAMConsole.py" "!TUAM_HOME!\setup\console\deployTUAMConsole_fp2.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				echo Variable#RootIUTypeID[!uid:~0,32!,%base%.%fixpack%]#IAGLOBAL_TIP_HOME=!TIP_HOME:\=\\!> "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i\var.properties"
				echo Variable#RootIUTypeID[!uid:~0,32!,%base%.%fixpack%]#shExt=bat>> "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i\var.properties"
				call manageIU.bat -o undo -i "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i\var.properties" -r "!TUAM_HOME!" -p "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i\packagedIU.xml" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				set status=!ERRORLEVEL!
				del /q "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i\var.properties"
				if !status! == 0 (
					move /y "!TUAM_HOME!\setup\console\deployTUAMConsole.py" "!TUAM_HOME!\setup\console\deployTUAMConsole_fp0.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					move /y "!TUAM_HOME!\setup\console\deployTUAMConsole_fp2.py" "!TUAM_HOME!\setup\console\deployTUAMConsole.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					call "!TUAM_HOME!\setup\console\deployTuam_fp2.bat" replace %user% %passwd% 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					set status=!ERRORLEVEL!
					del /q "!TUAM_HOME!\setup\console\deployTuam_fp2.bat" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					move /y "!TUAM_HOME!\setup\console\deployTUAMConsole_fp0.py" "!TUAM_HOME!\setup\console\deployTUAMConsole.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				) else (
					del /q "!TUAM_HOME!\setup\console\deployTUAMConsole_fp2.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				)
				del /q "!TUAM_HOME!\setup\console\deployTuam_fp2.bat" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				if !status! == 0 (
					if exist "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\SMUtils.js" (
						move /y "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\SMUtils.js" "!TIP_HOME!/profiles/TIPProfile/installedApps/TIPCell/isc.ear/isclite.war/secure/isclite/scripts/SMUtils.js"
					)
					if exist "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\tipregistry.txt" (
						set /p oldv= < "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\tipregistry.txt"
						call "!TIP_HOME!\profiles\TIPProfile\bin\tipRegister" 081F67AF608643DE937B00F6A41D9083 TUAM "!TUAM_HOME!" !oldv! product none false 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
						set status=!ERRORLEVEL!
						del /q "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\tipregistry.txt"
					) else (
						call "!TIP_HOME!\profiles\TIPProfile\bin\tipDeregister" 081F67AF608643DE937B00F6A41D9083 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
						set status=!ERRORLEVEL!
					)
				)
			) else (
				call manageIU.bat -o undo -r "!TUAM_HOME!" -p "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i\packagedIU.xml" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				set status=!ERRORLEVEL!
			)
			if not !status! == 0 (
				echo Undo failed
				exit /b 1
			) else (
				del /q /s "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i\*" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				rd "!TUAM_HOME!\_uninst\fixes\fp%fixpack%\%%i" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
			)
			set /a patched+=1
		)
	)
)

popd
if %patched% == 0 (
   echo TUAM Release %base%.%fixpack% must be installed to remove this fix pack.
   echo Please install this version before attempting to remove this fix pack.
   echo Fix has not been unapplied successfully.
   exit /b 1
)

endlocal

